//
//    ConstDef.cpp
//

#include "wx/wx.h"
#include "incident.h"
#include "resource.h"
#include "KidsCindyCanvas.h"
#include "KidsCindyFrame.h"
#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif

void MyCanvas::ConstDefLine()
{
	if(NOhilightedPoints>1 && hilightedPoints[0]!=hilightedPoints[1]){
		double g0x=hilightedPoints[0]->xz().real();
		double g0y=hilightedPoints[0]->yz().real();
		double g1x=hilightedPoints[1]->xz().real();
		double g1y=hilightedPoints[1]->yz().real();
		GLine* ln=NewLine(g0x,g0y,g1x,g1y);
		ClearAllHilights();
		Sethilighted(ln);
		ln->hilightphase=3;
		ln->_name=wxString((wxChar*)last_ln_name.c_str());
		next_name(last_ln_name);
		ln->clipping=false;
		GConst* cnp=NewConst(CONST_JOIN);
		cnp->LOutput=ln;
		cnp->PInput1=hilightedPoints[0];
		cnp->PInput2=hilightedPoints[1];
		WriteConst(cnp);
		AssignLine(ln);
		AssignIncident(ln,hilightedPoints[0],0.0);
		AssignIncident(ln,hilightedPoints[1],1.0);
		ResetLineIcPara(ln);
		if(!CheckCoincidency(ln)) {
			CheckIncidency(ln);
		}
		m_owner->enableToolbar();
		Refresh(false);
	}
}

void MyCanvas::ConstDefClippingLine()
{
	if(NOhilightedPoints>1 && hilightedPoints[0]!=hilightedPoints[1]){
		double g0x=hilightedPoints[0]->xz().real();
		double g0y=hilightedPoints[0]->yz().real();
		double g1x=hilightedPoints[1]->xz().real();
		double g1y=hilightedPoints[1]->yz().real();
		GLine* ln=NewLine(g0x,g0y,g1x,g1y);
		ClearAllHilights();
		Sethilighted(ln);
		ln->hilightphase=3;
		ln->_name=wxString((wxChar*)last_ln_name.c_str());
		next_name(last_ln_name);
		ln->clipping=true;
		GConst* cnp=NewConst(CONST_JOIN);
		cnp->LOutput=ln;
		cnp->PInput1=hilightedPoints[0];
		cnp->PInput2=hilightedPoints[1];
		WriteConst(cnp);
		AssignLine(ln);
		AssignIncident(ln,hilightedPoints[0],0.0);
		AssignIncident(ln,hilightedPoints[1],1.0);
		if(!CheckCoincidency(ln)) {
			CheckIncidency(ln);
		}
		m_owner->enableToolbar();
		Refresh(false);
	}
}

void MyCanvas::LineClippingon()
{
	for(int i=0;i<NOhilightedLines;i++){
		hilightedLines[i]->clipping=true;
	}
	Refresh(false);
}

void MyCanvas::ConstDefMeet()
{
	GConst* cnq;
	if(NOhilightedLines>=2){
		GLine *LI1 = hilightedLines[0];
		GLine *LI2 = hilightedLines[1];
		CComplex cx = LI1->yy * LI2->zz - LI1->zz * LI2->yy;
		CComplex cy = LI1->zz * LI2->xx - LI1->xx * LI2->zz;
		CComplex cz = LI1->xx * LI2->yy - LI1->yy * LI2->xx;
		if(cx==CComplex(0.0,0.0) && cy==CComplex(0.0,0.0) && cz==CComplex(0.0,0.0)){ 
			cx=CComplex(1.0,0.0);
			cz=LI1->xx * CComplex(-1.0,0.0);
		}
		if(!FindMeetFromCn(cns,LI1,LI2,&cnq)||LI1==LI2){
			return;
		}
		GConst* cnp=NewConst(CONST_MEET);
		GPoint *pt = NewPoint(cx,cy,cz);
		cnp->POutput=pt;
		cnp->LInput1=LI1;
		cnp->LInput2=LI2;
		WriteConst(cnp);
		ClearAllHilights();
		Sethilighted(pt);
		m_owner->enableToolbar();
		pt->_name=wxString((wxChar*)last_pt_name.c_str());
		next_name(last_pt_name);
		AssignPoint(pt);
		AssignIncident(LI1,pt);
		AssignIncident(LI2,pt);
		ResetLineIcPara(LI1);
		ResetLineIcPara(LI2);
		if(!CheckCoincidency(pt)){
			CheckIncidency(pt);
		}
		Refresh(false);
	}
	else if(NOhilightedLines==1 && NOhilightedCircles==1){
		GLine *LI = hilightedLines[0];
		GCircle *CI = hilightedCircles[0];
		GConst* cnp1=NewConst(CONST_MEET_CL);
		GPoint *pt1 = NewPoint(CComplex(0.0,0.0),CComplex(1.0,0.0),CComplex(1.0,0.0));
		cnp1->POutput=pt1;
		cnp1->LInput1=LI;
		cnp1->CInput1=CI;
		WriteConst(cnp1);
		GConst* cnp2=NewConst(CONST_MEET_CL);
		GPoint *pt2 = NewPoint(CComplex(0.0,0.0),CComplex(1.0,0.0),CComplex(1.0,0.0));
		cnp2->POutput=pt2;
		cnp2->LInput1=LI;
		cnp2->CInput1=CI;
		cnp2->PInput1=pt1;
		WriteConst(cnp2);
		EvaluateConst(cns);
		GPoint* pt1p;
		GPoint* pt2p;
		pt1p=FindPtFromPts(pts,pt1);
		pt2p=FindPtFromPts(pts,pt2);
		ClearAllHilights();
		if(pt1p==NULL){
			Sethilighted(pt1);
			pt1->_name=wxString((wxChar*)last_pt_name.c_str());
			next_name(last_pt_name);
			AssignIncident(LI,pt1);
			AssignIncident(CI,pt1);
			AssignPoint(pt1);
			CheckIncidency(pt1);
		}
		else{
			DeleteConst(cnp1);
			DeletePoint(pt1);
			cnp2->PInput1=pt1p;
		}
		if(pt2p==NULL){
			Sethilighted(pt2);
			pt2->_name=wxString((wxChar*)last_pt_name.c_str());
			next_name(last_pt_name);
			AssignPoint(pt2);
			AssignIncident(LI,pt2);
			AssignIncident(CI,pt2);
			CheckIncidency(pt2);
		}
		else{
			DeleteConst(cnp2);
			DeletePoint(pt2);
			cnp1->PInput1=pt2p;
		}
		ResetLineIcPara(LI);
		ResetCircleIcPara(CI);
		m_owner->enableToolbar();
		Refresh(false);
	}
	else if(NOhilightedCircles==2){
		GCircle *CI1 = hilightedCircles[0];
		GCircle *CI2 = hilightedCircles[1];
		GConst* cnp1=NewConst(CONST_MEET_CC);
		GPoint *pt1 = NewPoint(CComplex(0.0,0.0),CComplex(1.0,0.0),CComplex(1.0,0.0));
		cnp1->POutput=pt1;
		cnp1->CInput1=CI1;
		cnp1->CInput2=CI2;
		WriteConst(cnp1);
		GConst* cnp2=NewConst(CONST_MEET_CC);
		GPoint *pt2 = NewPoint(CComplex(0.0,0.0),CComplex(1.0,0.0),CComplex(1.0,0.0));
		cnp2->POutput=pt2;
		cnp2->CInput1=CI1;
		cnp2->CInput2=CI2;
		cnp2->PInput1=pt1;
		WriteConst(cnp2);
		EvaluateConst(cns);
		GPoint* pt1p;
		GPoint* pt2p;
		pt1p=FindPtFromPts(pts,pt1);
		pt2p=FindPtFromPts(pts,pt2);
		ClearAllHilights();
		if(pt1p==NULL){
			Sethilighted(pt1);
			pt1->_name=wxString((wxChar*)last_pt_name.c_str());
			next_name(last_pt_name);
			AssignPoint(pt1);
			AssignIncident(CI1,pt1);
			AssignIncident(CI2,pt1);
//			CheckIncidency(pt1);
		}
		else{
			DeleteConst(cnp1);
			DeletePoint(pt1);
			cnp2->PInput1=pt1p;
		}
		if(pt2p==NULL){
			Sethilighted(pt2);
			pt2->_name=wxString((wxChar*)last_pt_name.c_str());
			next_name(last_pt_name);
			AssignPoint(pt2);
			AssignIncident(CI1,pt2);
			AssignIncident(CI2,pt2);
//			CheckIncidency(pt2);
		}
		else{
			DeleteConst(cnp2);
			DeletePoint(pt2);
			cnp1->PInput1=pt2p;
		}
		ResetCircleIcPara(CI1);
		ResetCircleIcPara(CI2);
		m_owner->enableToolbar();
		Refresh(false);
	}
}

void MyCanvas::ConstDefPara()
{
	GPoint * PI=hilightedPoints[0];
	GLine  * LI=hilightedLines[0];
	double g0x=PI->xz().real();
	double g0y=PI->yz().real();
	GLine * ln=NewLine(g0x,g0y,g0x+0.01,g0y+0.01);
	AssignLine(ln);
	ln->hilightphase=3;
	ln->_name=wxString((wxChar*)last_ln_name.c_str());
	next_name(last_ln_name);
	GConst* cnp=NewConst(CONST_PARALLEL);
	cnp->LOutput=ln;
	cnp->PInput1=PI;
	cnp->LInput1=LI;
	WriteConst(cnp);
	EvaluateConst(cns);
	AssignIncident(ln,PI,0.0);
	ClearAllHilights();
	Sethilighted(ln);
	PI->hilighted=false;
	LI->hilighted=false;
	m_owner->enableToolbar();
	if(!CheckCoincidency(ln)) {
		CheckIncidency(ln);
	}
	Refresh(false);
}

void MyCanvas::ConstDefPerp()
{
	GPoint * PI=hilightedPoints[0];
	GLine  * LI=hilightedLines[0];
	double g0x=PI->xz().real();
	double g0y=PI->yz().real();
	GLine * ln=NewLine(g0x,g0y,g0x+0.01,g0y+0.01);
	AssignLine(ln);
	ln->hilightphase=3;
	ln->_name=wxString((wxChar*)last_ln_name.c_str());
	next_name(last_ln_name);
	GConst* cnp=NewConst(CONST_PERP);
	cnp->LOutput=ln;
	cnp->PInput1=PI;
	cnp->LInput1=LI;
	WriteConst(cnp);
	EvaluateConst(cns);
	AssignIncident(ln,PI,0.0);
	ClearAllHilights();
	Sethilighted(ln);
	PI->hilighted=false;
	LI->hilighted=false;
	m_owner->enableToolbar();
	if(!CheckCoincidency(ln)) {
		CheckIncidency(ln);
	}
	Refresh(false);
}

void MyCanvas::ConstDefMid()
{
	double g0x=hilightedPoints[0]->xz().real();
	double g0y=hilightedPoints[0]->yz().real();
	double g1x=hilightedPoints[1]->xz().real();
	double g1y=hilightedPoints[1]->yz().real();
	GPoint* pt=NewPoint(CComplex((g0x+g1x)*0.5,0.0),CComplex((g0y+g1y)*0.5,0.0));
	GConst* cnp=NewConst(CONST_MID);
	cnp->POutput=pt;
	cnp->PInput1=hilightedPoints[0];
	cnp->PInput2=hilightedPoints[1];
	WriteConst(cnp);
	AssignPoint(pt);
	pt->_name=wxString((wxChar*)last_pt_name.c_str());
	next_name(last_pt_name);
	ClearAllHilights();
	Sethilighted(pt);
	m_owner->enableToolbar();
	if(!CheckCoincidency(pt)) {
		CheckIncidency(pt);
	}
	Refresh(false);
}

GCircle* MyCanvas::ConstDefCircle()
{
	GConst*cnp;
	if(NOhilightedPoints==2){
		double g0x=hilightedPoints[0]->xz().real();
		double g0y=hilightedPoints[0]->yz().real();
		double g1x=hilightedPoints[1]->xz().real();
		double g1y=hilightedPoints[1]->yz().real();
		double radius=(g0x-g1x)*(g0x-g1x)+(g0y-g1y)*(g0y-g1y);
		GCircle* ci=NewCircle(g0x,g0y,radius);
		ClearAllHilights();
		Sethilighted(ci);
		ci->hilightphase=3;
		ci->_name=wxString((wxChar*)last_ci_name.c_str());
		next_name(last_ci_name);
		m_owner->enableToolbar();
		cnp=NewConst(CONST_MULTI_CIRCLE);
		cnp->COutput=ci;
		cnp->PInput1=hilightedPoints[0];
		cnp->PInput2=hilightedPoints[1];
		WriteConst(cnp);
		AssignCircle(ci);
		AssignIncident(ci,cnp->PInput2);
		if(!CheckCoincidency(ci)) {
			CheckIncidency(ci);
		}
		Refresh(false);
		return(ci);
	}
	else if(NOhilightedPoints==3){
		GPoint*ptp1,*ptp2;
		GCircle* ci;
		ptp1=hilightedPoints[0];
		ptp2=hilightedPoints[1];
		ci=ConstDefCompass();
		bool drawsegment=true;
		for(cnp=cns;cnp!=NULL&&drawsegment;cnp=cnp->next){
			if(cnp->Const_Type==CONST_JOIN&&cnp->PInput1==ptp1&&cnp->PInput2==ptp2){
				drawsegment=false;
			}
			else if(cnp->Const_Type==CONST_JOIN&&cnp->PInput1==ptp2&&cnp->PInput2==ptp1){
				drawsegment=false;
			}
		}
		if(drawsegment){
			NOhilightedPoints=2;
			hilightedPoints[0]=ptp1;
			hilightedPoints[1]=ptp2;
			ConstDefClippingLine();
			Sethilighted(ci);
		}
		return(ci);
	}
	else if(NOhilightedPoints==1 && NOhilightedLines==1){
		GPoint*ptp;
		GLine*lnp;
		GConst*cn1;
		GCircle* ci;
		ptp=hilightedPoints[0];
		lnp=hilightedLines[0];
		FindLnFromCn(cns,lnp,&cn1);
		if(cn1->Const_Type!=CONST_JOIN){
			return(NULL);
		}
		hilightedPoints[0]=cn1->PInput1;
		hilightedPoints[1]=cn1->PInput2;
		hilightedPoints[2]=ptp;
		ci=ConstDefCompass();
		return(ci);
	}
	return(NULL);
}

void MyCanvas::ConstDefBisector()
{
	GPoint * PI1=hilightedPoints[0];
	GPoint * PI2=hilightedPoints[1];
	GPoint * PI3=hilightedPoints[2];
	double g0x=PI2->xz().real();
	double g0y=PI2->yz().real();
	GLine * ln=NewLine(g0x,g0y,g0x+0.01,g0y+0.01);
	AssignLine(ln);
	ln->hilightphase=3;
	ln->_name=wxString((wxChar*)last_ln_name.c_str());
	next_name(last_ln_name);
	GConst* cnp=NewConst(CONST_3P_BISECTOR);
	cnp->LOutput=ln;
	cnp->PInput1=PI1;
	cnp->PInput2=PI2;
	cnp->PInput3=PI3;
	WriteConst(cnp);
	EvaluateConst(cns);
	AssignIncident(ln,PI2,0.0);
	ClearAllHilights();
	Sethilighted(ln);
	m_owner->enableToolbar();
	if(!CheckCoincidency(ln)) {
		CheckIncidency(ln);
	}
	Refresh(false);
}

void MyCanvas::ConstDefTangent()
{
	GPoint* pt=hilightedPoints[0];
	GCircle* ci=hilightedCircles[0];
	bool incident=false;
	for(GIncident* icp=ci->ics;icp!=NULL;icp=icp->_icnext){
		if(icp->_icpt==pt){
			incident=true;
		}
	}
	if(incident){
		GConst *cnp=NewConst(CONST_TANGENT);
		cnp->CInput1=ci;
		cnp->PInput1=pt;
		GLine* lncursor=NewLine(pt->xz().real(),pt->yz().real(),pt->xz().real()+0.01,pt->yz().real()+0.01);
		AssignLine(lncursor);
		cnp->LOutput=lncursor;
		lncursor->_name=wxString((wxChar*)last_ln_name.c_str());
		next_name(last_ln_name);
		WriteConst(cnp);
		EvaluateConst(cns);
		ClearAllHilights();
		Sethilighted(cnp->LOutput);
		m_owner->enableToolbar();
		if(!CheckCoincidency(lncursor)) {
			CheckIncidency(lncursor,false);
		}
		Refresh(false);
	}
}

void MyCanvas::ConstDefCircleBy3()
{
	GConst* cnp;
	cnp=NewConst(CONST_ORTHOCENTER);
	GPoint* ptp1=cnp->PInput1=hilightedPoints[0];
	GPoint* ptp2=cnp->PInput2=hilightedPoints[1];
	GPoint* ptp3=cnp->PInput3=hilightedPoints[2];
	CComplex px1=hilightedPoints[0]->xz();
	CComplex py1=hilightedPoints[0]->yz();
	CComplex px2=hilightedPoints[1]->xz();
	CComplex py2=hilightedPoints[1]->yz();
	CComplex px3=hilightedPoints[2]->xz();
	CComplex py3=hilightedPoints[2]->yz();
	GPoint* ptp = NewPoint(
		(px2*px2-px1*px1+py2*py2-py1*py1)*(py3-py1)-(px3*px3-px1*px1+py3*py3-py1*py1)*(py2-py1) ,
		(px3*px3-px1*px1+py3*py3-py1*py1)*(px2-px1)-(px2*px2-px1*px1+py2*py2-py1*py1)*(px3-px1) ,
		CComplex(2.0,0.0)*((px2-px1)*(py3-py1)-(px3-px1)*(py2-py1)) );
	AssignPoint(ptp);
	cnp->POutput=ptp;
	SetPointName(ptp);
	cnp->POutput->invisible=false;
	cnp->POutput->ptbmp=0;
	WriteConst(cnp);
	ClearAllHilights();
	Sethilighted(cnp->POutput);
	cnp=NewConst(CONST_MULTI_CIRCLE);
	cnp->PInput1=ptp;
	cnp->PInput2=hilightedPoints[2];
	double g0x=cnp->PInput1->xz().real();
	double g0y=cnp->PInput1->yz().real();
	double g1x=cnp->PInput2->xz().real();
	double g1y=cnp->PInput2->yz().real();
	double radius=(g0x-g1x)*(g0x-g1x)+(g0y-g1y)*(g0y-g1y);
	GCircle* cip=NewCircle(g0x,g0y,radius);
	AssignCircle(cip);
	cnp->COutput=cip;
	cnp->COutput->invisible=false;
	cnp->COutput->lndsn=0;
	cip->_name=wxString((wxChar*)last_ci_name.c_str());
	next_name(last_ci_name);
	WriteConst(cnp);
	Sethilighted(cnp->COutput);
	EvaluateConst(cns);
	m_owner->enableToolbar();
	AssignIncident(cip,ptp1);
	AssignIncident(cip,ptp2);
	AssignIncident(cip,ptp3);
	ResetCircleIcPara(cip);
	if(!CheckCoincidency(cip)) {
		CheckIncidency(cip);
	}
	Refresh(false);
}

void MyCanvas::ConstDefOrbit(){
	GConst *cnp;
	GConst *cnq=NULL;
	GConst *cnr;
	FindCnFromPt(cns,hilightedPoints[0],&cnp);
	FindCnFromPt(cns,hilightedPoints[1],&cnr);
	if(cnp->Const_Type==CONST_PT_ON_CIRCLE){
		cnq=NewConst(CONST_ORBIT1);
	}
	else if(cnp->Const_Type==CONST_ON_LINE || cnp->Const_Type==CONST_PT_ON_PARA 
		|| cnp->Const_Type==CONST_PT_ON_PERP || cnp->Const_Type==CONST_PT_ON_TANGENT 
		|| cnp->Const_Type==CONST_PT_ON_CURVE_TANGENT || cnp->Const_Type==CONST_PT_ON_BISECTOR
		|| cnp->Const_Type==CONST_PT_ON_LINE_WITH_ANGLE || cnp->Const_Type==CONST_PT_ON_LINE_WITH_ANGLE_DEGREE){
		cnq=NewConst(CONST_ORBIT2);
	}
	cnq->PInput1=hilightedPoints[0];
	cnq->PInput2=hilightedPoints[1];
	cnq->ConstInput1=cnp;
	cnq->ConstInput2=cnr;
	GParaCurve* curvep=NewCurve();
	AssignCurve(curvep);
	cnq->CurveOutput=curvep;
	curvep->_name=wxString((wxChar*)last_curve_name.c_str());
	next_name(last_curve_name);
	WriteConst(cnq);
	ClearAllHilights();
	Sethilighted(cnq->CurveOutput);
	EvaluateConst(cns);
	Refresh(false);
}

GCircle* MyCanvas::ConstDefCompass()
{
	GConst *cnp=NewConst(CONST_COMPASS);
	cnp->PInput1=hilightedPoints[0];
	cnp->PInput2=hilightedPoints[1];
	cnp->PInput3=hilightedPoints[2];
	GCircle* cicursor=NewCircle(0.0,0.0,1.0);
	AssignCircle(cicursor);
	cnp->COutput=cicursor;
	cicursor->_name=wxString((wxChar*)last_ci_name.c_str());
	next_name(last_ci_name);
	WriteConst(cnp);
	ClearAllHilights();
	Sethilighted(cnp->COutput);
	EvaluateConst(cns);
	if(!CheckCoincidency(cicursor)) {
		CheckIncidency(cicursor);
	}
	Refresh(false);
	return(cicursor);
}

void MyCanvas::ConstDefCurveTangent()
{
	GPoint* pt=hilightedPoints[0];
	GParaCurve* cu=hilightedCurves[0];
	GConst *cnp=NewConst(CONST_CURVE_TANGENT);
	GConst *cnq;
	cnp->CurveInput1=cu;
	cnp->PInput1=pt;
	FindPtFromCn(cns,pt,&cnq);
	cnp->ConstInput1=cnq;
	GLine* lnp=NewLine(pt->xz().real(),pt->yz().real(),pt->xz().real()+0.01,pt->yz().real()+0.01);
	AssignLine(lnp);
	cnp->LOutput=lnp;
	lnp->_name=wxString((wxChar*)last_ln_name.c_str());
	next_name(last_ln_name);
	WriteConst(cnp);
	EvaluateConst(cns);
	ClearAllHilights();
	Sethilighted(cnp->LOutput);
	m_owner->enableToolbar();
	if(!CheckCoincidency(lnp)) {
		CheckIncidency(lnp,false);
	}
	Refresh(false);
}

void MyCanvas::ConstDefAngle()
{
	if(NOhilightedPoints>=3 && hilightedPoints[0]!=hilightedPoints[1] && hilightedPoints[1]!=hilightedPoints[2] && hilightedPoints[2]!=hilightedPoints[0]){
		//  define angle
		GConst *cnp=NewConst(CONST_3P_ANGLE);
		cnp->PInput1=hilightedPoints[0];
		cnp->PInput2=hilightedPoints[1];
		cnp->PInput3=hilightedPoints[2];
		GAngle* agp=NewAngle(0.0);
		AssignAngle(agp);
		cnp->AngleOutput=agp;
		agp->_name=wxString((wxChar*)last_ag_name.c_str());
		next_name(last_ag_name);
		WriteConst(cnp);
		EvaluateConst(cns);
		ClearAllHilights();
		Sethilighted(agp);
//		m_owner->enableToolbar();
		Refresh(false);
	}
}

void MyCanvas::ConstDefBracket()
{
	if(NOhilightedPoints>=2 && hilightedPoints[0]!=hilightedPoints[1]){
		//  define bracket
		GConst *cnp=NewConst(CONST_BRACKET);
		cnp->PInput1=hilightedPoints[0];
		cnp->PInput2=hilightedPoints[1];
		GBracket* brp=NewBracket(hilightedPoints[0],hilightedPoints[1]);
		AssignBracket(brp);
		cnp->BracketOutput=brp;
		SetBracketName(brp);
		WriteConst(cnp);
		EvaluateConst(cns);
		ClearAllHilights();
		Sethilighted(brp);
		m_owner->enableToolbar();
		Refresh(false);
	}
}



#include "wx/dialog.h"
#include "wx/textctrl.h"
#include "wx/button.h"
#include "wx/radiobut.h"

#include "AngleDialog.h"

BEGIN_EVENT_TABLE(AngleDialog, wxDialog)
END_EVENT_TABLE()

AngleDialog::AngleDialog(MyFrame*parent) 
:wxDialog(parent,wxID_ANY,MenuEditSourceTitle,wxPoint(50,50),wxSize(200,200),wxDEFAULT_DIALOG_STYLE,wxT(""))
{
	int x=15,y=15;
	int sx=40,sy=25;
	granpa = parent->m_canvas;
	new wxStaticText(this,wxID_ANY,AngleText1,wxPoint(x,y));

	y += sy;
	RB1 = new wxRadioButton(this,ID_ANGLE_BY_POINTS,AngleRButton1,wxPoint(x,y));

	y += sy;
	new wxStaticText(this,wxID_ANY,AngleText2,wxPoint(x+20,y),wxSize(sx-23,sy-3));
	txt1 = new wxTextCtrl(this,ID_ANGLE_BY_POINTS1,wxT(""),wxPoint(x+sx,y-2),wxSize(sx-3,sy-3));
	txt2 = new wxTextCtrl(this,ID_ANGLE_BY_POINTS2,wxT(""),wxPoint(x+2*sx,y-2),wxSize(sx-3,sy-3));
	txt3 = new wxTextCtrl(this,ID_ANGLE_BY_POINTS3,wxT(""),wxPoint(x+3*sx,y-2),wxSize(sx-3,sy-3));

	y += sy;
	RB2 = new wxRadioButton(this,ID_ANGLE_BY_VALUE,AngleRButton2,wxPoint(x,y));

	y +=sy;
	txt4 = new wxTextCtrl(this,ID_ANGLE_BY_VALUE1,wxT(""),wxPoint(x,y-2),wxSize(sx-3,sy-3));
	new wxStaticText(this,wxID_ANY,AngleText3,wxPoint(x+sx,y),wxSize(sx-3,sy-3));

	y +=sy;
	B1 = new wxButton(this,wxID_OK,AngleButtonOk,wxPoint(x,y),wxSize(2*sx-5,sy-3),0, wxDefaultValidator, wxT("button"));
	B2 = new wxButton(this,wxID_CANCEL,AngleButtonCancel,wxPoint(x+2*sx,y),wxSize(2*sx-5,sy-3),0, wxDefaultValidator, wxT("button"));

}


void MyCanvas::ConstDefLineWithAngle()
{
	wxString str0,str1;
	bool exists;
	GConst* cnp1,*cnp2,*cnp3,*cnp;
	char buff[256];
	if(NOhilightedPoints>0 && NOhilightedLines>0){
		if(NOhilightedAngles>0){
			cursorag=hilightedAngles[0];
		}
		else {
			//Open dialog for angle value;
			AngleDialog myd(m_owner);
			if(myd.ShowModal()==wxID_OK){
				if(myd.RB1->GetValue()){
					str0 = myd.txt1->GetValue();
					sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
					str1 =wxString((wxChar*)buff);
					FindNameFromCns(cns,str1,&cnp1);
					str0 = myd.txt2->GetValue();
					sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
					str1 =wxString((wxChar*)buff);
					FindNameFromCns(cns,str1,&cnp2);
					str0 = myd.txt3->GetValue();
					sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
					str1 =wxString((wxChar*)buff);
					FindNameFromCns(cns,str1,&cnp3);
					if(cnp1->POutput==NULL || cnp2->POutput==NULL || cnp3->POutput==NULL){
						return;
					}
					exists=false;
					for(cnp=cns;!exists && cnp!=NULL;cnp=cnp->next){
						// if there is an angle with these points then cursorag = the angle
						//we need much more precise casework
						if(cnp->Const_Type==CONST_3P_ANGLE && cnp->PInput1==cnp1->POutput && cnp->PInput2==cnp2->POutput && cnp->PInput3==cnp3->POutput){
							cursorag=cnp->AngleOutput;
							exists=true;
						}
						else if(cnp->Const_Type==CONST_3P_ANGLE && cnp->PInput1==cnp3->POutput && cnp->PInput2==cnp2->POutput && cnp->PInput3==cnp1->POutput){
							cursorag=cnp->AngleOutput;
							exists=true;
						}
					}
					if(!exists){
					// else cursorag= new angle with the three points.
						//printf("Debug:ConstDefLineWithAngle\n");
						//printf("angle %s%s%s\n",cnp1->POutput->_name.c_str(),cnp2->POutput->_name.c_str(),cnp3->POutput->_name.c_str());
						cnp=NewConst(CONST_3P_ANGLE);
						cnp->PInput1=cnp1->POutput;
						cnp->PInput2=cnp2->POutput;
						cnp->PInput3=cnp3->POutput;
						cursorag=NewAngle(0.0);
						AssignAngle(cursorag);
						cnp->AngleOutput=cursorag;
						cursorag->_name=wxString((wxChar*)last_ag_name.c_str());
						next_name(last_ag_name);
						WriteConst(cnp);
						EvaluateConst(cns);
						ClearAllHilights();
						Sethilighted(cursorag);
						m_owner->enableToolbar();
					}
				}
				else {
					cursorag=NULL;
					str0 = myd.txt4->GetValue();
					sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
					str1 =wxString((wxChar*)buff);
					if(!str1.ToDouble(&angle_value)){ angle_value=60.0; }
				}
			}
		}
		if(cursorag!=NULL){
			GPoint * PI=hilightedPoints[0];
			GLine  * LI=hilightedLines[0];
			double g0x=PI->xz().real();
			double g0y=PI->yz().real();
			// make a new line
			GLine * ln=NewLine(g0x,g0y,g0x+0.01,g0y+0.01);
			AssignLine(ln);
			ln->hilightphase=3;
			ln->_name=wxString((wxChar*)last_ln_name.c_str());
			next_name(last_ln_name);
			//make a new const
			cnp=NewConst(CONST_LINE_WITH_ANGLE);
			cnp->LOutput=ln;
			cnp->PInput1=PI;
			cnp->LInput1=LI;
			cnp->AngleInput1=cursorag;
			WriteConst(cnp);
			EvaluateConst(cns);
			AssignIncident(ln,PI,0.0);
			ClearAllHilights();
			Sethilighted(ln);
			PI->hilighted=false;
			LI->hilighted=false;
			m_owner->enableToolbar();
			// check concidency,indidency
			if(!CheckCoincidency(ln)) {
				CheckIncidency(ln);
			}
			Refresh(false);
		}
		else {
			GPoint * PI=hilightedPoints[0];
			GLine  * LI=hilightedLines[0];
			double g0x=PI->xz().real();
			double g0y=PI->yz().real();
			// make a new line
			GLine * ln=NewLine(g0x,g0y,g0x+0.01,g0y+0.01);
			AssignLine(ln);
			ln->hilightphase=3;
			ln->_name=wxString((wxChar*)last_ln_name.c_str());
			next_name(last_ln_name);
			//make a new const
			cnp=NewConst(CONST_LINE_WITH_ANGLE_DEGREE);
			cnp->LOutput=ln;
			cnp->PInput1=PI;
			cnp->LInput1=LI;
			cnp->para1=CComplex(angle_value,0.0);
			WriteConst(cnp);
			EvaluateConst(cns);
			AssignIncident(ln,PI,0.0);
			ClearAllHilights();
			Sethilighted(ln);
			PI->hilighted=false;
			LI->hilighted=false;
			m_owner->enableToolbar();
			// check concidency,indidency
			if(!CheckCoincidency(ln)) {
				CheckIncidency(ln);
			}
			Refresh(false);
		}
	}

}


void MyCanvas::ClearAllHilights()
{
	if(pts!=NULL)pts->ClearHilight();
	if(lns!=NULL)lns->ClearHilight();
	if(cis!=NULL)cis->ClearHilight();
	if(curves!=NULL)curves->ClearHilight();
	if(texts!=NULL)	texts->ClearHilight();
	if(ags!=NULL) ags->ClearHilight();
	if(ims!=NULL) ims->ClearHilight();
	if(brs!=NULL) brs->ClearHilight();
	NOhilightedLines=0;
	NOhilightedPoints=0;
	NOhilightedCircles=0;
	NOhilightedCurves=0;
	NOhilightedTexts=0;
	NOhilightedAngles=0;
	NOhilightedImages=0;
	NOhilightedBrackets=0;
}
