//
//   Draw.cpp
//
#include <math.h>
#include "wx/wx.h"
#include "wx/region.h"
#include "wx/dc.h"
#include "KidsCindyFrame.h"
#include "KidsCindyCanvas.h"
#include "resource.h"
#include "wx/fontenum.h"
#include "wx/fontmap.h"
#include "wx/encconv.h"
#include "incident.h"

wxBitmap		*gs_bmpScreen;
wxBitmap		*gs_bmpBackGround;


	#include "ball_h0.xpm"		// ball_h0_xpm
	#include "ball_r0.xpm"		// ball_r0_xpm
	#include "ball_h1.xpm"		// ball_h1_xpm
	#include "ball_r1.xpm"		// ball_r1_xpm
	#include "ball_h2.xpm"		// ball_h2_xpm
	#include "ball_r2.xpm"		// ball_r2_xpm
	#include "ball_h3.xpm"		// ball_h3_xpm
	#include "ball_r3.xpm"		// ball_r3_xpm
	#include "ball_h4.xpm"		// ball_h4_xpm
	#include "ball_r4.xpm"		// ball_r4_xpm

	#include "cat_h0.xpm"		// cat_h0_xpm
	#include "cat_r0.xpm"		// cat_r0_xpm
	#include "cat_h1.xpm"		// cat_h1_xpm
	#include "cat_r1.xpm"		// cat_r1_xpm
	#include "cat_h2.xpm"		// cat_h2_xpm
	#include "cat_r2.xpm"		// cat_r2_xpm
	#include "cat_h3.xpm"		// cat_h3_xpm
	#include "cat_r3.xpm"		// cat_r3_xpm
	#include "cat_h4.xpm"		// cat_h4_xpm
	#include "cat_r4.xpm"		// cat_r4_xpm

	#include "star_h0.xpm"		// star_h0_xpm
	#include "star_r0.xpm"		// star_r0_xpm
	#include "star_h1.xpm"		// star_h0_xpm
	#include "star_r1.xpm"		// star_r0_xpm
	#include "star_h2.xpm"		// star_h0_xpm
	#include "star_r2.xpm"		// star_r0_xpm
	#include "star_h3.xpm"		// star_h0_xpm
	#include "star_r3.xpm"		// star_r0_xpm
	#include "star_h4.xpm"		// star_h0_xpm
	#include "star_r4.xpm"		// star_r0_xpm

	#include "skeleton.xpm"				// skeleton_xpm
	#include "skeleton_mask.xpm"		// skeleton_mask_xpm
	#include "skeleton_r.xpm"			// skeleton_r_xpm
	#include "skeleton_rmask.xpm"		// skeleton_rmask_xpm
	#include "BkCat.xpm"		// bkcat_xpm
	#include "BkCINDY.xpm"		// bkcindy_xpm
	#include "BkKSEG.xpm"		// bkkseg_xpm
	#include "BkPASTEL.xpm"		// bkpastel_xpm
	#include "BkStandard0.xpm"	// bkstandard0_xpm
	#include "BkStandard1.xpm"	// bkstandard0_xpm
	#include "BkStandard2.xpm"	// bkstandard0_xpm
	#include "BkStar.xpm"		// bkstar_xpm
	#include "BkSkeleton.xpm"		// bkskeleton_xpm


double abs(double a)
{
	return (a>0)? a:-a;
}


void MyCanvas::OnPaint(wxPaintEvent &WXUNUSED(event))
{
	wxPaintDC dc(this);
	PrepareDC(dc);
	m_owner->PrepareDC(dc);
	g_memdc.SelectObject(*gs_bmpScreen);
	g_memBGdc.SelectObject(*gs_bmpBackGround);
	if(!BGbmp){
		DrawBackGround(&g_memBGdc);
		BGbmp=true;
	}
	g_memdc.Blit(0,0,windowwidth,windowheight,&g_memBGdc,0,0);
	OnDraw(&g_memdc);
	dc.Blit(0,0,windowwidth,windowheight,&g_memdc,0,0);
	redraw=false;
}


bool InitScreenBmp()
{
	gs_bmpScreen = new wxBitmap(1600,900);
	gs_bmpBackGround = new wxBitmap(1600,900);


	return true;
}
void MyCanvas::OnDraw(wxMemoryDC* pDC)
{
	// nonsense dummy drawing
	pDC->SetPen(wxPen(wxColour(255,255,255),1,wxSOLID));
	pDC->DrawLine(0,0,0,1);
	// draw axis
	if(AxisOn){
		DrawAxis(pDC);
	}
	//  draw clones
	if(DocMode==MODE_MOVE && CloneOnOff && m_move_dragging){
		DrawLines(lns3,pDC);
		DrawLines(lns2,pDC);
		DrawLines(lns1,pDC);
		DrawCircles(cis3,pDC); 
		DrawCircles(cis2,pDC); 
		DrawCircles(cis1,pDC); 
		DrawPoints(pts3,pDC); 
		DrawPoints(pts2,pDC); 
		DrawPoints(pts1,pDC); 
	}
	
	if(DocMode==MODE_COMPASS){
		DrawCompassCircle(pDC);
	}
	if(SMode && !anim_wait){
		Animnext();
	}
	DrawImages(ims,pDC); //  draw images
	DrawAngles(ags,pDC);//  draw angles
	DrawLines(lns,pDC);//  draw lines
	DrawCircles(cis,pDC); //  draw circles
	DrawCurves(curves,pDC); //  draw curves
	DrawBrackets(brs,pDC);//  draw brackets
	DrawPoints(pts,pDC); //  draw points
	DrawTexts(texts,pDC); //  draw texts

	//  while draggin, draw the current point
	if(m_point_dragging){
		switch(DocMode){
		case MODE_SINGLE_ADD:
			DrawOnePoint(cursorpt,pDC);
			break;
		case MODE_MULTI_LINE:
		case MODE_PARALLEL:
		case MODE_PERP:
		case MODE_LINE_WITH_ANGLE:
			DrawOnePoint(cursorpt,pDC);
			DrawOneLine(cursorln,pDC);
			break;
		case MODE_MID:
			DrawOnePoint(cursorpt,pDC);
			DrawOnePoint(cursorpt2,pDC);
			break;
		case MODE_MULTI_CIRCLE:
			DrawOnePoint(cursorpt,pDC);
			DrawOneCircle(cursorci,pDC);
			break;
		case MODE_BRACKET:
			DrawOnePoint(cursorpt,pDC);
			DrawOneBracket(cursorbr,pDC);
		}
	}
	if(GMode==MODE_PANEL){
		DrawPanelButton(pDC);
	}
	wxString str;
	str.Printf( wxT("Sheet: %d/%d"), currentSheet+1,NOMySheet );
	m_owner->SetStatusText( str );

}

void MyCanvas::DrawBackGround(wxMemoryDC *pDC)
{
	int i,j,col,row;
	pDC->SelectObject(*gs_bmpBackGround);
	row=(windowwidth/(m_appear._MyBG._width))+1;
	col=(windowheight/(m_appear._MyBG._height))+1;
	for(i=0;i<row;i++)for(j=0;j<col;j++){
		pDC->DrawBitmap(*(m_appear._MyBG._bitmap),i*(m_appear._MyBG._width),j*(m_appear._MyBG._height),false);
	}
}

void MyCanvas::DrawAxis(wxMemoryDC *pDC)
{
	double dispx0,dispy0,dispx1,dispy1;
	double i;
	if(boxleft<0.0 && boxright>0.0){
		pDC->SetPen(AxisPen);
		dispx0=(0.0-geomcx)/geomperdot+centerx;
		dispy0=-(boxtop-geomcy)/geomperdot+centery;
		dispx1=(0.0-geomcx)/geomperdot+centerx;
		dispy1=-(boxbottom-geomcy)/geomperdot+centery;
		pDC->DrawLine((int)floor(dispx0),(int)floor(dispy0),(int)floor(dispx1),(int)floor(dispy1));
		pDC->SetPen(AxisMeshPen);
		for(i=floor(boxbottom)+1.0;i<floor(boxtop)+1.0;i+=1.0){
			dispx0=(-0.05-geomcx)/geomperdot+centerx;
			dispy0=-(i-geomcy)/geomperdot+centery;
			dispx1=(+0.05-geomcx)/geomperdot+centerx;
			dispy1=-(i-geomcy)/geomperdot+centery;
			pDC->DrawLine((int)floor(dispx0),(int)floor(dispy0),(int)floor(dispx1),(int)floor(dispy1));
		}
	}
	if(boxtop>0.0 && boxbottom<0.0){
		pDC->SetPen(AxisPen);
		dispx0=(boxleft-geomcx)/geomperdot+centerx;
		dispy0=-(0.0-geomcy)/geomperdot+centery;
		dispx1=(boxright-geomcx)/geomperdot+centerx;
		dispy1=-(0.0-geomcy)/geomperdot+centery;
		pDC->DrawLine((int)floor(dispx0),(int)floor(dispy0),(int)floor(dispx1),(int)floor(dispy1));
		pDC->SetPen(AxisMeshPen);
		for(i=floor(boxleft)+1.0;i<floor(boxright)+1.0;i+=1.0){
			dispx0=(i-geomcx)/geomperdot+centerx;
			dispy0=-(-0.05-geomcy)/geomperdot+centery;
			dispx1=(i-geomcx)/geomperdot+centerx;
			dispy1=-(+0.05-geomcy)/geomperdot+centery;
			pDC->DrawLine((int)floor(dispx0),(int)floor(dispy0),(int)floor(dispx1),(int)floor(dispy1));
		}
	}
}

bool MyCanvas::DrawOnePoint(GPoint* pt,wxMemoryDC* pDC)
{
	if(pt==0){
		return false;
	}

	if(pt->zz.zerop()){
		return false;
	}
	if(!pt->xz().realp() || !pt->yz().realp() || pt->invisible){
		return false;
	}
	double geomx=pt->xz().real();
	double geomy=pt->yz().real();
	int dispx=centerx+(int)floor((geomx-geomcx)/geomperdot)+pt->offsetx;
	int dispy=centery-(int)floor((geomy-geomcy)/geomperdot)+pt->offsety;
	int r_bmpsize=0,r_bmphsize=0;
	int h_bmpsize=0,h_bmphsize=0;
	wxBitmap *mybmp_r=NULL,*mybmp_h=NULL;
	PtBmp* myptbmp=NULL;
	unsigned char r,g,b;
	myptbmp=&(m_appear._MyP[pt->ptbmp]);
	if(myptbmp->_BmpOn){
		mybmp_r=myptbmp->_regular;
		mybmp_h=myptbmp->_hilighted;
		r_bmpsize=mybmp_r->GetHeight();r_bmphsize=r_bmpsize/2;
		h_bmpsize=mybmp_h->GetHeight();h_bmphsize=h_bmpsize/2;
		pt->phase_max=mybmp_h->GetWidth()/mybmp_h->GetHeight();
		if(pt->hilighted){
			if(pt->hilightphase < pt->phase_max){
				pDC->DrawBitmap(mybmp_h->GetSubBitmap(wxRect(h_bmpsize* pt->hilightphase,0,h_bmpsize,h_bmpsize)),dispx-h_bmphsize,dispy-h_bmphsize,true);
			}
			pt->hilightphase ++;
			if(pt->hilightphase >= pt->phase_max){
				pt->hilightphase=0;
			}
		}
		else if(pt->expand>1.0){
			pDC->DrawBitmap(mybmp_h->GetSubBitmap(wxRect(h_bmpsize*((int)floor((pt->expand-1.0)/0.2)),0,h_bmpsize,h_bmpsize)),dispx-h_bmphsize,dispy-h_bmphsize,true);
		}
		else if(pt->vanishing<4){
			pDC->DrawBitmap(mybmp_r->GetSubBitmap(wxRect(r_bmpsize* pt->vanishing,0,r_bmpsize,r_bmpsize)),dispx-r_bmphsize,dispy-r_bmphsize,true);
		}
	}
	else {
		if(pt->hilighted){
			pDC->SetBrush(wxBrush(wxColour(myptbmp->_HilColR,myptbmp->_HilColG,myptbmp->_HilColB),wxSOLID));
			pDC->SetPen(wxPen(wxColour(myptbmp->_HilColR,myptbmp->_HilColG,myptbmp->_HilColB),1,wxSOLID));
			pDC->DrawCircle(dispx,dispy,myptbmp->_HilRad);
			pDC->SetBrush(wxBrush(wxColour(myptbmp->_OutColR,myptbmp->_OutColG,myptbmp->_OutColB),wxSOLID));
			pDC->SetPen(wxPen(wxColour(myptbmp->_OutColR,myptbmp->_OutColG,myptbmp->_OutColB),1,wxSOLID));
			pDC->DrawCircle(dispx,dispy,myptbmp->_OutRad);
			pDC->SetBrush(wxBrush(wxColour(myptbmp->_InColR,myptbmp->_InColG,myptbmp->_InColB),wxSOLID));
			pDC->SetPen(wxPen(wxColour(myptbmp->_InColR,myptbmp->_InColG,myptbmp->_InColB),1,wxSOLID));
			pDC->DrawCircle(dispx,dispy,myptbmp->_InRad);
		}
		else if(pt->vanishing<4){
			int BgR= m_appear._MyBG._BgR;
			int BgG= m_appear._MyBG._BgG;
			int BgB= m_appear._MyBG._BgB;
			r=myptbmp->_OutColR+pt->vanishing*(BgR-myptbmp->_OutColR)/4;
			g=myptbmp->_OutColG+pt->vanishing*(BgG-myptbmp->_OutColG)/4;
			b=myptbmp->_OutColB+pt->vanishing*(BgB-myptbmp->_OutColB)/4;
			pDC->SetBrush(wxBrush(wxColour(r,g,b),wxSOLID));
			pDC->SetPen(wxPen(wxColour(r,g,b),1,wxSOLID));
			pDC->DrawCircle(dispx,dispy,(int)floor(myptbmp->_OutRad*pt->expand));
			r=myptbmp->_InColR+pt->vanishing*(BgR-myptbmp->_InColR)/4;
			g=myptbmp->_InColG+pt->vanishing*(BgG-myptbmp->_InColG)/4;
			b=myptbmp->_InColB+pt->vanishing*(BgB-myptbmp->_InColB)/4;
			pDC->SetBrush(wxBrush(wxColour(r,g,b),wxSOLID));
			pDC->SetPen(wxPen(wxColour(r,g,b),1,wxSOLID));
			pDC->DrawCircle(dispx,dispy,(int)floor(myptbmp->_InRad*pt->expand));
		}
	}
	pDC->SetFont(wxFont(pt->_fontsize, wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, false, wxT(""),  wxFONTENCODING_DEFAULT));
	if(pt->vanishing<4){
		wxString str((char*)pt->_name.c_str(),*wxConvCurrent);
		pDC->SetTextForeground(wxColour(PTextColR,PTextColG,PTextColB));
		pDC->DrawText(str,dispx+(int)floor((10+pt->_fontsize)*cos(pt->_name_theta))-(pt->_fontsize/2),
			dispy-(int)floor((10+pt->_fontsize)*sin(pt->_name_theta))-(pt->_fontsize));
	}
	return false;
}

bool MyCanvas::DrawPoints(GConst* cnp,wxMemoryDC* pDC)
{
	if(cnp==0){
		return true;
	}
	if(cnp->Output_Type()==OUTPUT_POINT){
		DrawOnePoint(cnp->POutput,pDC);
	}
	if(cnp->next!=0){
		DrawPoints(cnp->next,pDC);
	}
	return false;
}

bool MyCanvas::DrawPoints(GPoint* p,wxMemoryDC* pDC)
{
	if(p==0){
		return true;
	}
	DrawOnePoint(p,pDC);
	if(p->next!=0){
		DrawPoints(p->next,pDC);
	}
	return false;
}

int min(int a,int b)
{
	if(a<b) return a;
	else return b;
}

double min(double a,double b);

void FindLineends(GIncident* ic,GIncident**mn,GIncident**mx)
{
	if(ic==NULL){
		return;
	}
	if(*mn!=NULL && (*mn)->_icpara.imag()==0.0 && (*mn)->_icpara.real()>ic->_icpara.real()){
		*mn=ic;
	}
	else if(*mn==NULL){
		*mn=ic;
	}
	if(*mx!=NULL && (*mn)->_icpara.imag()==0.0 && (*mx)->_icpara.real() < ic->_icpara.real()){
		*mx=ic;
	}
	else if(*mx==NULL){
		*mx=ic;
	}
	FindLineends(ic->_icnext,mn,mx);
}

bool MyCanvas::GetGeomXY(GLine* p, double* dx0, double* dy0, double* dx1, double* dy1)
{	
	double rx,ry,rz;
	if(p->realp(&rx,&ry,&rz)==false || p->invisible){
		return false;
	}
	double geomx[2],geomy[2];
	GIncident* mn,*mx;
	int geomcount=0;
	double tt;
	if(ry!=0.0){
		tt=-(rz+rx*boxleft)/ry;
		if(tt<boxtop  && tt>boxbottom){
			geomx[geomcount]=boxleft;
			geomy[geomcount]=tt;
			geomcount++;
		}
	}
	if(ry!=0.0){
		tt=-(rz+rx*boxright)/ry;
		if(tt<boxtop  && tt>boxbottom){
			geomx[geomcount]=boxright;
			geomy[geomcount]=tt;
			geomcount++;
		}
	}
	if(rx!=0.0){
		tt=-(rz+ry*boxtop)/rx;
		if(tt>boxleft && tt<boxright){
			geomx[geomcount]=tt;
			geomy[geomcount]=boxtop;
			geomcount++;
		}
	}
	if(rx!=0.0){
		tt=-(rz+ry*boxbottom)/rx;
		if(tt>boxleft && tt<boxright){
			geomx[geomcount]=tt;
			geomy[geomcount]=boxbottom;
			geomcount++;
		}
	}
	if(geomcount<2){
		return false;
	}
	double geomx1=0,geomy1=0,geomx2=0,geomy2=0;
	if(p->clipping && p->NOics<0){
		geomx1=p->afterimage_x1;
		geomy1=p->afterimage_y1;
		geomx2=p->afterimage_x2;
		geomy2=p->afterimage_y2;
	}
	else if(p->clipping && p->NOics>=2){
		double hx1,hy1,hx2,hy2;
		double tt1,tt2;
		mn=mx=NULL;
		ResetLineIcPara(p);
		FindLineends(p->ics,&mn,&mx);
		if(mn==mx){
			geomx1=geomx[0];
			geomy1=geomy[0];
			geomx2=geomx[1];
			geomy2=geomy[1];
		}
		else {
			hx1=mn->_icpt->xz().real();
			hy1=mn->_icpt->yz().real();
			hx2=mx->_icpt->xz().real();
			hy2=mx->_icpt->yz().real();
			if(hx1!=hx2){
				tt1=(geomx[0]-hx1)/(hx2-hx1);
				tt2=(geomx[1]-hx1)/(hx2-hx1);
			}
			else {
				tt1=(geomy[0]-hy1)/(hy2-hy1);
				tt2=(geomy[1]-hy1)/(hy2-hy1);
			}
			if(tt1<0.0){
				if(tt2<0.0){
					return false;
				}
				else if(tt2<1.0){
					geomx1=hx1;
					geomy1=hy1;
					geomx2=geomx[1];
					geomy2=geomy[1];
				}
				else {
					geomx1=hx1;
					geomy1=hy1;
					geomx2=hx2;
					geomy2=hy2;
				}
			}
			else if(tt1<1.0){
				if(tt2<0.0){
					geomx1=geomx[0];
					geomy1=geomy[0];
					geomx2=hx1;
					geomy2=hy1;
				}
				else if(tt2<1.0){
					geomx1=geomx[0];
					geomy1=geomy[0];
					geomx2=geomx[1];
					geomy2=geomy[1];
				}
				else {
					geomx1=geomx[0];
					geomy1=geomy[0];
					geomx2=hx2;
					geomy2=hy2;
				}
			}
			else {
				if(tt2<0.0){
					geomx1=hx1;
					geomy1=hy1;
					geomx2=hx2;
					geomy2=hy2;
				}
				else if(tt2<1.0){
					geomx1=geomx[1];
					geomy1=geomy[1];
					geomx2=hx2;
					geomy2=hy2;
				}
				else {
					return false;
				}
			}
		}
		p->afterimage_x1=geomx1;
		p->afterimage_y1=geomy1;
		p->afterimage_x2=geomx2;
		p->afterimage_y2=geomy2;
	}
	else {
		geomx1=geomx[0];
		geomy1=geomy[0];
		geomx2=geomx[1];
		geomy2=geomy[1];
	}
	double dispx0,dispx1,dispy0,dispy1;
	if(geomx1<=geomx2){
		dispx0=(geomx1-geomcx)/geomperdot+centerx;
		dispx1=(geomx2-geomcx)/geomperdot+centerx;
		dispy0=-(geomy1-geomcy)/geomperdot+centery;
		dispy1=-(geomy2-geomcy)/geomperdot+centery;
	}
	else {
		dispx0=(geomx2-geomcx)/geomperdot+centerx;
		dispx1=(geomx1-geomcx)/geomperdot+centerx;
		dispy0=-(geomy2-geomcy)/geomperdot+centery;
		dispy1=-(geomy1-geomcy)/geomperdot+centery;
	}
	double theta=atan2(dispy1-dispy0,dispx1-dispx0);
	double linewidth = m_appear._MyL[p->lndsn].LnRgn[0]._LineWidth;
	if(-0.5+relRect.GetLeft()<dispx0 && dispx0<0.5+relRect.GetLeft()){
		dispx0 -= (linewidth*abs(tan(theta))*cos(theta));
		dispy0 -= (linewidth*abs(tan(theta))*sin(theta));
	}
	else if(-0.5+relRect.GetTop()<dispy0 && dispy0<0.5+relRect.GetTop()){
		dispx0 -= (linewidth*cos(theta)/sin(theta)*cos(theta));
		dispy0 -= (linewidth*cos(theta));
	}
	else if(-0.5+relRect.GetBottom()<dispy0 && dispy0<0.5+relRect.GetBottom()){
		dispx0 += (linewidth*cos(theta)/sin(theta)*cos(theta));
		dispy0 += (linewidth*cos(theta));
	}
	if(-0.5+relRect.GetRight()<dispx1 && dispx1<0.5+relRect.GetRight()){
		dispx1 += (linewidth*abs(tan(theta))*cos(theta));
		dispy1 += (linewidth*abs(tan(theta))*sin(theta));
	}
	else if(-0.5+relRect.GetTop()<dispy1 && dispy1<0.5+relRect.GetTop()){
		dispx1 -= (linewidth*cos(theta)/sin(theta)*cos(theta));
		dispy1 -= (linewidth*cos(theta));
	}
	else if(-0.5+relRect.GetBottom()<dispy1 && dispy1<0.5+relRect.GetBottom()){
		dispx1 += (linewidth*cos(theta)/sin(theta)*cos(theta));
		dispy1 += (linewidth*cos(theta));
	}
	*dx0=dispx0;
	*dy0=dispy0;
	*dx1=dispx1;
	*dy1=dispy1;
	return true;
}

bool MyCanvas::DrawOneLine(GLine* p, wxMemoryDC* pDC)
{
	if(p==0){
		return false;
	}
	double dispx0,dispx1,dispy0,dispy1;
	if(GetGeomXY(p, &dispx0, &dispy0, &dispx1, &dispy1)==false){
		return false;
	}
	int i,j,k;
	unsigned char r,g,b;
	double linelength = m_appear._MyL[p->lndsn].LnRgn[0]._LineLength;
	double theta=atan2(dispy1-dispy0,dispx1-dispx0);
	int loopend = 1+(int)floor(sqrt((dispx1-dispx0)*(dispx1-dispx0)+(dispy1-dispy0)*(dispy1-dispy0))/linelength);
	int lastseg = (int)floor(sqrt((dispx1-dispx0)*(dispx1-dispx0)+(dispy1-dispy0)*(dispy1-dispy0))-linelength*(loopend-1));
	wxPoint myP[20];
	int jstart=(p->hilighted)? 0:1;
	int BgR= m_appear._MyBG._BgR;
	int BgG= m_appear._MyBG._BgG;
	int BgB= m_appear._MyBG._BgB;
 	for(i=0;i<loopend;i++){
		for(j=jstart;j<m_appear._MyL[p->lndsn].NLnRgn;j++){
			if(m_appear._MyL[p->lndsn].LnRgn[j]._LGTH==2){
				if(p->vanishing<4){
					r=m_appear._MyL[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR - m_appear._MyL[p->lndsn].LnRgn[j]._R)/4;
					g=m_appear._MyL[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG - m_appear._MyL[p->lndsn].LnRgn[j]._G)/4;
					b=m_appear._MyL[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB - m_appear._MyL[p->lndsn].LnRgn[j]._B)/4;
					if(p->expand>1.0){
						pDC->SetPen(wxPen(wxColour(r,g,b),(int)floor((p->expand-1.0)/0.2+2.0),wxSOLID));
					}
					else{
						pDC->SetPen(wxPen(wxColour(r,g,b),2,wxSOLID));
					}
					pDC->DrawLine((int)floor(dispx0+p->offsetx),(int)floor(dispy0+p->offsety),(int)floor(dispx1+p->offsetx),(int)floor(dispy1+p->offsety));
				}
			}
			else {
				for(k=0;k<m_appear._MyL[p->lndsn].LnRgn[j]._LGTH;k++){
					if(i<loopend-1){
						myP[k].x = (int)floor( dispx0 + cos(theta)*linelength*i 
							+ cos(theta)*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].x - sin(theta)*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].y*p->expand) ;
						myP[k].y = (int)floor( dispy0 + sin(theta)*linelength*i 
							+ sin(theta)*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].x + cos(theta)*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].y*p->expand) ;
					}
					else {
						myP[k].x = (int)floor( dispx0 + cos(theta)*linelength*i 
							+ cos(theta)*min(lastseg,m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].x) - sin(theta)*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].y*p->expand) ;
						myP[k].y = (int)floor( dispy0 + sin(theta)*linelength*i 
							+ sin(theta)*min(lastseg,m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].x) + cos(theta)*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].y*p->expand) ;
					}
				}
				if(p->vanishing<4){
					r=m_appear._MyL[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR - m_appear._MyL[p->lndsn].LnRgn[j]._R)/4;
					g=m_appear._MyL[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG - m_appear._MyL[p->lndsn].LnRgn[j]._G)/4;
					b=m_appear._MyL[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB - m_appear._MyL[p->lndsn].LnRgn[j]._B)/4;
					pDC->SetPen(wxPen(wxColour(r,g,b),1,wxSOLID));
					pDC->SetBrush(wxBrush(wxColour(r,g,b),wxSOLID));
					pDC->DrawPolygon(m_appear._MyL[p->lndsn].LnRgn[j]._LGTH,myP,p->offsetx,p->offsety,wxWINDING_RULE);
				}
			}
		}
	}
	return false;
}

bool MyCanvas::DrawLines(GLine* p, wxMemoryDC* pDC)
{
	if(p==0){
		return true;
	}
	DrawOneLine(p,pDC);
	if(p->next!=0){
		DrawLines(p->next,pDC);
	}
	return false;
}

bool MyCanvas::DrawOneCircle(GCircle* p, wxMemoryDC* pDC)
{
	if(p==0){
		return false;
	}
	if(!p->xx.realp() || !p->yy.realp() || !p->rr.realp() || p->invisible){
		return false;
	}
	int cx = centerx + (int)floor((p->xx.real() - geomcx) / geomperdot);
	int cy = centery - (int)floor((p->yy.real() - geomcy) / geomperdot);
	int cr = (int)floor(sqrt(p->rr.real()) / geomperdot );
	
	if(relRect.GetLeft() >cx+cr || relRect.GetRight() <cx-cr || relRect.GetTop() > cy+cr || relRect.GetBottom() < cy-cr){
		return false;
	}

	int j,k;
	double i;
	double linelength = m_appear._MyL[p->lndsn].LnRgn[0]._LineLength;
	double step = linelength/cr;
	unsigned char r,g,b;
	//determine start and end
	double end1,end2;
	int BgR= m_appear._MyBG._BgR;
	int BgG= m_appear._MyBG._BgG;
	int BgB= m_appear._MyBG._BgB;
	if(p->clipping && p->NOics>2){
		ResetCircleIcPara(p);
		end1=p->ics->_icpara.real();
		double mid=p->ics->_icnext->_icpara.real();
		end2=p->ics->_icnext->_icnext->_icpara.real();
		//printf("%s%s%s:",p->ics->_icpt->_name.c_str(),p->ics->_icnext->_icpt->_name.c_str(),p->ics->_icnext->_icnext->_icpt->_name.c_str());
		//printf("%lf,%lf,%lf\n",end1,mid,end2);
		double pp;
		if(end1>=mid && mid>=end2){
			pp=end1;end1=end2;end2=pp;
		}
		else if(end1>=end2 && end2>=mid){
			end2+=6.28;
		}
		else if(end2>=mid && mid>=end1){
			;
		}
		else if(end2>=end1 && end1>=mid){
			pp=end1;end1=end2;end2=pp+6.28;
		}
		else if(mid>=end1 && end1>=end2){
			end2+=6.28;
		}
		else if(mid>=end2 && end2>=end1){
			pp=end1;end1=end2;end2=pp+6.28;
		}
	}
	else {
		end1=0.0;
		end2=6.28;
	}
	wxPoint myP[20];
	double laststep=end2-end1-floor((end2-end1)/step)*step;
	int jstart=(p->hilighted)? 0:1;
	for(i=end1;i<end2;i+=step){
		for(j=jstart;j<m_appear._MyL[p->lndsn].NLnRgn;j++){
			for(k=0;k<m_appear._MyL[p->lndsn].LnRgn[j]._LGTH;k++){
				if(i<end2-step){
					myP[k].x = (int)floor( cx + p->offsetx + (cr+m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].y*p->expand)*cos(i + 1.0*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].x/cr));
					myP[k].y = (int)floor( cy + p->offsety + (cr+m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].y*p->expand)*sin(i + 1.0*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].x/cr));
				}
				else {
					myP[k].x = (int)floor( cx + p->offsetx + (cr+m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].y*p->expand)*cos(i + min(laststep,1.0*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].x/cr)));
					myP[k].y = (int)floor( cy + p->offsety + (cr+m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].y*p->expand)*sin(i + min(laststep,1.0*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].x/cr)));
				}
			}
			if(m_appear._MyL[p->lndsn].LnRgn[j]._LGTH==2){
				if(p->vanishing<4){
					r=m_appear._MyL[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR - m_appear._MyL[p->lndsn].LnRgn[j]._R)/4;
					g=m_appear._MyL[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG - m_appear._MyL[p->lndsn].LnRgn[j]._G)/4;
					b=m_appear._MyL[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB - m_appear._MyL[p->lndsn].LnRgn[j]._B)/4;
					if(p->expand>1.0){
						pDC->SetPen(wxPen(wxColour(r,g,b),(int)floor((p->expand-1.0)/0.2+2.0),wxSOLID));
					}
					else{
						pDC->SetPen(wxPen(wxColour(r,g,b),2,wxSOLID));
					}
					pDC->DrawLine(myP[0].x+ p->offsetx,myP[0].y+ p->offsety,myP[1].x+ p->offsetx,myP[1].y+ p->offsety);
				}
			}
			else {
				if(p->vanishing<4){
					r=m_appear._MyL[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR - m_appear._MyL[p->lndsn].LnRgn[j]._R)/4;
					g=m_appear._MyL[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG - m_appear._MyL[p->lndsn].LnRgn[j]._G)/4;
					b=m_appear._MyL[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB - m_appear._MyL[p->lndsn].LnRgn[j]._B)/4;
					pDC->SetPen(wxPen(wxColour(r,g,b),1,wxSOLID));
					pDC->SetBrush(wxBrush(wxColour(r,g,b),wxSOLID));
					pDC->DrawPolygon(m_appear._MyL[p->lndsn].LnRgn[j]._LGTH,myP,0,0,wxWINDING_RULE);
				}
			}
		}
	}
	return false;
}

bool MyCanvas::DrawCircles(GCircle* p, wxMemoryDC* pDC)
{
	if(p==0){
		return true;
	}
	DrawOneCircle(p,pDC);
	if(p->next!=0){
		DrawCircles(p->next,pDC);
	}
	return false;
}


bool MyCanvas::DrawOneCurve(GParaCurve* p, wxMemoryDC* pDC)
{
	if(p==0 || p->invisible){
		return false;
	}
	double theta,linelength;
	double linerate;
	double dispx0,dispx1,dispy0,dispy1;
	int jstart=(p->hilighted)? 0:1;
	int i,j,k;
	bool good0,good1,good2,good3;
	unsigned char r,g,b;
	wxPoint myP[20];
	int BgR= m_appear._MyBG._BgR;
	int BgG= m_appear._MyBG._BgG;
	int BgB= m_appear._MyBG._BgB;
	dispx1=(p->orbitx[p->orbit_len-1]-geomcx)/geomperdot+centerx;
	dispy1=-(p->orbity[p->orbit_len-1]-geomcy)/geomperdot+centery;
	good1= p->orbitx[p->orbit_len-1]>boxleft && p->orbitx[p->orbit_len-1]<boxright 
		&& - p->orbity[p->orbit_len-1]<boxtop && - p->orbity[p->orbit_len-1]>boxbottom;
	good3 = p->orbit_real[p->orbit_len-1];
	for(i=0;i<p->orbit_len;i++){
		dispx0 = dispx1;
		dispy0 = dispy1;
		good0 = good1;
		good2 = good3;
		dispx1 = (p->orbitx[i]-geomcx)/geomperdot+centerx;
		dispy1 = -(p->orbity[i]-geomcy)/geomperdot+centery;
		good1= p->orbitx[i]>boxleft && p->orbitx[i]<boxright 
			&& - p->orbity[i]<boxtop && - p->orbity[i]>boxbottom;
		good3= p->orbit_real[i];
		if((good0 || good1)/* && (good2 || good3) */){
			if(m_lbuttondown){
				pDC->DrawRectangle((int)floor(dispx1)-2,(int)floor(dispy1)-2,5,5);
			}
			else {
				theta=atan2(dispy1-dispy0,dispx1-dispx0);
				linelength = m_appear._MyL[p->lndsn].LnRgn[0]._LineLength;
				linerate = sqrt((dispx0-dispx1)*(dispx0-dispx1)+(dispy0-dispy1)*(dispy0-dispy1))/linelength;
				if(linerate<3.0){
					for(j=jstart;j<m_appear._MyL[p->lndsn].NLnRgn;j++){
						if(m_appear._MyL[p->lndsn].LnRgn[j]._LGTH==2){
							if(p->vanishing<4){
								r=m_appear._MyL[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR - m_appear._MyL[p->lndsn].LnRgn[j]._R)/4;
								g=m_appear._MyL[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG - m_appear._MyL[p->lndsn].LnRgn[j]._G)/4;
								b=m_appear._MyL[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB - m_appear._MyL[p->lndsn].LnRgn[j]._B)/4;
								if(p->expand>1.0){
									pDC->SetPen(wxPen(wxColour(r,g,b),(int)floor((p->expand-1.0)/0.2+2.0),wxSOLID));
								}
								else{
									pDC->SetPen(wxPen(wxColour(r,g,b),2,wxSOLID));
								}
								pDC->DrawLine((int)floor(dispx0),(int)floor(dispy0),(int)floor(dispx1),(int)floor(dispy1));
							}
						}
						else {
							for(k=0;k<m_appear._MyL[p->lndsn].LnRgn[j]._LGTH;k++){
								myP[k].x = (int)floor( dispx0 
									+ cos(theta)*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].x*linerate - sin(theta)*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].y) ;
								myP[k].y = (int)floor( dispy0 
									+ sin(theta)*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].x*linerate + cos(theta)*m_appear._MyL[p->lndsn].LnRgn[j]._PT[k].y) ;
							}
						}
						if(p->vanishing<4){
							r=m_appear._MyL[p->lndsn].LnRgn[j]._R+p->vanishing*(BgR - m_appear._MyL[p->lndsn].LnRgn[j]._R)/4;
							g=m_appear._MyL[p->lndsn].LnRgn[j]._G+p->vanishing*(BgG - m_appear._MyL[p->lndsn].LnRgn[j]._G)/4;
							b=m_appear._MyL[p->lndsn].LnRgn[j]._B+p->vanishing*(BgB - m_appear._MyL[p->lndsn].LnRgn[j]._B)/4;
							pDC->SetPen(wxPen(wxColour(r,g,b),1,wxSOLID));
							pDC->SetBrush(wxBrush(wxColour(r,g,b),wxSOLID));
							pDC->DrawPolygon(m_appear._MyL[p->lndsn].LnRgn[j]._LGTH,myP,0,0,wxWINDING_RULE);
						}
					}
				}
			}
		}
	} 
	return false;
}

bool MyCanvas::DrawCurves(GParaCurve* p, wxMemoryDC* pDC)
{
	if(p==NULL){
		return true;
	}
	DrawOneCurve(p,pDC);
	if(p->next!=NULL){
		DrawCurves(p->next,pDC);
	}
	return false;
}

bool MyCanvas::DrawOneText(GText* p,wxMemoryDC* pDC)
{
	if(p==NULL){
		return true;
	}
	if(!relRect.Inside((int)floor(p->tx),(int)floor(p->ty)) || p->invisible){
		return true;
	}
	wxString tgt;
	EvaluateText(cns,p->str,tgt,false);
	RemoveYenCommaOnText(tgt);
	DrawMultiText(p,tgt,pDC,(int)floor(p->tx),(int)floor(p->ty));
	if(p->hilighted){
		int px,py;
		pDC->SetPen(wxPen(wxColour(TextHilColR,TextHilColG,TextHilColB),1,wxSOLID));
		pDC->SetBrush(*wxTRANSPARENT_BRUSH);
		GetMultiTextSize(tgt,pDC,&px,&py);
		pDC->DrawRectangle((int)floor(p->tx) - 1,(int)floor(p->ty),px+2,py);
	}
	return false;

}

bool MyCanvas::DrawTexts(GText* p,wxMemoryDC* pDC)
{
	if(p==NULL){
		return true;
	}
	DrawOneText(p,pDC);
	if(p->next!=0){
		DrawTexts(p->next,pDC);
	}
	return false;
}

bool MyCanvas::DrawMultiText(GText* p,wxString& st,wxMemoryDC* pDC,int px,int py)
{
	long length,height,descent;
	int i=0,j,offsety=0;
	unsigned char r,g,b;
	wxString subst;
	char*pp=(char*)st.c_str();
	int len=strlen(pp);
	int cpx,cpy;
	int BgR= m_appear._MyBG._BgR;
	int BgG= m_appear._MyBG._BgG;
	int BgB= m_appear._MyBG._BgB;
	GetMultiTextSize(st,pDC,&cpx,&cpy);
	for(j=0;j<len;j++){
		if(pp[j]=='\n' || pp[j]=='\r'){
			subst=mMid(st,i,j-i);
			if(p->vanishing<4){
				pDC->SetFont(wxFont((int)floor(p->fontsize*p->expand), wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, false, wxT(""),  wxFONTENCODING_DEFAULT));
				r=p->ColR+p->vanishing*(BgR-p->ColR)/4;
				g=p->ColG+p->vanishing*(BgG-p->ColG)/4;
				b=p->ColB+p->vanishing*(BgB-p->ColB)/4;
				pDC->SetTextForeground(wxColour(r,g,b));
				wxString str1((char*)subst.c_str(),*wxConvCurrent);
				pDC->GetTextExtent(str1,&length,&height,&descent);
				if(p->centered){
					pDC->DrawText(str1,px+p->offsetx-(int)floor(length*(p->expand-1.0)*0.25)+(int)floor(0.5*(cpx-length)),py+offsety+p->offsety-(int)floor((height+descent)*(p->expand-1.0)*0.25));
				}
				else {
					pDC->DrawText(str1,px+p->offsetx-(int)floor(length*(p->expand-1.0)*0.25),py+offsety+p->offsety-(int)floor((height+descent)*(p->expand-1.0)*0.25));
				}
				offsety +=(height+descent);
				i=j+1;
			}
		}
	}
	subst=mMid(st,i);
	if(p->vanishing<=4){
		pDC->SetFont(wxFont((int)floor(p->fontsize*p->expand), wxFONTFAMILY_DEFAULT, wxFONTSTYLE_NORMAL, wxFONTWEIGHT_NORMAL, false, wxT(""),  wxFONTENCODING_DEFAULT));
		pDC->SetTextForeground(wxColour(
			p->ColR+p->vanishing*(BgR-p->ColR)/4,
			p->ColG+p->vanishing*(BgG-p->ColG)/4,
			p->ColB+p->vanishing*(BgB-p->ColB)/4));
		wxString str2((char*)subst.c_str(),*wxConvCurrent);
		pDC->GetTextExtent(str2,&length,&height,&descent);
		pDC->DrawText(str2,px+p->offsetx-(int)floor(length*(p->expand-1.0)*0.25),py+offsety+p->offsety-(int)floor((height+descent)*(p->expand-1.0)*0.25));
	}
	return false;
}

bool MyCanvas::GetMultiTextSize(wxString st,wxMemoryDC* pDC,int *px,int *py)
{
	*px=0;
	*py=0;
	long length,height,descent;
	int i=0,j;
	wxString subst;
	char*pp=(char*)st.c_str();
	int len=strlen(pp);
	for(j=0;j<len;j++){
		if(pp[j]=='\n' || pp[j]=='\r'){
			subst=mMid(st,i,j-i);
			wxString str1((char*)subst.c_str(),*wxConvCurrent);
			pDC->GetTextExtent(str1,&length,&height,&descent);
			i=j+1;
			*py +=(height+descent);
			if(*px<length){
				*px=length;
			}
		}
	}
	subst=mMid(st,i);
	wxString str2((char*)subst.c_str(),*wxConvCurrent);
	pDC->GetTextExtent(str2,&length,&height,&descent);
	*py +=(height+descent);
	if(*px<length){
		*px=length;
	}
	return false;
}

bool MyCanvas::DrawAngles(GAngle* ag,wxMemoryDC *pDC)
{
	if(ag==NULL){
		return true;
	}
	DrawOneAngle(ag,pDC);
	if(ag->next!=0){
		DrawAngles(ag->next,pDC);
	}
	return false;
}

bool MyCanvas::DrawOneAngle(GAngle* ag,wxMemoryDC *pDC)
{
	unsigned char r,g,b;
	int BgR= m_appear._MyBG._BgR;
	int BgG= m_appear._MyBG._BgG;
	int BgB= m_appear._MyBG._BgB;
	if(ag->invisible){
		return false;
	}
	if(ag->vanishing<4){
		r=ag->ColR+ag->vanishing*(BgR-ag->ColR)/4;
		g=ag->ColG+ag->vanishing*(BgG-ag->ColG)/4;
		b=ag->ColB+ag->vanishing*(BgB-ag->ColB)/4;
		pDC->SetPen(wxPen(wxColour(r,g,b),3,wxSOLID));
		if(ag->hilighted){
			pDC->SetBrush(wxBrush(wxColour(r,g,b),wxSOLID));
		}
		else {
			pDC->SetBrush(wxBrush(wxColour(r,g,b),wxTRANSPARENT));
		}
		if(ag->m_angle.realp() && ag->m_startx.realp() && ag->m_starty.realp() && ag->m_endx.realp() && ag->m_endy.realp()){
			int cx = centerx + (int)floor((ag->m_xx.real() - geomcx) / geomperdot) + ag->offsetx;
			int cy = centery - (int)floor((ag->m_yy.real() - geomcy) / geomperdot) + ag->offsety;
			double pm = ag->m_startx.real() * ag->m_endy.real() - ag->m_starty.real() * ag->m_endx.real();
			double m1x=ag->m_startx.real()+ag->m_endx.real();
			double m1y=ag->m_starty.real()+ag->m_endy.real();
			double m1norm=sqrt(m1x*m1x+m1y*m1y);
			double asize=ag->m_angle_size*ag->expand;
			if(m1norm!=0){
				m1x /= m1norm ; m1y /= m1norm;
			}
			switch(ag->m_angle_design){
			case 0:
				if(pm>0.05){
					pDC->DrawArc(
						(int)floor(cx+ag->m_startx.real()*asize),(int)floor(cy-ag->m_starty.real()*asize),
						(int)floor(cx+ag->m_endx.real()*asize),(int)floor(cy-ag->m_endy.real()*asize),
						cx,cy);
				}
				else if(pm<-0.05){
					pDC->DrawArc(
						(int)floor(cx+ag->m_endx.real()*asize),(int)floor(cy-ag->m_endy.real()*asize),
						(int)floor(cx+ag->m_startx.real()*asize),(int)floor(cy-ag->m_starty.real()*asize),
						cx,cy);
				}
				break;
			case 1:
				if(pm>0.05){
					pDC->DrawArc(
						(int)floor(cx+ag->m_startx.real()*asize*1.08),(int)floor(cy-ag->m_starty.real()*asize*1.08),
						(int)floor(cx+ag->m_endx.real()*asize*1.08),(int)floor(cy-ag->m_endy.real()*asize*1.08),
						cx,cy);
					pDC->DrawArc(
						(int)floor(cx+ag->m_startx.real()*asize*0.92),(int)floor(cy-ag->m_starty.real()*asize*0.92),
						(int)floor(cx+ag->m_endx.real()*asize*0.92),(int)floor(cy-ag->m_endy.real()*asize*0.92),
						cx,cy);
				}
				else if(pm<-0.05){
					pDC->DrawArc(
						(int)floor(cx+ag->m_endx.real()*asize*1.08),(int)floor(cy-ag->m_endy.real()*asize*1.08),
						(int)floor(cx+ag->m_startx.real()*asize*1.08),(int)floor(cy-ag->m_starty.real()*asize*1.08),
						cx,cy);
					pDC->DrawArc(
						(int)floor(cx+ag->m_endx.real()*asize*0.92),(int)floor(cy-ag->m_endy.real()*asize*0.92),
						(int)floor(cx+ag->m_startx.real()*asize*0.92),(int)floor(cy-ag->m_starty.real()*asize*0.92),
						cx,cy);
				}
				break;
			case 2:
				if(pm>0.05){
					pDC->DrawArc(
						(int)floor(cx+ag->m_startx.real()*asize),(int)floor(cy-ag->m_starty.real()*asize),
						(int)floor(cx+ag->m_endx.real()*asize),(int)floor(cy-ag->m_endy.real()*asize),
						cx,cy);
					pDC->DrawLine(
						(int)floor(cx+m1x*0.8*asize),(int)floor(cy-m1y*0.8*asize),
						(int)floor(cx+m1x*1.2*asize),(int)floor(cy-m1y*1.2*asize));
				}
				else if(pm<-0.05){
					pDC->DrawArc(
						(int)floor(cx+ag->m_endx.real()*asize),(int)floor(cy-ag->m_endy.real()*asize),
						(int)floor(cx+ag->m_startx.real()*asize),(int)floor(cy-ag->m_starty.real()*asize),
						cx,cy);
					pDC->DrawLine(
						(int)floor(cx+m1x*0.8*asize),(int)floor(cy-m1y*0.8*asize),
						(int)floor(cx+m1x*1.2*asize),(int)floor(cy-m1y*1.2*asize));
				}
				break;
			case 3:
				if(pm>0.05){
					pDC->DrawArc(
						(int)floor(cx+ag->m_startx.real()*asize),(int)floor(cy-ag->m_starty.real()*asize),
						(int)floor(cx+ag->m_endx.real()*asize),(int)floor(cy-ag->m_endy.real()*asize),
						cx,cy);
					pDC->DrawLine(
						(int)floor(cx+(m1x*0.8+m1y*0.15)*asize),(int)floor(cy-(m1y*0.8-m1x*0.15)*asize),
						(int)floor(cx+(m1x*1.2+m1y*0.15)*asize),(int)floor(cy-(m1y*1.2-m1x*0.15)*asize));
					pDC->DrawLine(
						(int)floor(cx+(m1x*0.8-m1y*0.15)*asize),(int)floor(cy-(m1y*0.8+m1x*0.15)*asize),
						(int)floor(cx+(m1x*1.2-m1y*0.15)*asize),(int)floor(cy-(m1y*1.2+m1x*0.15)*asize));
				}
				else if(pm<-0.05){
					pDC->DrawArc(
						(int)floor(cx+ag->m_endx.real()*asize),(int)floor(cy-ag->m_endy.real()*asize),
						(int)floor(cx+ag->m_startx.real()*asize),(int)floor(cy-ag->m_starty.real()*asize),
						cx,cy);
					pDC->DrawLine(
						(int)floor(cx+(m1x*0.8+m1y*0.15)*asize),(int)floor(cy-(m1y*0.8-m1x*0.15)*asize),
						(int)floor(cx+(m1x*1.2+m1y*0.15)*asize),(int)floor(cy-(m1y*1.2-m1x*0.15)*asize));
					pDC->DrawLine(
						(int)floor(cx+(m1x*0.8-m1y*0.15)*asize),(int)floor(cy-(m1y*0.8+m1x*0.15)*asize),
						(int)floor(cx+(m1x*1.2-m1y*0.15)*asize),(int)floor(cy-(m1y*1.2+m1x*0.15)*asize));
				}
				break;
			case 4:
				if(pm>0.05){
					pDC->DrawArc(
						(int)floor(cx+ag->m_startx.real()*asize),(int)floor(cy-ag->m_starty.real()*asize),
						(int)floor(cx+ag->m_endx.real()*asize),(int)floor(cy-ag->m_endy.real()*asize),
						cx,cy);
					pDC->DrawCircle(
						(int)floor(cx+m1x*asize),(int)floor(cy-m1y*asize),
						(int)floor(0.2*asize));
				}
				else if(pm<-0.05){
					pDC->DrawArc(
						(int)floor(cx+ag->m_endx.real()*asize),(int)floor(cy-ag->m_endy.real()*asize),
						(int)floor(cx+ag->m_startx.real()*asize),(int)floor(cy-ag->m_starty.real()*asize),
						cx,cy);
					pDC->DrawCircle(
						(int)floor(cx+m1x*asize),(int)floor(cy-m1y*asize),
						(int)floor(0.2*asize));
				}
				break;
			}
		}
	}
	return false;
}

bool MyCanvas::DrawImages(GImage* p,wxMemoryDC* pDC)
{
	if(p==NULL){
		return true;
	}
	DrawOneImage(p,pDC);
	if(p->next!=0){
		DrawImages(p->next,pDC);
	}
	return false;
}

bool MyCanvas::DrawOneImage(GImage* p,wxMemoryDC* pDC)
{
	if(!p->invisible && p->imageon && p->vanishing<4){
		pDC->DrawBitmap(p->m_bmp,p->m_x+p->offsetx,p->m_y+p->offsety);
		if(p->hilighted || p->expand>1.0){
			int thick=(p->hilighted)? 1: (int)floor(p->expand*5-4);
			pDC->SetPen(wxPen(wxColour(TextHilColR,TextHilColG,TextHilColB),thick,wxSOLID));
			pDC->SetBrush(*wxTRANSPARENT_BRUSH);
			pDC->DrawRectangle(p->m_x+p->offsetx-5,p->m_y+p->offsety-5,p->m_w+10,p->m_h+10);
			pDC->SetBrush(wxBrush(wxColour(TextHilColR,TextHilColG,TextHilColB)));
			pDC->DrawRectangle(p->m_x+p->offsetx-5,p->m_y+p->offsety-5,5,5);
			pDC->DrawRectangle(p->m_x+p->offsetx-5,p->m_y+p->m_h+p->offsety,5,5);
			pDC->DrawRectangle(p->m_x+p->m_w+p->offsetx,p->m_y+p->offsety-5,5,5);
			pDC->DrawRectangle(p->m_x+p->m_w+p->offsetx,p->m_y+p->m_h+p->offsety,5,5);
		}
	}
	return false;
}

bool MyCanvas::DrawBrackets(GBracket* br,wxMemoryDC *pDC)
{
	if(br==NULL){
		return true;
	}
	DrawOneBracket(br,pDC);
	if(br->next!=0){
		DrawBrackets(br->next,pDC);
	}
	return false;
}

bool MyCanvas::DrawOneBracket(GBracket* br,wxMemoryDC *pDC)
{
	unsigned char r,g,b;
	wxString str1;
	int BgR= m_appear._MyBG._BgR;
	int BgG= m_appear._MyBG._BgG;
	int BgB= m_appear._MyBG._BgB;
	if(br->invisible){
		return false;
	}
	if(br->vanishing<4){
		r=br->ColR+br->vanishing*(BgR-br->ColR)/4;
		g=br->ColG+br->vanishing*(BgG-br->ColG)/4;
		b=br->ColB+br->vanishing*(BgB-br->ColB)/4;
		pDC->SetBrush(wxBrush(wxColour(r,g,b),wxTRANSPARENT));
		int thick=(br->hilighted)? 6: (int)floor(br->expand*5-2);
		pDC->SetPen(wxPen(wxColour(r,g,b),thick,wxSOLID));
		if(br->m_startz.zerop() || br->m_endz.zerop()){
			return false;
		}
		CComplex sxz=br->m_startx/br->m_startz;
		CComplex syz=br->m_starty/br->m_startz;
		CComplex exz=br->m_endx/br->m_endz;
		CComplex eyz=br->m_endy/br->m_endz;
		if(!(sxz.realp()) || !(syz.realp()) || !(exz.realp()) || !(eyz.realp())){
			return false;
		}
		double s_geomx=sxz.real();
		double s_geomy=syz.real();
		int s_dispx=centerx+(int)floor((s_geomx-geomcx)/geomperdot)+br->offsetx;
		int s_dispy=centery-(int)floor((s_geomy-geomcy)/geomperdot)+br->offsety;
		double e_geomx=exz.real();
		double e_geomy=eyz.real();
		int e_dispx=centerx+(int)floor((e_geomx-geomcx)/geomperdot)+br->offsetx;
		int e_dispy=centery-(int)floor((e_geomy-geomcy)/geomperdot)+br->offsety;
		double d=sqrt(1.0*(s_dispx-e_dispx)*(s_dispx-e_dispx)+1.0*(s_dispy-e_dispy)*(s_dispy-e_dispy));
		double ax=0.5*(s_dispx+e_dispx);
		double ay=0.5*(s_dispy+e_dispy);
		if(br->m_bracket_height>0.02 || br->m_bracket_height<-0.02){
			if(d<0.1){
				return false;
			}
//			double dh=(br->m_bracket_height>0)? d*br->m_bracket_height : -d*br->m_bracket_height;
			double sn=(br->m_bracket_height>0)? 1.0 : -1.0;
			double dh=abs(d*br->m_bracket_height);
			double r0=(dh*dh+d*d*0.25)/(2.0*dh);
			double cx=ax-sn*(s_dispy-e_dispy)/d*(r0-dh);
			double cy=ay+sn*(s_dispx-e_dispx)/d*(r0-dh);
			double start_theta=atan2(-s_dispy+cy,s_dispx-cx)*180.0/3.14159265;
			double end_theta=atan2(-e_dispy+cy,e_dispx-cx)*180.0/3.14159265;
			if(end_theta<start_theta-180.0){ end_theta+=360.0; }
			if(end_theta>start_theta+180.0){ end_theta-=360.0; }
			if(end_theta>start_theta){
				pDC->DrawEllipticArc((int)floor(cx-r0),(int)floor(cy-r0),(int)floor(r0)*2,(int)floor(r0)*2,start_theta,end_theta);
			}
			else {
				pDC->DrawEllipticArc((int)floor(cx-r0),(int)floor(cy-r0),(int)floor(r0)*2,(int)floor(r0)*2,end_theta,start_theta);
			}
			cx=ax+sn*(s_dispy-e_dispy)/d*dh;
			cy=ay-sn*(s_dispx-e_dispx)/d*dh;
			int dx,dy,ex,ey;
			wxString tgt;
			int px,py;
			switch(br->m_bracket_design){
			case -1: // caption
				EvaluateText(cns,br->caption,tgt,false);
				RemoveYenCommaOnText(tgt);
				GetMultiTextSize(tgt,pDC,&px,&py);
				pDC->SetTextForeground(wxColour(r,g,b));
				str1=wxString((char*)tgt.c_str(),*wxConvCurrent);
				pDC->DrawText(str1,
					(int)floor(cx)-(px/2)+br->offsetx,
					(int)floor(cy)-(py/2)+br->offsety);
				break;
			case 1: // single segment
				dx=(int)floor(cx+(s_dispy-e_dispy)/d*10);
				dy=(int)floor(cy-(s_dispx-e_dispx)/d*10);
				ex=(int)floor(cx-(s_dispy-e_dispy)/d*10);
				ey=(int)floor(cy+(s_dispx-e_dispx)/d*10);
				pDC->DrawLine(dx,dy,ex,ey);
				break;
			case 2: // double segments
				dx=(int)floor(cx+(s_dispy-e_dispy)/d*10+(s_dispx-e_dispx)/d*5);
				dy=(int)floor(cy-(s_dispx-e_dispx)/d*10+(s_dispy-e_dispy)/d*5);
				ex=(int)floor(cx-(s_dispy-e_dispy)/d*10+(s_dispx-e_dispx)/d*5);
				ey=(int)floor(cy+(s_dispx-e_dispx)/d*10+(s_dispy-e_dispy)/d*5);
				pDC->DrawLine(dx,dy,ex,ey);
				dx=(int)floor(cx+(s_dispy-e_dispy)/d*10-(s_dispx-e_dispx)/d*5);
				dy=(int)floor(cy-(s_dispx-e_dispx)/d*10-(s_dispy-e_dispy)/d*5);
				ex=(int)floor(cx-(s_dispy-e_dispy)/d*10-(s_dispx-e_dispx)/d*5);
				ey=(int)floor(cy+(s_dispx-e_dispx)/d*10-(s_dispy-e_dispy)/d*5);
				pDC->DrawLine(dx,dy,ex,ey);
				break;
			case 3: // circle
				dx=(int)floor(cx);
				dy=(int)floor(cy);
				pDC->DrawCircle(dx,dy,10);
				break;
			case 4: // check
				dx=(int)floor(cx+(s_dispy-e_dispy)/d*10+(s_dispx-e_dispx)/d*5);
				dy=(int)floor(cy-(s_dispx-e_dispx)/d*10+(s_dispy-e_dispy)/d*5);
				ex=(int)floor(cx-(s_dispy-e_dispy)/d*10-(s_dispx-e_dispx)/d*5);
				ey=(int)floor(cy+(s_dispx-e_dispx)/d*10-(s_dispy-e_dispy)/d*5);
				pDC->DrawLine(dx,dy,ex,ey);
				dx=(int)floor(cx+(s_dispy-e_dispy)/d*10-(s_dispx-e_dispx)/d*5);
				dy=(int)floor(cy-(s_dispx-e_dispx)/d*10-(s_dispy-e_dispy)/d*5);
				ex=(int)floor(cx-(s_dispy-e_dispy)/d*10+(s_dispx-e_dispx)/d*5);
				ey=(int)floor(cy+(s_dispx-e_dispx)/d*10+(s_dispy-e_dispy)/d*5);
				pDC->DrawLine(dx,dy,ex,ey);
				break;
			}
		}
		else {
			br->m_bracket_height=0.0;
			pDC->DrawLine(e_dispx,e_dispy,s_dispx,s_dispy);
			int dx,dy,ex,ey;
			wxString tgt;
			int px,py;
			switch(br->m_bracket_design){
			case -1: // caption
				EvaluateText(cns,br->caption,tgt,false);
				RemoveYenCommaOnText(tgt);
				GetMultiTextSize(tgt,pDC,&px,&py);
				pDC->SetTextForeground(wxColour(r,g,b));
				str1=wxString((char*)tgt.c_str(),*wxConvCurrent);
				pDC->DrawText(str1,
					(int)floor(ax)-(px/2)+br->offsetx,
					(int)floor(ay)-(py/2)+br->offsety);
				break;
			case 1: // single segment
				dx=(int)floor(ax+(s_dispy-e_dispy)/d*10);
				dy=(int)floor(ay-(s_dispx-e_dispx)/d*10);
				ex=(int)floor(ax-(s_dispy-e_dispy)/d*10);
				ey=(int)floor(ay+(s_dispx-e_dispx)/d*10);
				pDC->DrawLine(dx,dy,ex,ey);
				break;
			case 2: // double segments
				dx=(int)floor(ax+(s_dispy-e_dispy)/d*10+(s_dispx-e_dispx)/d*5);
				dy=(int)floor(ay-(s_dispx-e_dispx)/d*10+(s_dispy-e_dispy)/d*5);
				ex=(int)floor(ax-(s_dispy-e_dispy)/d*10+(s_dispx-e_dispx)/d*5);
				ey=(int)floor(ay+(s_dispx-e_dispx)/d*10+(s_dispy-e_dispy)/d*5);
				pDC->DrawLine(dx,dy,ex,ey);
				dx=(int)floor(ax+(s_dispy-e_dispy)/d*10-(s_dispx-e_dispx)/d*5);
				dy=(int)floor(ay-(s_dispx-e_dispx)/d*10-(s_dispy-e_dispy)/d*5);
				ex=(int)floor(ax-(s_dispy-e_dispy)/d*10-(s_dispx-e_dispx)/d*5);
				ey=(int)floor(ay+(s_dispx-e_dispx)/d*10-(s_dispy-e_dispy)/d*5);
				pDC->DrawLine(dx,dy,ex,ey);
				break;
			case 3: // circle
				dx=(int)floor(ax);
				dy=(int)floor(ay);
				pDC->DrawCircle(dx,dy,10);
				break;
			case 4: // check
				dx=(int)floor(ax+(s_dispy-e_dispy)/d*10+(s_dispx-e_dispx)/d*5);
				dy=(int)floor(ay-(s_dispx-e_dispx)/d*10+(s_dispy-e_dispy)/d*5);
				ex=(int)floor(ax-(s_dispy-e_dispy)/d*10-(s_dispx-e_dispx)/d*5);
				ey=(int)floor(ay+(s_dispx-e_dispx)/d*10-(s_dispy-e_dispy)/d*5);
				pDC->DrawLine(dx,dy,ex,ey);
				dx=(int)floor(ax+(s_dispy-e_dispy)/d*10-(s_dispx-e_dispx)/d*5);
				dy=(int)floor(ay-(s_dispx-e_dispx)/d*10-(s_dispy-e_dispy)/d*5);
				ex=(int)floor(ax-(s_dispy-e_dispy)/d*10+(s_dispx-e_dispx)/d*5);
				ey=(int)floor(ay+(s_dispx-e_dispx)/d*10+(s_dispy-e_dispy)/d*5);
				pDC->DrawLine(dx,dy,ex,ey);
				break;
			}
		}
	}
	return false;
}

bool MyCanvas::DrawCompassCircle(wxMemoryDC* pDC)
{
	if(NOhilightedPoints==1){
		compassradius=(int)floor(sqrt(
			1.0*(compasscenterx-compasscursorx)*(compasscenterx-compasscursorx)+
			1.0*(compasscentery-compasscursory)*(compasscentery-compasscursory)));
	}
	else if(NOhilightedPoints==2){
		compasscenterx=compasscursorx;
		compasscentery=compasscursory;
	}
	else {
		return false;;
	}
	pDC->SetPen(AxisPen);
	pDC->SetBrush(*wxTRANSPARENT_BRUSH);
	pDC->DrawCircle(compasscenterx,compasscentery,compassradius);
	return false;
}

bool MyCanvas::DrawPanelButton(wxMemoryDC* pDC)
{
	if(PanelShift){
		pDC->DrawBitmap(PanelShiftOn,0,relRect.GetHeight()-32,true);
	}
	else{
		pDC->DrawBitmap(PanelShiftOff,0,relRect.GetHeight()-32,true);
	}
	if(PanelAdd){
		pDC->DrawBitmap(PanelAddOn,64,relRect.GetHeight()-32,true);
	}
	else{
		pDC->DrawBitmap(PanelAddOff,64,relRect.GetHeight()-32,true);
	}
	if(PanelMove){
		pDC->DrawBitmap(PanelMoveOn,128,relRect.GetHeight()-32,true);
	}
	else{
		pDC->DrawBitmap(PanelMoveOff,128,relRect.GetHeight()-32,true);
	}
	return false;
}


void PtBmp::ClearBitmap()
{
	if(_BmpOn==1){
		//delete _regular;
		//delete _regular_mask;
		//delete _mask_r;
		//delete _hilighted;
		//delete _hilighted_mask;
		//delete _mask_h;
	}
}

void PtBmp::LoadData(int DataID)
{
	switch(DataID){
	case PTBMP_BALL0:
		_regular = new wxBitmap(ball_r0_xpm);
		_regular_mask = new wxBitmap(ball_r0_xpm);
		_mask_r=new wxMask(*(_regular_mask),*wxBLACK);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(ball_h0_xpm);
		_hilighted_mask = new wxBitmap(ball_h0_xpm);
		_mask_h=new wxMask(*(_hilighted_mask),*wxBLACK);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_BALL1:
		_regular = new wxBitmap(ball_r1_xpm);
		_regular_mask = new wxBitmap(ball_r1_xpm);
		_mask_r=new wxMask(*(_regular_mask),*wxBLACK);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(ball_h1_xpm);
		_hilighted_mask = new wxBitmap(ball_h1_xpm);
		_mask_h=new wxMask(*(_hilighted_mask),*wxBLACK);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_BALL2:
		_regular = new wxBitmap(ball_r2_xpm);
		_regular_mask = new wxBitmap(ball_r2_xpm);
		_mask_r=new wxMask(*(_regular_mask),*wxBLACK);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(ball_h2_xpm);
		_hilighted_mask = new wxBitmap(ball_h2_xpm);
		_mask_h=new wxMask(*(_hilighted_mask),*wxBLACK);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_BALL3:
		_regular = new wxBitmap(ball_r3_xpm);
		_regular_mask = new wxBitmap(ball_r3_xpm);
		_mask_r=new wxMask(*(_regular_mask),*wxBLACK);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(ball_h3_xpm);
		_hilighted_mask = new wxBitmap(ball_h3_xpm);
		_mask_h=new wxMask(*(_hilighted_mask),*wxBLACK);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_BALL4:
		_regular = new wxBitmap(ball_r4_xpm);
		_regular_mask = new wxBitmap(ball_r4_xpm);
		_mask_r=new wxMask(*(_regular_mask),*wxBLACK);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(ball_h4_xpm);
		_hilighted_mask = new wxBitmap(ball_h4_xpm);
		_mask_h=new wxMask(*(_hilighted_mask),*wxBLACK);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_CAT0:
		_regular = new wxBitmap(cat_r0_xpm);
		_regular_mask = new wxBitmap(cat_r0_xpm);
		_mask_r = new wxMask(*(_regular_mask),*wxWHITE);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(cat_h0_xpm);
		_hilighted_mask = new wxBitmap(cat_h0_xpm);
		_mask_h = new wxMask(*(_hilighted_mask),*wxWHITE);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_CAT1:
		_regular = new wxBitmap(cat_r1_xpm);
		_regular_mask = new wxBitmap(cat_r1_xpm);
		_mask_r = new wxMask(*(_regular_mask),*wxWHITE);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(cat_h1_xpm);
		_hilighted_mask = new wxBitmap(cat_h1_xpm);
		_mask_h = new wxMask(*(_hilighted_mask),*wxWHITE);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_CAT2:
		_regular = new wxBitmap(cat_r2_xpm);
		_regular_mask = new wxBitmap(cat_r2_xpm);
		_mask_r = new wxMask(*(_regular_mask),*wxWHITE);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(cat_h2_xpm);
		_hilighted_mask = new wxBitmap(cat_h2_xpm);
		_mask_h = new wxMask(*(_hilighted_mask),*wxWHITE);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_CAT3:
		_regular = new wxBitmap(cat_r3_xpm);
		_regular_mask = new wxBitmap(cat_r3_xpm);
		_mask_r = new wxMask(*(_regular_mask),*wxWHITE);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(cat_h3_xpm);
		_hilighted_mask = new wxBitmap(cat_h3_xpm);
		_mask_h = new wxMask(*(_hilighted_mask),*wxWHITE);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_CAT4:
		_regular = new wxBitmap(cat_r4_xpm);
		_regular_mask = new wxBitmap(cat_r4_xpm);
		_mask_r = new wxMask(*(_regular_mask),*wxWHITE);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(cat_h4_xpm);
		_hilighted_mask = new wxBitmap(cat_h4_xpm);
		_mask_h = new wxMask(*(_hilighted_mask),*wxWHITE);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_STAR0:
		_regular = new wxBitmap(star_r0_xpm);
		_regular_mask = new wxBitmap(star_r0_xpm);
		_mask_r = new wxMask(*(_regular_mask),*wxBLACK);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(star_h0_xpm);
		_hilighted_mask = new wxBitmap(star_h0_xpm); 
		_mask_h = new wxMask(*(_hilighted_mask),*wxBLACK);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_STAR1:
		_regular = new wxBitmap(star_r1_xpm);
		_regular_mask = new wxBitmap(star_r1_xpm);
		_mask_r = new wxMask(*(_regular_mask),*wxBLACK);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(star_h1_xpm);
		_hilighted_mask = new wxBitmap(star_h1_xpm); 
		_mask_h = new wxMask(*(_hilighted_mask),*wxBLACK);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_STAR2:
		_regular = new wxBitmap(star_r2_xpm);
		_regular_mask = new wxBitmap(star_r2_xpm);
		_mask_r = new wxMask(*(_regular_mask),*wxBLACK);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(star_h2_xpm);
		_hilighted_mask = new wxBitmap(star_h2_xpm); 
		_mask_h = new wxMask(*(_hilighted_mask),*wxBLACK);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_STAR3:
		_regular = new wxBitmap(star_r3_xpm);
		_regular_mask = new wxBitmap(star_r3_xpm);
		_mask_r = new wxMask(*(_regular_mask),*wxBLACK);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(star_h3_xpm);
		_hilighted_mask = new wxBitmap(star_h3_xpm); 
		_mask_h = new wxMask(*(_hilighted_mask),*wxBLACK);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_STAR4:
		_regular = new wxBitmap(star_r4_xpm);
		_regular_mask = new wxBitmap(star_r4_xpm);
		_mask_r = new wxMask(*(_regular_mask),*wxBLACK);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(star_h4_xpm);
		_hilighted_mask = new wxBitmap(star_h4_xpm); 
		_mask_h = new wxMask(*(_hilighted_mask),*wxBLACK);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_SKELETON0:
		_regular = new wxBitmap(skeleton_xpm);
		_regular_mask = new wxBitmap(skeleton_mask_xpm);
		_mask_r=new wxMask(*(_regular_mask),*wxWHITE);
		_regular->SetMask(_mask_r);
		_hilighted = new wxBitmap(skeleton_r_xpm);
		_hilighted_mask = new wxBitmap(skeleton_rmask_xpm); 
		_mask_h = new wxMask(*(_hilighted_mask),*wxWHITE);
		_hilighted->SetMask(_mask_h);
		_BmpOn=1;
		break;
	case PTBMP_CINDY0:
		_HilColR=255;_HilColG=255;_HilColB=255;
		_OutColR=000;_OutColG=000;_OutColB=000;
		_InColR=255;_InColG=000;_InColB=000;
		_HilRad=9;_OutRad=7;_InRad=6;
		_BmpOn=0;
		break;
	case PTBMP_CINDY1:
		_HilColR=255;_HilColG=255;_HilColB=255;
		_OutColR=000;_OutColG=000;_OutColB=000;
		_InColR=130;_InColG=255;_InColB=000;
		_HilRad=9;_OutRad=7;_InRad=6;
		_BmpOn=0;
		break;
	case PTBMP_CINDY2:
		_HilColR=255;_HilColG=255;_HilColB=255;
		_OutColR=000;_OutColG=000;_OutColB=000;
		_InColR=000;_InColG=130;_InColB=255;
		_HilRad=9;_OutRad=7;_InRad=6;
		_BmpOn=0;
		break;
	case PTBMP_CINDY3:
		_HilColR=255;_HilColG=255;_HilColB=255;
		_OutColR=000;_OutColG=000;_OutColB=000;
		_InColR=130;_InColG=000;_InColB=255;
		_HilRad=9;_OutRad=7;_InRad=6;
		_BmpOn=0;
		break;
	case PTBMP_CINDY4:
		_HilColR=255;_HilColG=255;_HilColB=255;
		_OutColR=000;_OutColG=000;_OutColB=000;
		_InColR=255;_InColG=130;_InColB=000;
		_HilRad=9;_OutRad=7;_InRad=6;
		_BmpOn=0;
		break;
	case PTBMP_KSEG0:
		_HilColR=255;_HilColG=000;_HilColB=000;
		_OutColR=000;_OutColG=000;_OutColB=000;
		_InColR=000;_InColG=000;_InColB=000;
		_HilRad=8;_OutRad=6;_InRad=4;
		_BmpOn=0;
		break;
	case PTBMP_KSEG1:
		_HilColR=255;_HilColG=000;_HilColB=000;
		_OutColR=000;_OutColG=000;_OutColB=000;
		_InColR=000;_InColG=255;_InColB=000;
		_HilRad=8;_OutRad=6;_InRad=4;
		_BmpOn=0;
		break;
	case PTBMP_KSEG2:
		_HilColR=255;_HilColG=000;_HilColB=000;
		_OutColR=000;_OutColG=000;_OutColB=000;
		_InColR=000;_InColG=000;_InColB=255;
		_HilRad=8;_OutRad=6;_InRad=4;
		_BmpOn=0;
		break;
	case PTBMP_KSEG3:
		_HilColR=255;_HilColG=000;_HilColB=000;
		_OutColR=000;_OutColG=000;_OutColB=000;
		_InColR=255;_InColG=000;_InColB=000;
		_HilRad=8;_OutRad=6;_InRad=4;
		_BmpOn=0;
		break;
	case PTBMP_KSEG4:	
		_HilColR=255;_HilColG=000;_HilColB=000;
		_OutColR=000;_OutColG=000;_OutColB=000;
		_InColR=000;_InColG=128;_InColB=128;
		_HilRad=8;_OutRad=6;_InRad=4;
		_BmpOn=0;
		break;
	case PTBMP_PASTEL0:
		_HilColR=200;_HilColG=255;_HilColB=200;
		_OutColR=120;_OutColG=255;_OutColB=120;
		_InColR=255;_InColG=255;_InColB=000;
		_HilRad=9;_OutRad=7;_InRad=5;
		_BmpOn=0;
		break;
	case PTBMP_PASTEL1:
		_HilColR=200;_HilColG=255;_HilColB=200;
		_OutColR=120;_OutColG=255;_OutColB=120;
		_InColR=000;_InColG=255;_InColB=255;
		_HilRad=9;_OutRad=7;_InRad=5;
		_BmpOn=0;
		break;
	case PTBMP_PASTEL2:
		_HilColR=200;_HilColG=255;_HilColB=200;
		_OutColR=120;_OutColG=255;_OutColB=120;
		_InColR=255;_InColG=130;_InColB=180;
		_HilRad=9;_OutRad=7;_InRad=5;
		_BmpOn=0;
		break;
	case PTBMP_PASTEL3:
		_HilColR=200;_HilColG=255;_HilColB=200;
		_OutColR=120;_OutColG=255;_OutColB=120;
		_InColR=130;_InColG=180;_InColB=255;
		_HilRad=9;_OutRad=7;_InRad=5;
		_BmpOn=0;
		break;
	case PTBMP_PASTEL4:
		_HilColR=200;_HilColG=255;_HilColB=200;
		_OutColR=120;_OutColG=255;_OutColB=120;
		_InColR=130;_InColG=250;_InColB=180;
		_HilRad=9;_OutRad=7;_InRad=5;
		_BmpOn=0;
		break;
	case PTBMP_USER0:
		_HilColR=200;_HilColG=255;_HilColB=200;
		_OutColR=120;_OutColG=255;_OutColB=120;
		_InColR=130;_InColG=180;_InColB=255;
		_HilRad=9;_OutRad=7;_InRad=5;
		_BmpOn=0;
		break;
	case PTBMP_USER1:
		_HilColR=200;_HilColG=255;_HilColB=200;
		_OutColR=120;_OutColG=255;_OutColB=120;
		_InColR=130;_InColG=180;_InColB=255;
		_HilRad=9;_OutRad=7;_InRad=5;
		_BmpOn=0;
		break;
	case PTBMP_USER2:
		_HilColR=200;_HilColG=255;_HilColB=200;
		_OutColR=120;_OutColG=255;_OutColB=120;
		_InColR=130;_InColG=180;_InColB=255;
		_HilRad=9;_OutRad=7;_InRad=5;
		_BmpOn=0;
		break;
	case PTBMP_USER3:
		_HilColR=200;_HilColG=255;_HilColB=200;
		_OutColR=120;_OutColG=255;_OutColB=120;
		_InColR=130;_InColG=180;_InColB=255;
		_HilRad=9;_OutRad=7;_InRad=5;
		_BmpOn=0;
		break;
	case PTBMP_USER4:
		_HilColR=200;_HilColG=255;_HilColB=200;
		_OutColR=120;_OutColG=255;_OutColB=120;
		_InColR=130;_InColG=180;_InColB=255;
		_HilRad=9;_OutRad=7;_InRad=5;
		_BmpOn=0;
		break;
	}
}

void BGBmp::ClearData()
{
	// delete _bitmap;
}

void BGBmp::LoadData(int DataID)
{
	switch(DataID){
	case BG_STANDARD0:
		_bitmap= new wxBitmap(bkstandard0_xpm);
		_width=256;_height=192;
		_BgR=240;_BgG=189;_BgB=255;
		break;
	case BG_STANDARD1:
		_bitmap= new wxBitmap(bkstandard1_xpm);
		_width=256;_height=192;
		_BgR=187;_BgG=240;_BgB=240;
		break;
	case BG_STANDARD2:
		_bitmap= new wxBitmap(bkstandard2_xpm);
		_width=256;_height=192;
		_BgR=240;_BgG=240;_BgB=190;
		break;
	case BG_CAT:
		_bitmap= new wxBitmap(bkcat_xpm);
		_width=256;_height=192;
		_BgR=255;_BgG=187;_BgB=206;
		break;
	case BG_STAR:
		_bitmap= new wxBitmap(bkstar_xpm);
		_width=256;_height=192;
		_BgR=0;_BgG=0;_BgB=96;
		break;
	case BG_SKELETON:
		_bitmap= new wxBitmap(bkskeleton_xpm);
		_width=256;_height=192;
		_BgR=0;_BgG=0;_BgB=0;
		break;
	case BG_CINDY:
		_bitmap= new wxBitmap(bkcindy_xpm);
		_width=256;_height=192;
		_BgR=177;_BgG=178;_BgB=198;
		break;
	case BG_KSEG:
		_bitmap= new wxBitmap(bkkseg_xpm);
		_width=256;_height=192;
		_BgR=239;_BgG=239;_BgB=239;
		break;
	case BG_PASTEL:
		_bitmap= new wxBitmap(bkpastel_xpm);
		_width=256;_height=192;
		_BgR=184;_BgG=189;_BgB=255;
		break;
	}
}

