
#include "GCalculation.h"
#include "resource.h"
#include <math.h>


	wxString mMid(wxString &src,int i);
	wxString mMid(wxString &src,int i,int j);
	wxString mLeft(wxString &src,int i);
	bool mStrcmp(wxString src,wxString tgt);
	bool mStrcmp(wxString src,char* tgt);
	bool mAppend(wxString& src,wxString& tgt);

GCalculation gcalbuffer[1000];


GCalculation::GCalculation()
{
}

GCalculation::~GCalculation()
{
}

bool intP(double a)
{
	double b=floor(a+0.0001);
	if(b>a-0.0001 && b<a+0.0001){
		return true;
	}
	else {
		return false;
	}
}

bool GCalculation::Evaluate(double x,double* tgt)
{
	double a1,a2;
	bool b1,b2;
	if(mode==CALC_SUM){
		b1=i1->Evaluate(x,&a1);
		b2=i2->Evaluate(x,&a2);
		*tgt=a1+a2;
		return (b1 && b2);
	}
	else if(mode==CALC_CONST){
		*tgt=input1;
		return true;
	}
	else if(mode==CALC_PROD){
		b1=i1->Evaluate(x,&a1);
		b2=i2->Evaluate(x,&a2);
		*tgt=a1*a2;
		return (b1 && b2);
	}
	else if(mode==CALC_DIV){
		b1=i1->Evaluate(x,&a1);
		b2=i2->Evaluate(x,&a2);
		if(a2==0.0){
			*tgt=0.0;
			return false;
		}
		else {
			*tgt=a1/a2;
			return (b1 && b2);
		}
	}
	else if(mode==CALC_POWER){
		b1=i1->Evaluate(x,&a1);
		b2=i2->Evaluate(x,&a2);
		if(intP(a2)){
			*tgt=pow(a1,a2);
			return (b1 && b2);
		}
		else if(a1>0){
			*tgt=exp(a2*log(a1));
			return (b1 && b2);
		}
		else {
			*tgt=0.0;
			return false;
		}
	}
	else if(mode==CALC_SIN){
		b1=i1->Evaluate(x,&a1);
		*tgt = sin(a1);
		return b1;
	}
	else if(mode==CALC_COS){
		b1=i1->Evaluate(x,&a1);
		*tgt = cos(a1);
		return b1;
	}
	else if(mode==CALC_TAN){
		b1=i1->Evaluate(x,&a1);
		*tgt = tan(a1);
		return b1;
	}
	else if(mode==CALC_LOG){
		b1=i1->Evaluate(x,&a1);
		if(a1>0){
			*tgt = log(a1);
			return b1;
		}
		else {
			return false;
		}
	}
	else if(mode==CALC_VAR){
		*tgt= x;
		return true;
	}
	return false;
}



bool AlphabetP(char c)
{
	if(c=='x' || c=='y'){
		return false;
	}
	if('a'<= c && c<='z'){
		return true;
	}
	if('A'<= c && c<='Z'){
		return true;
	}
	return false;
}

bool NumberP(char* s)
{
	char c=s[0];
	if('0'<= c && c<='9'){
		return true;
	}
	if(c=='+' || c=='-' || c=='.'){
		return true;
	}
	if(c=='e'){
		return true;
	}
	if(s[0]=='p' && s[1]=='i'){
		return true;
	}
	return false;
}

bool NumberDigitP(char* s)
{
	char c=s[0];
	if('0'<= c && c<='9'){
		return true;
	}
	if(c=='.'){
		return true;
	}
	if(c=='e' || c=='p' || c=='i'){
		return true;
	}
	return false;
}

//////////////////


bool ReservedfunctionP(char* s)
{
	if(strlen(s)<3){
		return false;
	}
	if(strncmp(s,"sin",3)==0 || strncmp(s,"cos",3)==0 || strncmp(s,"tan",3)==0 || strncmp(s,"log",3)==0 ){
		return true;
	}
	return false;
}


void GCalculation::Print(int depth)
{
	int i;
	if(mode==CALC_SUM){
		for(i=0;i<depth;i++) {printf("   ");}
		printf("sum {\n");
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i1:\n");
		i1->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i2:\n");
		i2->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("}\n");
	}
	if(mode==CALC_CONST){
		for(i=0;i<depth;i++) {printf("   ");}
		printf("const {\n");
		for(i=0;i<depth;i++) {printf("   ");}
		printf("input1:=%f\n",input1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("}\n");
	}
	if(mode==CALC_PROD){
		for(i=0;i<depth;i++) {printf("   ");}
		printf("prod {\n");
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i1:\n");
		i1->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i2:\n");
		i2->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("}\n");
	}
	if(mode==CALC_DIV){
		for(i=0;i<depth;i++) {printf("   ");}
		printf("div {\n");
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i1:\n");
		i1->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i2:\n");
		i2->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("}\n");
	}
	if(mode==CALC_POWER){
		for(i=0;i<depth;i++) {printf("   ");}
		printf("power {\n");
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i1:\n");
		i1->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i2:\n");
		i2->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("}\n");
	}
	if(mode==CALC_SIN){
		for(i=0;i<depth;i++) {printf("   ");}
		printf("sin {\n");
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i1:\n");
		i1->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("}\n");
	}
	if(mode==CALC_COS){
		for(i=0;i<depth;i++) {printf("   ");}
		printf("cos {\n");
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i1:\n");
		i1->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("}\n");
	}
	if(mode==CALC_TAN){
		for(i=0;i<depth;i++) {printf("   ");}
		printf("tan {\n");
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i1:\n");
		i1->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("}\n");
	}
	if(mode==CALC_LOG){
		for(i=0;i<depth;i++) {printf("   ");}
		printf("log {\n");
		for(i=0;i<depth;i++) {printf("   ");}
		printf("i1:\n");
		i1->Print(depth+1);
		for(i=0;i<depth;i++) {printf("   ");}
		printf("}\n");
	}
	if(mode==CALC_VAR){
		for(i=0;i<depth;i++) {printf("   ");}
		printf("var x\n");
	}
}

int GetFirstMonomial(wxString& str,wxString& ret)
{
	int offset=0;
	char ch;
	char*p=(char*)str.c_str();
	int len=strlen(p);
	int paren=0;
	bool loopon=false;
	do{
		ch=p[offset];
		if(ch=='('){
			paren++;
		}
		if(ch==')'){
			paren--;
			if(paren<0){
				printf("Error\n");
				ret=wxString((wxChar*)"");
				return 128;
			}
		}
		offset++;
		if(paren>0){
			loopon=true;
		}
		else if(offset<=1){
			loopon=true;
		}
		else if(offset>=len){
			loopon=false;
		}
		else if(ch!='+' && ch!='-'){
			loopon=true;
		}
		else if(offset>2 && (ch=='+' || ch=='-') && p[offset-2]=='^'){
			loopon=true;
		}
		else {
			loopon=false;
		}
	} while (loopon);
	if(offset>=len){
		ret=wxString((wxChar*)str.c_str());
		str=wxString((wxChar*)"");
		return 0;
	}
	else {
		ret=mLeft(str,offset-1);
		str=mMid(str,offset-1);
		return 0;
	}
}

int GetFirstVariable(wxString& str,wxString& ret)
{	
//	ret=wxT("");
	wxString ret2=wxString((wxChar*)"");
	char ch;
	int i=0;
	char*p=(char*)str.c_str();
	int len=strlen(p);
	if(p[0]=='+' || p[0]=='-'){
		ret=mLeft(str,1);
		str=mMid(str,1);
		if(GetFirstVariable(str,ret2)){ return 1; }
		mAppend(ret,ret2);
		return 0;
	}
	else if(NumberP(p)){
		do{
			i++;
		} while (NumberDigitP(p+i) && i<len);
		ret=mLeft(str,i);
		str=mMid(str,i);
		p=(char*)str.c_str();
		if(p[0]=='^'){
			ret2=mLeft(str,1);
			mAppend(ret,ret2);
			str = mMid(str,1);
			if(GetFirstVariable(str,ret2)){ return 1; }
			mAppend(ret,ret2);
			return 0;
		}
		else {
			return 0;
		}
	}
	else if(p[0]=='x' || p[0]=='y'){
		if(p[1]!='^'){
			ret=mLeft(str,1);
			str=mMid(str,1);
			return 0;
		}
		else {
			ret=mLeft(str,2);
			str=mMid(str,2);
			if(GetFirstVariable(str,ret2)){ return 1; }
			mAppend(ret,ret2); 
			return 0;
		}
	}
	else if(p[0]=='('){
		i=0;
		int paren=1;
		do{
			i++;
			ch=p[i];
			if(ch=='('){
				paren++;
			}
			else if(ch==')'){
				paren--;
			}
		} while (paren>0);
		if(i+1>=len || p[i+1]!='^'){
			ret=mLeft(str,i+1);
			str=mMid(str,i+1);
			return 0;
		}
		else {
			ret=mLeft(str,i+2);
			str=mMid(str,i+2);
			if(GetFirstVariable(str,ret2)){ return 1; }
			mAppend(ret,ret2); 
			return 0;
		}
	}
	else if(ReservedfunctionP(p)){
		i=3;
		ret=mLeft(str,i);
		str=mMid(str,i);
		if(GetFirstMonomial(str,ret2)){ return 1; }
		mAppend(ret,ret2);
		return 0;
	}
	ret=wxString((wxChar*)"");
	return 1; 
}

int MakeCalcVariable(wxString& str,GCalculation** ret)
{
	wxString str2;
	int i;
	bool err;
	wxString rest;
	char ch;
	char*p=(char*)str.c_str();
	int len=strlen(p);
	if(p[0]=='+'){
		if((*ret=NewGCalculation(CALC_PROD))==NULL){ return 2; }
		if(((*ret)->i1=NewGCalculation(CALC_CONST))==NULL){ return 2;}
		(*ret)->i1->input1=(*ret)->i1->output1=1.0;
		str2=mMid(str,1);
		MakeCalcVariable(str2,&((*ret)->i2));
		return 0;
	}
	else if(p[0]=='-'){
		if((*ret=NewGCalculation(CALC_PROD))==NULL){ return 2; }
		if(((*ret)->i1=NewGCalculation(CALC_CONST))==NULL){return 2;}
		(*ret)->i1->input1=(*ret)->i1->output1=-1.0;
		str2=mMid(str,1);
		MakeCalcVariable(str2,&((*ret)->i2));
		return 0;
	}
	else if(NumberP(p)){
		double value;
		i=0;
		do{
			i++;
		} while (NumberDigitP(p+i) && i<len);
		if(i<len && p[i]=='^'){
			if((*ret=NewGCalculation(CALC_POWER))==NULL){return 2;}
			if(((*ret)->i1=NewGCalculation(CALC_CONST))==NULL){return 2;}
			if(p[0]=='e'){
				(*ret)->i1->input1=(*ret)->i1->output1=2.718281828;
				rest=mMid(str,2);
			}
			else if(p[0]=='p' && p[1]=='i'){
				(*ret)->i1->input1=(*ret)->i1->output1=3.1415926535;
				rest=mMid(str,3);
			}
			else {
				value=atof(p);
				(*ret)->i1->input1=(*ret)->i1->output1=value;
				rest=mMid(str,i+1);
			}
			return MakeCalcVariable(rest,&((*ret)->i2));
		}
		else {
			if((*ret=NewGCalculation(CALC_CONST))==NULL){return 2;}
			if(p[0]=='e'){
				(*ret)->input1=(*ret)->output1=2.718281828;
			}
			else if(p[0]=='p' && p[1]=='i'){
				(*ret)->input1=(*ret)->output1=3.1415926535;
			}
			else {
				value=atof(p);
				(*ret)->input1=(*ret)->output1=value;
			}
			return 0;
		}
	}
	else if(p[0]=='x' || p[0]=='y'){
		if(p[1]!='^'){
			if((*ret=NewGCalculation(CALC_VAR))==NULL){return 2;}
			(*ret)->var=mLeft(str,1);
			return 0;
		}
		else {
			if((*ret=NewGCalculation(CALC_POWER))==NULL){return 2;}
			if(((*ret)->i1=NewGCalculation(CALC_VAR))==NULL){return 2;}
			rest=mMid(str,2);
			return MakeCalcVariable(rest,&((*ret)->i2));
		}
	}
	else if(p[0]=='('){
		i=0;
		int paren=1;
		do{
			i++;
			if(i>=len){
				return 128;
			}
			ch=p[i];
			if(ch=='('){
				paren++;
			}
			else if(ch==')'){
				paren--;
			}
		} while (paren>0);
		if(i+1>=len || p[i+1]!='^'){
			rest=mLeft(str,i+1);
			return MakeCalcMonomial(rest,ret);
		}
		else {			
			if((*ret=NewGCalculation(CALC_POWER))==NULL){return 2;}
			rest=mLeft(str,i+1);
			err = MakeCalcMonomial(rest,&((*ret)->i1));
			rest=mMid(str,i+2);
			err |= MakeCalcVariable(rest,&((*ret)->i2));
			return err;
		}
	}
	else if(ReservedfunctionP(p)){
		if(strncmp(p,"sin",3)==0){
			if((*ret=NewGCalculation(CALC_SIN))==NULL){return 2;}
			rest=mMid(str,3);
			err = MakeCalcMonomial(rest,&((*ret)->i1));
		}
		else if(strncmp(p,"cos",3)==0){
			if((*ret=NewGCalculation(CALC_COS))==NULL){return 2;}
			rest=mMid(str,3);
			err = MakeCalcMonomial(rest,&((*ret)->i1));
		}
		else if(strncmp(p,"tan",3)==0){
			if((*ret=NewGCalculation(CALC_TAN))==NULL){return 2;}
			rest=mMid(str,3);
			err = MakeCalcMonomial(rest,&((*ret)->i1));
		}
		else if(strncmp(p,"log",3)==0){
			if((*ret=NewGCalculation(CALC_LOG))==NULL){return 2;}
			rest=mMid(str,3);
			err = MakeCalcMonomial(rest,&((*ret)->i1));
		}
		else {
			return 4;
		}
		return err;
	}
	return 1;
}

int MakeCalcPolynomial(wxString& str,GCalculation** ret)
{
	wxString tgt=wxString((wxChar*)"");
	bool err;
	if(GetFirstMonomial(str,tgt)) {return 2;}
	char*p=(char*)str.c_str();
	int len=strlen(p);
	if(len==0){
		return MakeCalcMonomial(tgt,ret);
	}
	if((*ret=NewGCalculation(CALC_SUM))==NULL){return 2;}
	err=MakeCalcMonomial(tgt,&((*ret)->i1));
	err|=MakeCalcPolynomial(str,&((*ret)->i2));
	return err;
}

int MakeCalcMonomial(wxString& str,GCalculation** ret)
{
	wxString tgt=wxString((wxChar*)"");
	char c;
	bool err;
	int i;
	int paren;
	char*p=(char*)str.c_str();
	int len=strlen(p);
	bool full_paren=false;
	if(p[0]=='(' && p[len-1]==')'){
		full_paren=true;
		paren=1;
		for(i=1;i<len-1;i++){
			if(p[i]=='('){
				paren++;
			}
			if(p[i]==')'){
				paren--;
			}
			if(paren==0){
				full_paren=false;
				i=len+1;
			}
		}
		if(full_paren){
			str = mMid(str,1,len-2);
			return MakeCalcPolynomial(str,ret);
		}
	}
	if(GetFirstVariable(str,tgt)) {return 2;}
	p=(char*)str.c_str();
	len=strlen(p);
	if(len==0){
		return MakeCalcVariable(tgt,ret);
	}
	else {
		c=p[0];
		if(c=='/' || c=='*'){
			str=mMid(str,1);
		}
		if(c=='/'){
			*ret=NewGCalculation(CALC_DIV);
		}
		else {
			*ret=NewGCalculation(CALC_PROD);
		}
		if(*ret==NULL){return true;}
		err=MakeCalcVariable(tgt,&((*ret)->i1));
		err|=MakeCalcMonomial(str,&((*ret)->i2));
		return err;
	}
}


///////////////////

GCalculation* NewGCalculation(int md)
{
	int i;
	for(i=0;i<1000;i++){
		if(gcalbuffer[i].used==false){
			gcalbuffer[i].mode=md;
			gcalbuffer[i].used=true;
			gcalbuffer[i].i1=NULL;
			gcalbuffer[i].i2=NULL;
			gcalbuffer[i].i3=NULL;
			gcalbuffer[i].i4=NULL;
			gcalbuffer[i].o1=NULL;
			return &(gcalbuffer[i]);
		}
	}
	return NULL;
}

void ClearGcals()
{
	int i;
	for(i=0;i<1000;i++){
		gcalbuffer[i].used=false;
	}
}


void DeleteGCalc(GCalculation* gcal)
{
	if(gcal==NULL){
		return;
	}
	switch(gcal->mode){
	case CALC_SUM:
	case CALC_PROD:
	case CALC_DIV:
	case CALC_POWER:
		DeleteGCalc(gcal->i1);
		DeleteGCalc(gcal->i2);
		gcal->used=false;
		gcal->i1=gcal->i2=NULL;
		break;
	case CALC_SIN:
	case CALC_COS:
	case CALC_TAN:
	case CALC_LOG:
		DeleteGCalc(gcal->i1);
		gcal->used=false;
		gcal->i1=NULL;
		break;
	case CALC_CONST:
	case CALC_VAR:
		gcal->used=false;
		break;
	}
}

void CountChInGraphText(wxString& str,int *x,int *y,int *t,int *comma)
{
	int i;
	wxString ch;
	*x=*y=*t=*comma=0;
	for(i=0;i<(int)str.Length();i++){
		ch=str.Mid(i,1);
		if(ch==wxT("x")){ (*x)++; }
		if(ch==wxT("y")){ (*y)++; }
		if(ch==wxT("t")){ (*t)++; }
		if(ch==wxT(",")){ (*comma)++; }
	}
}

int GetRBInGraphText(wxString& str)
{
	int x,y,t,c;
	CountChInGraphText(str,&x,&y,&t,&c);
	if(c==0){
		return 0;
	}
	else {
		return 1;
	}
}

