#ifndef __GPOINT__
#define __GPOINT__

#include "GObject.h"
#include "Complex.h"

#include "PtBmp.h"

class GPoint :
	public GObject
{
public:
	CComplex xx,yy,zz;
	GPoint(void);
	GPoint(CComplex x,CComplex y,CComplex z);
	GPoint(CComplex a,CComplex b);
	GPoint(double xx, double yy, int rr, int gg, int bb, int radius);
	GPoint(const GPoint& p);
	~GPoint(void);
	GPoint& operator = (const GPoint& p);
	friend bool operator == (GPoint p,GPoint q);
	bool used;
	GPoint* next;
	int ptbmp;
	int phase_max;
	double _name_theta;

	// For Evaluate_MeetCC
	double a11,a12,a21,a22;
	double geom_oldx,geom_oldy;
	double geom_vx,geom_vy;
	double b_a11,b_a12,b_a21,b_a22;
	double b_geom_oldx,b_geom_oldy;
	double b_geom_vx,b_geom_vy;

	CComplex xz(void);
	CComplex yz(void);

	void ClearHilight(void){
		hilighted=false;
		if(next!=NULL){
			next->ClearHilight();
		}
	};
	int NumbOfPt(void);
	void GetAij();
	void PushPointData();
	void PopPointData();
	void SetOffset(int van,int ox,int oy,int vel);
};

#endif
