//
//
//	GText.cpp
//		 by K. Ahara
//

#include "wx/wx.h"
#include "KidsCindyCanvas.h"

void GText::SetOffset(int van,int ox,int oy,int vel)
{
	vanishing=van;
	offsetx=ox;
	offsety=oy;
	velocity=vel;
}

GText* MyCanvas::NewText(wxString s)
{
	int i;
	for(i=0;i<NUM_OF_BUFFER;i++){
		if(textbuffer[i].used==false){
			textbuffer[i].used=true;
			textbuffer[i].str=wxString((wxChar*)s.c_str());
			textbuffer[i].invisible=false;
			textbuffer[i].centered=0;
			textbuffer[i].offsetx=0;
			textbuffer[i].offsety=0;
			textbuffer[i].expand=1.0;
			textbuffer[i].interval=0.2;
			textbuffer[i].ColR=TextColR;
			textbuffer[i].ColG=TextColG;
			textbuffer[i].ColB=TextColB;
			return &(textbuffer[i]);
		}
	}
	return NULL;
}

void MyCanvas::AssignText(GText* tx)
{
	*lasttext = tx;
	lasttext= &(tx->next);
	sheetbuffer[currentSheet].MyText=texts;
	sheetbuffer[currentSheet].MyLastText=lasttext;
}

bool MyCanvas::DeleteAllTexts(GText* p)
{
	int i;
	for(i=0;i<NUM_OF_BUFFER;i++){
		textbuffer[i].used=false;
	}
	return false;
}

bool EvaluateText(GConst* cn,wxString& src, wxString& tgt,bool paren)
{
	int i,j,k;
	GConst* cnp;
	char*p=(char*)src.c_str();
	int len=strlen(p);
	char*buff=new char[len*2];
	char S,Y;
	char Z[256];
	int offset=0;
	tgt=wxT("");
	bool evaluate;
	for(i=0;i<len;i++){
		S=p[i];
		if(S!='{'){
			buff[offset]=S;
			offset++;
		}
		else{
			j=i;
			do{
				i++;
			} while (i<len && p[i]!='}');
			if(i==len || i-j<=2){
				return true;
			}
			else {
				Y=p[i-1];
				for(k=0;k<i-j-2;k++){
					Z[k]=p[k+j+1];
				}
				Z[i-j-2]=0;
				evaluate=false;
				if(Y=='x'){
					wxString strZ=wxString((wxChar*)Z);
					if(FindNameFromCns(cn,strZ,&cnp)){
						if(cnp->POutput!=NULL){
							if(paren){
								buff[offset]='(';
								offset++;
							}
							if(cnp->POutput->xz().realp()){
								sprintf(buff+offset,"%+.4f",cnp->POutput->xz().real());
								offset=strlen(buff);
							}
							else {
								sprintf(buff+offset,"%+.4lf%+.4lfi",cnp->POutput->xz().real(),cnp->POutput->xz().imag());
								offset=strlen(buff);
							}
							if(paren){
								buff[offset]=')';
								offset++;
							}
							evaluate=true;
						}
					}
				}
				if(!evaluate && Y=='y'){
					wxString strZ=wxString((wxChar*)Z);
					if(FindNameFromCns(cn,strZ,&cnp)){
						if(cnp->POutput!=NULL){
							if(paren){
								buff[offset]='(';
								offset++;
							}
							if(cnp->POutput->yz().realp()){
								sprintf(buff+offset,"%+.4f",cnp->POutput->yz().real());
								offset=strlen(buff);
							}
							else {
								sprintf(buff+offset,"%+.4lf%+.4lfi",cnp->POutput->yz().real(),cnp->POutput->yz().imag());
								offset=strlen(buff);
							}
							if(paren){
								buff[offset]=')';
								offset++;
							}
							evaluate=true;
						}
					}
				}
				if(!evaluate && Y=='_'){
					wxString strZ=wxString((wxChar*)Z);
					if(FindNameFromCns(cn,strZ,&cnp)){
						if(cnp->AngleOutput!=NULL){
							if(paren){
								buff[offset]='(';
								offset++;
							}
							if(cnp->AngleOutput->m_angle.realp()){
								sprintf(buff+offset,"%+.4f",cnp->AngleOutput->m_angle.real()*180/3.14159);
								offset=strlen(buff);
							}
							else {
								sprintf(buff+offset,"%+.4lf%+.4lfi",cnp->AngleOutput->m_angle.real()*180/3.14159,cnp->AngleOutput->m_angle.imag()*180/3.14159);
								offset=strlen(buff);
							}
							if(paren){
								buff[offset]=')';
								offset++;
							}
							evaluate=true;
						}
						else if(cnp->BracketOutput!=NULL){
							if(paren){
								buff[offset]='(';
								offset++;
							}
							GBracket* br=cnp->BracketOutput;
							CComplex sxz=br->m_startx/br->m_startz;
							CComplex syz=br->m_starty/br->m_startz;
							CComplex exz=br->m_endx/br->m_endz;
							CComplex eyz=br->m_endy/br->m_endz;
							double s_geomx=sxz.real();
							double s_geomy=syz.real();
							double e_geomx=exz.real();
							double e_geomy=eyz.real();
							double d=sqrt((s_geomx-e_geomx)*(s_geomx-e_geomx)+(s_geomy-e_geomy)*(s_geomy-e_geomy));
							sprintf(buff+offset,"%.4f",d);
							offset=strlen(buff);
							if(paren){
								buff[offset]=')';
								offset++;
							}
							evaluate=true;
						}
					}
				}
			}
		}
	}
	buff[offset]=0;
	tgt=wxString((wxChar*)buff);
	delete buff;
	return false;
}

void AddYenCommaOnText(wxString& src)
{
	int i;
	char*p=(char*)src.c_str();
	int len=strlen(p);
	char* buff=new char[len*2];
	int offset=0;
	for(i=0;i<len;i++){
		if(p[i]==','){
			buff[offset]='\\';offset++;
			buff[offset]=',';offset++;
		}
		else {
			buff[offset]=p[i];offset++;
		}
	}
	buff[offset]=0;
	src = wxString((wxChar*)buff);
	delete buff;
}

void RemoveYenCommaOnText(wxString& src)
{
	int i;
	char*p=(char*)src.c_str();
	int len=strlen(p);
	char* buff=new char[len*2];
	int offset=0;
	for(i=0;i<len;i++){
		if(p[i]=='\\' && p[i+1]==','){
			buff[offset]=',';offset++;
			i++;
		}
		else {
			buff[offset]=p[i];offset++;
		}
	}
	buff[offset]=0;
	src = wxString((wxChar*)buff);
	delete buff;
}

