//
//   KidsCindyFrame.h
//
//

class MyCanvas;

// Define a new frame type: this is going to be our main frame
class MyFrame : public wxFrame
{
public:
    // ctor(s)
    MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size);
	
	wxMenu *menuFile,*menuEdit,*menuMode,*menuSlideShow,*menuTheme,*menuPoint,*menuLine,*menuBG,*menuAngle,*menuAppear,*menuExt;
	wxToolBar *m_tbar1,*m_tbar2;
	bool m_tbar_on;


    // event handlers (these functions should _not_ be virtual)
	void OnSize(wxSizeEvent& event);

	void OnQuit(wxCommandEvent& event);
    void OnClose(wxCloseEvent& event);
    void OnNew(wxCommandEvent& event);
    void OnOpen(wxCommandEvent& event);
    void OnSave(wxCommandEvent& event);
    void OnSaveCsv(wxCommandEvent& event);
    void OnSaveBmp(wxCommandEvent& event);
    void OnLogfile(wxCommandEvent& event);
    void OnAbout(wxCommandEvent& event);
	bool InitToolbarBMP();
	bool RecreateToolbar();
	void enableToolbar();
	MyCanvas   *m_canvas;

	//// Menu.cpp  ////
	void OnThemeStandard(wxCommandEvent& event);
	void OnThemeCat(wxCommandEvent& event);
	void OnThemeStar(wxCommandEvent& event);
	void OnThemeKseg(wxCommandEvent& event);
	void OnThemeCindy(wxCommandEvent& event);
	void OnThemePastel(wxCommandEvent& event);
	void OnThemeSkeleton(wxCommandEvent& event);
	void OnPt0(wxCommandEvent& event);
	void OnPt1(wxCommandEvent& event);
	void OnPt2(wxCommandEvent& event);
	void OnPt3(wxCommandEvent& event);
	void OnPt4(wxCommandEvent& event);
	void OnLn0(wxCommandEvent& event);
	void OnLn1(wxCommandEvent& event);
	void OnLn2(wxCommandEvent& event);
	void OnLn3(wxCommandEvent& event);
	void OnLn4(wxCommandEvent& event);
	void OnBg(wxCommandEvent& event);
	//void OnBg0(wxCommandEvent& event);
	//void OnBg1(wxCommandEvent& event);
	//void OnBg2(wxCommandEvent& event);
	void OnAg0(wxCommandEvent& event);
	void OnAg1(wxCommandEvent& event);
	void OnAg2(wxCommandEvent& event);
	void OnAg3(wxCommandEvent& event);
	void OnAg4(wxCommandEvent& event);
	void OnAppearSelect(wxCommandEvent& event);

	void OnModeMove(wxCommandEvent& event);
	void OnModeSPoint(wxCommandEvent& event);
	void OnModeMLine(wxCommandEvent& event);
	void OnModePara(wxCommandEvent& event);
	void OnModePerp(wxCommandEvent& event);
	void OnModeMid(wxCommandEvent& event);
	void OnModeMCircle(wxCommandEvent& event);
	void OnModeBisector(wxCommandEvent& event);
	void OnModeSelect(wxCommandEvent& event);
	void OnModeMeet(wxCommandEvent& event);
	void OnModeGraph(wxCommandEvent& event);
	void OnModeClipping(wxCommandEvent& event);
	void OnModeAxis(wxCommandEvent& event);
	void OnModeTangent(wxCommandEvent& event);
	void OnModeCircleBy3(wxCommandEvent& event);
	void OnModeText(wxCommandEvent& event);
	void OnModeImage(wxCommandEvent& event);
	void OnModeCompass(wxCommandEvent& event);
	void OnModeUndo(wxCommandEvent& event);
	void OnModeRedo(wxCommandEvent& event);
	void OnModeOrbit(wxCommandEvent& event);
	void OnModeInvisible(wxCommandEvent& event);
	void OnModeZoomIn(wxCommandEvent& event);
	void OnModeZoomOut(wxCommandEvent& event);
	void OnModeAngle(wxCommandEvent& event);
	void OnModeBracket(wxCommandEvent& event);
	void OnModeLineWithAngle(wxCommandEvent& event);
	void OnModeEraser(wxCommandEvent& event);
	void OnProperty(wxCommandEvent& event);


	void OnIdModeTangent(wxCommandEvent& event);
	void OnIdModeCircleBy3(wxCommandEvent& event);

	void OnCloneOn(wxCommandEvent& event);
	void OnEditText(wxCommandEvent& event);
	void OnSlideShowProperty(wxCommandEvent& event);
	void OnNextSheet(wxCommandEvent& event);
	void OnPrevSheet(wxCommandEvent& event);
	void OnInsertNew(wxCommandEvent& event);
	void OnInsertCopyFigure(wxCommandEvent& event);
	void OnInsertCopyAll(wxCommandEvent& event);
	void OnDeleteSheet(wxCommandEvent& event);
	void OnBenchMark(wxCommandEvent& event);

	void OnGModeCindy(wxCommandEvent& event);
	void OnGModeKseg(wxCommandEvent& event);
	void OnGModePanel(wxCommandEvent& event);
	void OnSlideShowStart(wxCommandEvent& event);

//	void OnUpdateModeSelect(wxUpdateUIEvent& event);
//	void OnToolLeftClick(wxCommandEvent& event);

	// Printing.cpp
	void InitPrintData();
	void DeletePrintData();
	void OnPrint(wxCommandEvent& event);
    void OnPrintPreview(wxCommandEvent& event);
    void OnPageSetup(wxCommandEvent& event);
	//// wxKidsCindy.cpp ////

private:
    // any class wishing to process wxWidgets events must use this macro
    DECLARE_EVENT_TABLE()
};

