//
//	lbutton.cpp
//
//

#include <math.h>
#include "wx/wx.h"
#include "wx/string.h"
#include "wx/timer.h"
#include "KidsCindyCanvas.h"
#include "KidsCindyFrame.h"
#include "resource.h"
#include "Meet.h"
#include "GConst.h"
#include "incident.h"
#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif


double abs(double a);

bool MyCanvas::next_name(wxString& tgt)
{
	GConst* cnp;
	do{
		if(next_name_sub(tgt)) return true;
	} while (FindNameFromCns(cns,tgt,&cnp));
	return false;
}

bool MyCanvas::next_name_sub(wxString& tgt)
{
	char c,d;
	char* p=(char*)tgt.c_str();
	int tgtlen=strlen(p);
	if(mStrcmp(tgt,"ZZZ")){
		tgt=wxString((wxChar*)"A");return false;
	}
	else if(mStrcmp(tgt,"zzz")){
		tgt=wxString((wxChar*)"a");return false;
	}
	else if(mStrcmp(tgt,"SZZ")){
		tgt=wxString((wxChar*)"TA");return false;
	}
	else if(tgtlen<=1){
		c=p[0];
		if((c>='A' && c<'Z') || (c>='a' && c<'z')){
			p[0]++;p[1]=0;
			tgt=wxString((wxChar*)p);
		}
		else if(c=='Z'){
			tgt=wxString((wxChar*)"AA");return false;
		}
		else if(c=='z'){
			tgt=wxString((wxChar*)"aa");return false;
		}
		return false;
	}
	else {
		c=p[tgtlen-1];
		d=p[tgtlen-2];
		if((c>='0' && c<'9') || (c>='A' && c<'Z') || (c>='a' && c<'z')){
			p[tgtlen-1]++;p[tgtlen]=0;
			tgt=wxString((wxChar*)p);
		}
		else if(c=='9'){
			p[tgtlen-2]++;p[tgtlen-1]='0';p[tgtlen]=0x00;
			tgt=wxString((wxChar*)p);
		}
		else if(c=='Z'){
			p[tgtlen-2]++;p[tgtlen-1]='A';p[tgtlen]=0x00;
			tgt=wxString((wxChar*)p);
		}
		else if(c=='z'){
			p[tgtlen-2]++;p[tgtlen-1]='a';p[tgtlen]=0x00;
			tgt=wxString((wxChar*)p);
		}
		else {
			//tgt=tgt.Left(tgtlen-2)+wxString::SetChar(1,tgt.GetChar(1)+1);
			return true;
		}
	}
	return false;
}

void MyCanvas::ResetAllName()
{
	last_pt_name=wxString((wxChar*)"ZZZ");
	next_name(last_pt_name);
	last_ln_name=wxString((wxChar*)"zzz");
	next_name(last_ln_name);
	last_ci_name=wxString((wxChar*)"C0");
	next_name(last_ci_name);
	last_curve_name=wxString((wxChar*)"x0");
	next_name(last_curve_name);
	last_text_name=wxString((wxChar*)"SZZ");
	next_name(last_text_name);
	last_ag_name=wxString((wxChar*)"ag0");
	next_name(last_ag_name);
	last_im_name=wxString((wxChar*)"im0");
	next_name(last_im_name);
	last_br_name=wxString((wxChar*)"br0");
	next_name(last_br_name);
}

void MyCanvas::SetPointName(GPoint* ptp)
{
	ptp->_name=wxString((wxChar*)last_pt_name.c_str());
	next_name(last_pt_name);
	ptp->_fontsize=DefaultFontSize;
	ptp->_name_theta=0.0;
}

void MyCanvas::SetCircleName(GCircle* cip)
{
	cip->_name=wxString((wxChar*)last_ci_name.c_str());
	next_name(last_ci_name);
}

void MyCanvas::SetBracketName(GBracket* brp)
{
	brp->_name=wxString((wxChar*)last_br_name.c_str());
	next_name(last_br_name);
}

void MyCanvas::LButtonDown(wxPoint &point)
{
	//printf("LButtonDown :\n");
	m_lbuttondown=true;
	if(SMode){
		if(anim_wait==true){
			//printf("LButtonDown : anim_wait==true\n");
			anim_wait=false;
			if(anim_cn==NULL){
				//printf("LButtonDown : anim_cn==NULL\n");
				for(GConst* cnp=cns;cnp!=NULL;cnp=cnp->next){
					switch(cnp->Const_Type){
					case CONST_EFFECT_POINT:
						cnp->anim_entry->POutput->offsetx=0;
						cnp->anim_entry->POutput->offsety=0;
						cnp->anim_entry->POutput->vanishing=0;
						break;
					case CONST_EFFECT_LINE:
						cnp->anim_entry->LOutput->offsetx=0;
						cnp->anim_entry->LOutput->offsety=0;
						cnp->anim_entry->LOutput->vanishing=0;
						break;
					case CONST_EFFECT_TEXT:
						cnp->anim_entry->TextOutput->offsetx=0;
						cnp->anim_entry->TextOutput->offsety=0;
						cnp->anim_entry->TextOutput->vanishing=0;
						break;
					case CONST_EFFECT_CIRCLE:
						cnp->anim_entry->COutput->offsetx=0;
						cnp->anim_entry->COutput->offsety=0;
						cnp->anim_entry->COutput->vanishing=0;
						break;
					case CONST_EFFECT_CURVE:
						break;
					case CONST_EFFECT_ANGLE:
						cnp->anim_entry->AngleOutput->offsetx=0;
						cnp->anim_entry->AngleOutput->offsety=0;
						cnp->anim_entry->AngleOutput->vanishing=0;
						break;
					case CONST_EFFECT_IMAGE:
						cnp->anim_entry->ImageOutput->offsetx=0;
						cnp->anim_entry->ImageOutput->offsety=0;
						cnp->anim_entry->ImageOutput->vanishing=0;
						break;
					case CONST_EFFECT_BRACKET:
						cnp->anim_entry->BracketOutput->offsetx=0;
						cnp->anim_entry->BracketOutput->offsety=0;
						cnp->anim_entry->BracketOutput->vanishing=0;
						break;
					}
				}
				if(NextSheet()){
					anim_cn=NULL;
					SlideShowStart(cns);
				}
				else {
					SMode=false;
					anim_wait=true;
					anim_cn=NULL;
					wxMessageBox(EndSlideShow,wxT(""),wxOK | wxICON_INFORMATION, this);
				}
			}
			else {
				//printf("Next\n");
				Refresh(false);
			}
		}
	}
	else if(GMode==MODE_CINDY){
		switch(DocMode){
		case MODE_MOVE:
			LDown_Move(point);break;
		case MODE_SINGLE_ADD:
			LDown_SPoint(point);break;
		case MODE_MULTI_LINE:
			LDown_MLine(point);break;
		case MODE_PARALLEL:
			LDown_Para(point);break;
		case MODE_PERP:
			LDown_Perp(point);break;
		case MODE_MID:
			LDown_Mid(point);break;
		case MODE_MULTI_CIRCLE:
			LDown_MCircle(point);break;
		case MODE_BISECTOR:
			LDown_Bisector(point);break;
		case MODE_LINE_WITH_ANGLE:
			LDown_LineWithAngle(point);break;
		case MODE_BRACKET:
			LDown_Bracket(point);break;
		}
	}
	else if(GMode==MODE_KSEG){
		DocMode=MODE_MOVE;
		LDown_Move(point);
	}
}

void MyCanvas::LButtonDrag(wxPoint &point)
{
	if(SMode){
		return ;
	}
	if(GMode==MODE_CINDY){
		switch(DocMode){
		case MODE_MOVE:
			LDrag_Move(point);break;
		case MODE_SINGLE_ADD:
		case MODE_MULTI_LINE:
		case MODE_PARALLEL:
		case MODE_PERP:
		case MODE_MID:
		case MODE_MULTI_CIRCLE:
		case MODE_LINE_WITH_ANGLE:
		case MODE_BRACKET:
			LDrag_Point(point);break;
		}
	}
	else if(GMode==MODE_KSEG){
//		DocMode=MODE_MOVE;
		LDrag_Move(point);
	}
}

void MyCanvas::LButtonUp(wxPoint &point)
{
	m_lbuttondown=false;
	if(SMode){
		return ;
	}
	if(GMode==MODE_CINDY){
		switch(DocMode){
		case MODE_MOVE:
			LUp_Move(point);break;
		case MODE_SINGLE_ADD:
			LUp_SPoint(point);break;
		case MODE_MULTI_LINE:
			LUp_MLine(point);break;
		case MODE_PARALLEL:
			LUp_Para(point);break;
		case MODE_PERP:
			LUp_Perp(point);break;
		case MODE_MID:
			LUp_Mid(point);break;
		case MODE_MULTI_CIRCLE:
			LUp_MCircle(point);break;
		case MODE_BISECTOR:
			LUp_Bisector(point);break;
		case MODE_SELECT:
			LUp_Select(point);break;
		case MODE_TANGENT:
			LUp_Tangent(point);break;
		case MODE_TEXT:
			LUp_Text(point);break;
		case MODE_IMAGE:
			LUp_Image(point);break;
		case MODE_COMPASS:
			LUp_Compass(point);break;
		case MODE_ORBIT:
			LUp_Orbit(point);break;
		case MODE_CIRCLE_BY_3:
			LUp_CircleBy3(point);break;
		case MODE_ANGLE:
			LUp_Angle(point);break;
		case MODE_LINE_WITH_ANGLE:
			LUp_LineWithAngle(point);break;
		case MODE_BRACKET:
			LUp_Bracket(point);break;
		}
	}
	else if(GMode==MODE_KSEG){
		LUp_Move(point);
		LUp_Select(point);
		m_owner->enableToolbar();
	}
	else if(GMode==MODE_PANEL){
		wxRect PShift=wxRect(0,relRect.GetHeight()-32,64,32);
		wxRect PAdd=wxRect(64,relRect.GetHeight()-32,64,32);
		wxRect PMove=wxRect(128,relRect.GetHeight()-32,64,32);
		if(PShift.Inside(point)){
			PanelShift = !PanelShift;
		}
		else if(PAdd.Inside(point)){
			PanelAdd = !PanelAdd;
		}
		else if(PMove.Inside(point)){
			PanelMove = !PanelMove;
			PanelDragPoint=PanelDragText=PanelDragPointName=false;
		}
		else {
			if(PanelMove){
				if(!PanelDragPoint && !PanelDragText && !PanelDragPointName){
					ShiftLButton=PanelShift;
					LDown_Move(point);
				}
				else {
					m_move_dragging=PanelDragPoint;
					m_text_dragging=PanelDragText;
					m_ptname_dragging=PanelDragPointName;
					ShiftLButton=PanelShift;
					LDrag_Move(point);
					LUp_Move(point);
					PanelDragPoint=PanelDragText=PanelDragPointName=false;
				}
			}
			else if(PanelAdd){
				if(!KSEGtexton && !KSEGimageon){
					ShiftLButton=PanelShift;
					LDown_SPoint(point);
					LDrag_Point(point);
					LUp_SPoint(point);
					m_owner->enableToolbar();
				}
				else if(KSEGtexton){
					LUp_Text(point);
				}
				else {
					LUp_Image(point);
				}
			}
			else{
				ShiftLButton=PanelShift;
				LUp_Select(point);
				m_owner->enableToolbar();
			}

		}
	}
	Refresh(false);
}

void MyCanvas::LeaveWindow(wxMouseEvent &event)
{
	if(m_lbuttondown){
		LButtonUp(currentpoint);
	}
	if(m_rbuttondown){
		RButtonUp(currentpoint);
	}
}

void MyCanvas::LDown_Move(wxPoint& point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	//printf("LDown_Move : start \n");
	if(m_move_dragging = NearPoint(pts,&geomx,&geomy,&moved_point)){
		mspointx=moved_point->xz().real()-geomx;
		mspointy=moved_point->yz().real()-geomy;
		wxStartTimer();
		if(CloneOnOff){
			OnCloneOn();
		}
		PanelDragPoint=true;
		for(GPoint* ptp=pts;ptp!=NULL;ptp=ptp->next){
			ptp->a11=ptp->a12=ptp->a21=ptp->a22=0.0;
		}
	}
	if(!ShiftLButton){
		ClearAllHilights();
	}
	if(moved_point!=NULL){
		Sethilighted(moved_point);
	}
	if(!m_move_dragging){
		if(Snap2Text(texts,point.x,point.y)){
			PanelDragText=m_text_dragging=true;
			cursortext->hilighted=true;
		}
		else if((m_image_dragging=Snap2Image(ims,point.x,point.y))>0){
			//printf("LDown_Move : m_image_dragging=%d\n",m_image_dragging);
			//PanelDragImage=m_image_dragging=true;
			cursorim->hilighted=true;
		}
		else if(m_bracket_dragging=Snap2Bracket(brs,geomx,geomy)){
			Sethilighted(cursorbr);
		}
		else if(ShiftLButton && Snap2PtName(pts,point.x,point.y)){
			PanelDragPointName=m_ptname_dragging=true;
		}
	}
}

void MyCanvas::LDrag_Move(wxPoint &point)
{
	//printf("LDrag_Move:start\n");
	double geomx=geomcx+(point.x-centerx)*geomperdot+mspointx;
	double geomy=geomcy-(point.y-centery)*geomperdot+mspointy;
	if(m_move_dragging){
		GConst *cnp,*cnq;
		if(wxGetElapsedTime(false)>200){
			if(CloneOnOff){
				copyToPClone(pts3,pts2);
				copyToPClone(pts2,pts1);
				copyToPClone(pts1,pts);
				copyToLClone(lns3,lns2);
				copyToLClone(lns2,lns1);
				copyToLClone(lns1,lns);
				copyToCClone(cis3,cis2);
				copyToCClone(cis2,cis1);
				copyToCClone(cis1,cis);
				Refresh(false);
			}
			else if((ThemeMode==THM_STANDARD || ThemeMode==THM_CAT || ThemeMode==THM_STAR || ThemeMode==THM_SKELETON) && NOhilightedPoints>0){
				Refresh(false);
			}
			wxStartTimer();
		}
		if(FindPtFromCn(cns,moved_point,&cnp)){
			if(cnp->Const_Type==CONST_FREE){
				moved_point->xx = CComplex(geomx,0.0);
				moved_point->yy = CComplex(geomy,0.0);
				moved_point->zz = CComplex(1.0,0.0);
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_ON_LINE){
				CComplex ax=cnp->PInput1->xz() - CComplex(geomx,0.0);
				CComplex ay=cnp->PInput1->yz() - CComplex(geomy,0.0);
				CComplex bx=cnp->PInput2->xz() - CComplex(geomx,0.0);
				CComplex by=cnp->PInput2->yz() - CComplex(geomy,0.0);
				CComplex ss=(ax*(ax-bx)+ay*(ay-by))/((ax-bx)*(ax-bx)+(ay-by)*(ay-by));
				cnp->para1=ss;
				cnp->para2=CComplex(1.0,0.0) - ss;
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_PARA){
				CComplex ax=cnp->PInput1->xz() - CComplex(geomx,0.0);
				CComplex ay=cnp->PInput1->yz() - CComplex(geomy,0.0);
				CComplex bx=cnp->LInput1->yy;
				CComplex by=cnp->LInput1->xx * CComplex(-1.0,0.0);
				CComplex ss=(ax*bx+ay*by)/(bx*bx+by*by);
				cnp->para1=ss;
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_PERP){
				CComplex ax=cnp->PInput1->xz() - CComplex(geomx,0.0);
				CComplex ay=cnp->PInput1->yz() - CComplex(geomy,0.0);
				CComplex bx=cnp->LInput1->xx * CComplex(-1.0,0.0);
				CComplex by=cnp->LInput1->yy * CComplex(-1.0,0.0);
				CComplex ss=(ax*bx+ay*by)/(bx*bx+by*by);
				cnp->para1=ss;
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_CIRCLE){
				double vx=geomx - cnp->CInput1->xx.real();	
				double vy=geomy - cnp->CInput1->yy.real();
				double theta = atan2(-vy,vx);
				double theta0 = cnp->para1.real();
				if(theta0+5.28 < theta && theta < theta0+7.28){
					theta0 +=6.28;
				}
				if(theta0-5.28 > theta && theta > theta0-7.28){
					theta0 -=6.28;
				}
				double thetastep=0.3;
				if(theta0>theta){
					for(double thp=theta0-thetastep;thp>=theta+thetastep;thp-=thetastep){
						cnp->para1=CComplex(thp,0.0);
						EvaluateConst(cns);
					}
				}
				else {
					for(double thp=theta0+thetastep;thp<=theta-thetastep;thp+=thetastep){
						cnp->para1=CComplex(thp,0.0);
						EvaluateConst(cns);
					}
				}
				cnp->para1=CComplex(theta,0.0);
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_CURVE){
				double g1x,g1y,g2x,g2y;
				double x0,y0,t=0.0;
				bool snap=false;
				int i;
				g1x=cnp->CurveInput1->orbitx[0];
				g1y=cnp->CurveInput1->orbity[0];
				for(i=1;i<cnp->CurveInput1->orbit_len && !snap;i++){
					g2x=cnp->CurveInput1->orbitx[i];
					g2y=cnp->CurveInput1->orbity[i];
					if(g1x!=g2x || g1y!=g2y){
						t = ((geomx-g1x)*(g2x-g1x)+(geomy-g1y)*(g2y-g1y)) / ((g2x-g1x)*(g2x-g1x)+(g2y-g1y)*(g2y-g1y));
						x0 = g1x*(1-t)+g2x*t;
						y0 = g1y*(1-t)+g2y*t;
						if(t>=0.0 && t<1.0 && (x0- geomx)*(x0 - geomx)+(y0 - geomy)*(y0 - geomy) < snapradius2*10  && cnp->CurveInput1->invisible==false){
							snap=true;
						}
					}
					g1x=g2x;g1y=g2y;
				}
				if(snap){
					cnp->para1=CComplex(1.0*(i-2)+t,0.0);
				}
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_3P_BISECTOR){
				double g1x=cnp->PInput1->xz().real();
				double g1y=cnp->PInput1->yz().real();
				double g2x=cnp->PInput2->xz().real();
				double g2y=cnp->PInput2->yz().real();
				double g3x=cnp->PInput3->xz().real();
				double g3y=cnp->PInput3->yz().real();
				double norm12 = sqrt((g1x-g2x)*(g1x-g2x)+(g1y-g2y)*(g1y-g2y));
				double norm32 = sqrt((g3x-g2x)*(g3x-g2x)+(g3y-g2y)*(g3y-g2y));
				if(norm12<0.0001){
					norm12=1.0;
					g1x=g2x+1.0;
					g1y=g2y;
				}
				if(norm32<0.0001){
					norm32=1.0;
					g3x=g2x;
					g3y=g2y+1.0;
				}
				g1x=g2x + (g1x-g2x)/norm12;
				g1y=g2y + (g1y-g2y)/norm12;
				g3x=g2x + (g3x-g2x)/norm32;
				g3y=g2y + (g3y-g2y)/norm32;
				double g4x = (g1x+g3x)*0.5 - g2x;
				double g4y = (g1y+g3y)*0.5 - g2y;
				double norm4 = sqrt(g4x*g4x+g4y*g4y);
				if(norm4!=0){
					g4x/=norm4;
					g4y/=norm4;
				}
				else {
					g4x = g1y-g3y;
					g4y = - g1x+g3x;
					norm4 = sqrt(g4x*g4x+g4y*g4y);
					g4x/=norm4;
					g4y/=norm4;
				}
				double para;
				if(g4y==0.0){
					para = (geomx - g2x) / g4x;
				}
				else {
					para = (geomy - g2y) / g4y;
				}
				cnp->para1=CComplex(para,0.0);
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_BISECTOR){
				GLine* ln1=cnp->LInput1;
				GLine* ln2=cnp->LInput2;
				CComplex g1x = ln1->yy * ln2->zz -  ln1->zz * ln2->yy;
				CComplex g1y = ln1->zz * ln2->xx -  ln1->xx * ln2->zz;
				CComplex g1z = ln1->xx * ln2->yy -  ln1->yy * ln2->xx;
				CComplex g2x = sqrtC(ln2->xx * ln2->xx + ln2->yy * ln2->yy) * ln1->xx + cnp->para1 * sqrtC(ln1->xx * ln1->xx + ln1->yy * ln1->yy) * ln2->xx;
				CComplex g2y = sqrtC(ln2->xx * ln2->xx + ln2->yy * ln2->yy) * ln1->yy + cnp->para1 * sqrtC(ln1->xx * ln1->xx + ln1->yy * ln1->yy) * ln2->yy;
				if(g1z==CComplex(0.0,0.0)){
					cnp->para2=CComplex(0.0,0.0);
				}
				else {
					CComplex ax= CComplex(geomx,0.0) - g1x / g1z;
					CComplex ay= CComplex(geomy,0.0) - g1y / g1z;
					CComplex by= g2x;
					CComplex bx= g2y;
					CComplex nn = sqrtC(g2x * g2x + g2y * g2y);
					bx /= nn;
					by /= nn;
					CComplex ss=(ax*bx+ay*by);
					cnp->para2=ss;
				}
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_TANGENT){
				CComplex ax=cnp->PInput1->xz() - CComplex(geomx,0.0);
				CComplex ay=cnp->PInput1->yz() - CComplex(geomy,0.0);
				CComplex bx=(cnp->CInput1->yy - cnp->PInput1->yz()) * CComplex(-1.0,0.0) ;
				CComplex by=(cnp->CInput1->xx - cnp->PInput1->xz());
				CComplex ss=(ax*bx+ay*by)/(bx*bx+by*by);
				cnp->para1=ss;
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_CURVE_TANGENT){
				FindCurveTangentFromCns(cns,cnp->CurveInput1,cnp->PInput1,&cnq);
				CComplex ax=cnp->PInput1->xz() - CComplex(geomx,0.0);
				CComplex ay=cnp->PInput1->yz() - CComplex(geomy,0.0);
				CComplex bx= cnq->LOutput->yy * CComplex(-1.0,0.0) ;
				CComplex by= cnq->LOutput->xx ;
				CComplex ss=(ax*bx+ay*by)/(bx*bx+by*by);
				cnp->para1=ss;
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_LINE_WITH_ANGLE){
				// direction vector(dx,dy)
				double theta=(cnp->AngleInput1->m_angle.real());
				//printf("Debug : LDrag_Move: CONST_PT_ON_LINE_WITH_ANGLE: theta=%f\n",theta);
				CComplex dx=cnp->LInput1->yy*CComplex(cos(theta),0.0)+cnp->LInput1->xx*CComplex(sin(theta),0.0);
				CComplex dy=cnp->LInput1->yy*CComplex(sin(theta),0.0)-cnp->LInput1->xx*CComplex(cos(theta),0.0);
				CComplex ax= cnp->PInput1->xz() - CComplex(geomx,0.0) ;
				CComplex ay= cnp->PInput1->yz() - CComplex(geomy,0.0);
				cnp->para1 = CComplex(-1.0,0.0)*(ax*dx+ay*dy)/(dx*dx+dy*dy);
				EvaluateConst(cns);
				redraw=true;
			}
			else if(cnp->Const_Type==CONST_PT_ON_LINE_WITH_ANGLE_DEGREE){
				// direction vector(dx,dy)
				double theta=cnp->para1.real()*3.1415926535/180;
				CComplex dx=cnp->LInput1->yy*CComplex(cos(theta),0.0)+cnp->LInput1->xx*CComplex(sin(theta),0.0);
				CComplex dy=cnp->LInput1->yy*CComplex(sin(theta),0.0)-cnp->LInput1->xx*CComplex(cos(theta),0.0);
				CComplex ax= cnp->PInput1->xz() - CComplex(geomx,0.0);
				CComplex ay= cnp->PInput1->yz() - CComplex(geomy,0.0);
				cnp->para2 =CComplex(-1.0,0.0)*(ax*dx+ay*dy)/(dx*dx+dy*dy);
				EvaluateConst(cns);
				redraw=true;
			}
		}
	}
	else if(m_text_dragging){
		cursortext->tx=1.0*(point.x-cursortext->m_text_dragging_h_length);
		cursortext->ty=1.0*(point.y-cursortext->m_text_dragging_h_height);
		redraw=true;
	}
	else if(m_image_dragging==1){
		//printf("LDrag_Move: cursorim=%d\n",(int)cursorim);
		cursorim->m_x = point.x - cursorim->m_image_drag_x;
		cursorim->m_y = point.y - cursorim->m_image_drag_y;
		redraw=true;
	}
	else if(m_image_dragging==2){
		cursorim->m_w -= (point.x - cursorim->m_image_drag_x - cursorim->m_x);
		cursorim->m_h -= (point.y - cursorim->m_image_drag_y - cursorim->m_y);
		cursorim->m_x = point.x - cursorim->m_image_drag_x;
		cursorim->m_y = point.y - cursorim->m_image_drag_y;
		wxImage tmpimg=wxImage(cursorim->m_image);
		cursorim->m_bmp=wxBitmap(tmpimg.Rescale(cursorim->m_w,cursorim->m_h));
	}
	else if(m_image_dragging==3){
		cursorim->m_w -= (point.x - cursorim->m_image_drag_x - cursorim->m_x);
		cursorim->m_h = point.y - cursorim->m_image_drag_y - cursorim->m_y;
		cursorim->m_x = point.x - cursorim->m_image_drag_x;
		wxImage tmpimg=wxImage(cursorim->m_image);
		cursorim->m_bmp=wxBitmap(tmpimg.Rescale(cursorim->m_w,cursorim->m_h));
	}
	else if(m_image_dragging==4){
		cursorim->m_w = point.x - cursorim->m_image_drag_x - cursorim->m_x;
		cursorim->m_h -= (point.y - cursorim->m_image_drag_y - cursorim->m_y);
		cursorim->m_y = point.y - cursorim->m_image_drag_y;
		wxImage tmpimg=wxImage(cursorim->m_image);
		cursorim->m_bmp=wxBitmap(tmpimg.Rescale(cursorim->m_w,cursorim->m_h));
	}
	else if(m_image_dragging==5){
		cursorim->m_w = point.x - cursorim->m_image_drag_x - cursorim->m_x;
		cursorim->m_h = point.y - cursorim->m_image_drag_y - cursorim->m_y;
		wxImage tmpimg=wxImage(cursorim->m_image);
		cursorim->m_bmp=wxBitmap(tmpimg.Rescale(cursorim->m_w,cursorim->m_h));
	}
	else if(m_bracket_dragging){
		CComplex sxz=cursorbr->m_startx/cursorbr->m_startz;
		CComplex syz=cursorbr->m_starty/cursorbr->m_startz;
		CComplex exz=cursorbr->m_endx/cursorbr->m_endz;
		CComplex eyz=cursorbr->m_endy/cursorbr->m_endz;
		double s_geomx=sxz.real();
		double s_geomy=syz.real();
		double e_geomx=exz.real();
		double e_geomy=eyz.real();
		double ax=0.5*(s_geomx+e_geomx);
		double ay=0.5*(s_geomy+e_geomy);
		double d2=(s_geomx-e_geomx)*(s_geomx-e_geomx)+(s_geomy-e_geomy)*(s_geomy-e_geomy);
		double n2=-(geomx-ax)*(s_geomy-e_geomy)+(geomy-ay)*(s_geomx-e_geomx);
		double h;
		h=n2/d2;
		//printf("h=%f\n",h);
		if(h>-0.5 && h<0.5){
			cursorbr->m_bracket_height =h;
		}
	}
	else if(m_ptname_dragging){
		int dispx= centerx + (int)floor((cursorpt->xz().real()-geomcx)/geomperdot);
		int dispy= centery - (int)floor((cursorpt->yz().real()-geomcy)/geomperdot);
		cursorpt->_name_theta = atan2(-point.y+dispy,point.x-dispx);
		redraw=true;
	}
}

void MyCanvas::LUp_Move(wxPoint &point)
{
	if(m_move_dragging){
		m_move_dragging= false;
		if(CloneOnOff){
			OnCloneOff();
		}
	}
	if(!ShiftLButton && pts!=NULL){
		pts->ClearHilight();
	}
	if(moved_point!=NULL){
		Sethilighted(moved_point);
	}
	moved_point=NULL;
	m_text_dragging=m_angle_dragging=m_bracket_dragging=false;
	m_image_dragging=0;
	m_ptname_dragging=false;
	cursortext=NULL;
}

void MyCanvas::LDown_SPoint(wxPoint &point)
{
	if(!ShiftLButton){
		ClearAllHilights();
	}
	double startgeomx=geomcx+(point.x-centerx)*geomperdot;
	double startgeomy=geomcy-(point.y-centery)*geomperdot;
	ConstFree(startgeomx,startgeomy,true);
	m_point_dragging = true;
	snapped2pt=snapped2ln=snapped2ci=snapped2curve=snapped2ag=snapped2br=false;
	startpt=NULL;
	Refresh(false);
}

void MyCanvas::LDrag_Point(wxPoint &point)
{
	if(!m_point_dragging){ return ; }
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint *pt1;
	snapped2pt=Snapping(pts,&geomx,&geomy,&pt1);
	snapped2ln=Snap2Line(lns,&geomx,&geomy);
	PtDragHilight(lns,geomx,geomy);
	snapped2ci=Snap2Circle(cis,&geomx,&geomy);
	PtDragHilight(cis,geomx,geomy);
	snapped2curve=Snap2Curve(curves,&geomx,&geomy);
	PtDragHilight(curves,geomx,geomy);
	PtDragHilight(pts,geomx,geomy);
	cursorpt->xx.SetComplex(geomx,0.0);
	cursorpt->yy.SetComplex(geomy,0.0);
	EvaluateConst(cns);
	redraw=true;
}

enum{
	LUP_ERROR,
	LUP_ON_POINT,
	LUP_ON_STARTPOINT,
	LUP_ON_LINE,
	LUP_MEET_LL,
	LUP_MEET_LC,
	LUP_ON_CIRCLE,
	LUP_MEET_CC,
	LUP_ON_CURVE,
	LUP_NO_SNAPPING
};

int MyCanvas::LUp_Point(double* geomx,double* geomy)
{
	int lncount,cicount,cucount;
	GPoint* pt1;
	GLine *ln1,*ln2;
	GCircle *ci1,*ci2;
	GParaCurve *cu1,*cu2;
	m_point_dragging = false;
	if(snapped2pt){//
		Snapping(pts,geomx,geomy,&pt1);
		DeletePtFromCn(&(cns),cursorpt);
		if(pt1!=startpt){
			return LUP_ON_POINT;
		}
		else {
			return LUP_ON_STARTPOINT;
		}
	}		
	else if(snapped2ln){ // on a line
		lncount= Snap2LineEx(lns,geomx,geomy,&ln1,&ln2);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		if(snapped2ci && lncount==1){ //case 3
			Snap2CircleEx(cis,geomx,geomy,&ci1,&ci2);
			if(ci1==NULL){
				printf("Debug: LUp_SPoint: error case.\n");
				return LUP_ERROR;
			}
			ConstMeet(ci1,ln1,*geomx,*geomy);
			return LUP_MEET_LC;
		}
		else if(lncount==1){ // case 1
			ConstOnLine(ln1);
			return LUP_ON_LINE;
		}
		else if(lncount==2){ // case 2
			ConstMeet(ln1,ln2);
			return LUP_MEET_LL;
		}
		else { //
			printf("Debug: LUp_SPoint: error case.\n");
			return LUP_ERROR;
		}
	}
	else if(snapped2ci){
		cicount= Snap2CircleEx(cis,geomx,geomy,&ci1,&ci2);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		if(cicount==1){ // 
			ConstOnCircle(ci1);
			return LUP_ON_CIRCLE;
		}
		else if(cicount==2){
			ConstMeet(ci1,ci2,*geomx,*geomy);
			return LUP_MEET_CC;
		}
		else {
			printf("Debug: LUp_SPoint: error case.\n");
			return LUP_ERROR;
		}
	}
	else if(snapped2curve){
		cucount= Snap2CurveEx(curves,geomx,geomy,&cu1,&cu2);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		if(cucount>=1){ // 
			ConstOnCurve(cu1);
			return LUP_ON_CURVE;
		}
		else {
			printf("Debug: LUp_SPoint: error case.\n");
			return LUP_ERROR;
		}
	}
	else {
		SetPointName(cursorpt);
		AssignPoint(cursorpt);
		return LUP_NO_SNAPPING;
	}
}

void MyCanvas::LUp_SPoint(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	LUp_Point(&geomx,&geomy);
	WriteConst(cursorcn);
	m_point_dragging = false;
}

void MyCanvas::LDown_MLine(wxPoint &point)
{
	ClearAllHilights();
	double gx=geomcx+(point.x-centerx)*geomperdot;
	double gy=geomcy-(point.y-centery)*geomperdot;
	if(Snapping(pts,&gx,&gy,&startpt)){
		snapped2pt=true;
	}
	else {
		ConstFree(gx,gy,true);
		AssignPoint(cursorpt);
		startpt=cursorpt;
		SetPointName(cursorpt);
		snapped2pt=false;
	}
	ConstFree(gx+0.01,gy+0.01,true);
	cursorln=NewLine(gx,gy,gx+0.01,gy+0.01);
	Sethilighted(cursorln);
	cursorln->clipping=LineClipping;
	cursorln->hilightphase=3;
	cursorln->_name=wxString((wxChar*)last_ln_name.c_str());
	next_name(last_ln_name);
	GConst* cnp = NewConst(CONST_JOIN);
	cnp->LOutput=cursorln;
	cnp->PInput1=startpt;
	cnp->PInput2=cursorpt;
	cursorcn=cnp;
	AssignIncident(cursorln,startpt,0.0);
	AssignIncident(cursorln,cursorpt,1.0);
	m_point_dragging = true;
}
void MyCanvas::LUp_MLine(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint *pt1;
	GConst* cnp;
	switch(LUp_Point(&geomx,&geomy)){
	case LUP_ON_POINT:
		Snapping(pts,&geomx,&geomy,&pt1);
		FindLnFromCn(cns,cursorln,&cnp);
		cnp->PInput2 = pt1;  
		cursorln->ics->_icnext->_icpt= pt1; 
		AssignLine(cursorln);
		if(!CheckCoincidency(cursorln)) {
			CheckIncidency(cursorln);
		}
		break;
	case LUP_ON_STARTPOINT:
		DeleteLnFromCn(&(cns),cursorln);
		DeleteLine(cursorln);
		*(lastln)=NULL;
		break;
	case LUP_MEET_LC:
	case LUP_MEET_LL:
	case LUP_ON_LINE:
	case LUP_MEET_CC:
	case LUP_ON_CIRCLE:
	case LUP_ON_CURVE:
	case LUP_NO_SNAPPING:
		AssignLine(cursorln);
		if(!CheckCoincidency(cursorln)) {
			CheckIncidency(cursorln);
		}
		break;
	}
	WriteConst(cursorcn);
	m_point_dragging = false;
}
void MyCanvas::LDown_Para(wxPoint &point)
{
	ClearAllHilights();
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GLine *ln1,*ln2;
	if(Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2)){
		snapped2ln=true;
		ConstFree(geomx+0.01,geomy+0.01,true);
		cursorln=NewLine(geomx,geomy,geomx+0.01,geomy+0.01);
		Sethilighted(cursorln);
		cursorln->hilightphase=3;
		cursorln->_name=wxString((wxChar*)last_ln_name.c_str());
		next_name(last_ln_name);
		cursorln->clipping=LineClipping;
		GConst* cnp = NewConst(CONST_PARALLEL);
		cnp->LOutput=cursorln;
		cnp->PInput1=cursorpt;
		cnp->LInput1=ln1;
		startpt=NULL;
		cursorcn=cnp;
		EvaluateConst(cns);
		AssignIncident(cursorln,cursorpt);
		m_point_dragging = true;
		snapped2ln=false;
	}
	else {
		m_point_dragging = false;
		snapped2ln=false;
	}
}
void MyCanvas::LUp_Para(wxPoint &point)
{
	if(!m_point_dragging) return;
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint *pt1;
	GConst* cnp;
	switch(LUp_Point(&geomx,&geomy)){
	case LUP_ON_POINT:
		Snapping(pts,&geomx,&geomy,&pt1);
		FindLnFromCn(cns,cursorln,&cnp);
		cnp->PInput1 = pt1;  
		cursorln->ics->_icpt= pt1; 
		AssignLine(cursorln);
		if(!CheckCoincidency(cursorln)) {
			CheckIncidency(cursorln);
		}
		break;
	case LUP_ON_STARTPOINT:
		DeleteLnFromCn(&(cns),cursorln);
		DeleteLine(cursorln);
		*(lastln)=NULL;
		break;
	case LUP_MEET_LC:
	case LUP_MEET_LL:
	case LUP_ON_LINE:
	case LUP_MEET_CC:
	case LUP_ON_CIRCLE:
	case LUP_ON_CURVE:
	case LUP_NO_SNAPPING:
		AssignLine(cursorln);
		if(!CheckCoincidency(cursorln)) {
			CheckIncidency(cursorln);
		}
		cursorln=NULL;  // it must be non-sense.
		break;
	}
	WriteConst(cursorcn);
	m_point_dragging = false;
}

void MyCanvas::LDown_Perp(wxPoint &point)
{
	ClearAllHilights();
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GLine *ln1,*ln2;
	if(Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2)){
		snapped2ln=true;
		ConstFree(geomx+0.01,geomy+0.01,true);

		cursorln=NewLine(geomx,geomy,geomx+0.01,geomy+0.01);
		Sethilighted(cursorln);
		cursorln->hilightphase=3;
		cursorln->_name=wxString((wxChar*)last_ln_name.c_str());
		next_name(last_ln_name);
		cursorln->clipping=LineClipping;
		GConst* cnp = NewConst(CONST_PERP);
		cnp->LOutput=cursorln;
		cnp->PInput1=cursorpt;
		cnp->LInput1=ln1;
		cursorcn=cnp;
		startpt=NULL;
		EvaluateConst(cns);
		AssignIncident(cursorln,cursorpt);
		m_point_dragging = true;
		snapped2ln=false;
	}
	else {
		m_point_dragging = false;
		snapped2ln=false;
	}
}
void MyCanvas::LUp_Perp(wxPoint &point)
{
	LUp_Para(point);
}

void MyCanvas::LDown_Mid(wxPoint &point)
{
	ClearAllHilights();
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	if(Snapping(pts,&geomx,&geomy,&startpt)){
		snapped2pt=true;
	}
	else {
		ConstFree(geomx,geomy,false);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		startpt=cursorpt;
		snapped2pt=false;
	}
	ConstFree(startgeomx+0.1,startgeomy+0.1,true);
	cursorpt2=NewPoint(CComplex(startgeomx+0.05,0),CComplex(startgeomy+0.05,0));
	Sethilighted(cursorpt2);
	GConst* cnp=NewConst(CONST_MID);
	cnp->POutput=cursorpt2;
	cnp->PInput1=startpt;
	cnp->PInput2=cursorpt;
	cursorcn=cnp;
	EvaluateConst(cns);
	m_point_dragging = true;
}


void MyCanvas::LUp_Mid(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint *pt1;
	GConst* cnp;
	switch(LUp_Point(&geomx,&geomy)){
	case LUP_ON_POINT:
		Snapping(pts,&geomx,&geomy,&pt1);
		FindPtFromCn(cns,cursorpt2,&cnp);
		cnp->PInput2 = pt1;  
		AssignPoint(cursorpt2);
		SetPointName(cursorpt2);
		if(!CheckCoincidency(cursorpt2)){
			CheckIncidency(cursorpt2);
		}
		break;
	case LUP_ON_STARTPOINT:
		DeleteLnFromCn(&(cns),cursorln);
		DeleteLine(cursorln);
		*(lastln)=NULL;
		break;
	case LUP_MEET_LC:
	case LUP_MEET_LL:
	case LUP_ON_LINE:
	case LUP_MEET_CC:
	case LUP_ON_CIRCLE:
	case LUP_ON_CURVE:
	case LUP_NO_SNAPPING:
		AssignPoint(cursorpt2);
		SetPointName(cursorpt2);
		if(!CheckCoincidency(cursorpt2)){
			CheckIncidency(cursorpt2);
		}
		break;
	}
	WriteConst(cursorcn);
	m_point_dragging = false;
}

void MyCanvas::LDown_MCircle(wxPoint &point)
{
	//printf("LDown_MCircle : \n");
	GConst* cnp;
	ClearAllHilights();
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	if(Snapping(pts,&geomx,&geomy,&startpt)){
		snapped2pt=true;
	}
	else {
		ConstFree(geomx,geomy,false);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		startpt=cursorpt;
		snapped2pt=false;
	}
	ConstFree(geomx+0.1,geomy,true);
	cursorci=NewCircle(geomx,geomy,0.1);
	Sethilighted(cursorci);
	cursorci->hilightphase=3;
	cnp=NewConst(CONST_MULTI_CIRCLE);
	cnp->COutput=cursorci;
	cnp->PInput1=startpt;
	cnp->PInput2=cursorpt;
	cursorcn=cnp;
	AssignIncident(cursorci,cursorpt,1.0);// incident start
	m_point_dragging = true;
}

void MyCanvas::LUp_MCircle(wxPoint &point)
{
	if(!m_point_dragging) return;
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint *pt1;
	GConst* cnp;
	switch(LUp_Point(&geomx,&geomy)){
	case LUP_ON_POINT:
		Snapping(pts,&geomx,&geomy,&pt1);
		FindCiFromCn(cns,cursorci,&cnp);
		cnp->PInput2 = pt1;  
		cursorci->ics->_icpt= pt1; 
		AssignCircle(cursorci);
		SetCircleName(cursorci);
		if(!CheckCoincidency(cursorci)){
			CheckIncidency(cursorci);
		}
		break;
	case LUP_ON_STARTPOINT:
		DeleteCiFromCn(&(cns),cursorci);
		DeleteCircle(cursorci);
		*(lastln)=NULL;
		break;
	case LUP_MEET_LC:
	case LUP_MEET_LL:
	case LUP_ON_LINE:
	case LUP_MEET_CC:
	case LUP_ON_CIRCLE:
	case LUP_ON_CURVE:
	case LUP_NO_SNAPPING:
		AssignCircle(cursorci);
		SetCircleName(cursorci);
		if(!CheckCoincidency(cursorci)){
			CheckIncidency(cursorci);
		}
		break;
	}
	cursorci=NULL;
	WriteConst(cursorcn);
	m_point_dragging = false;
}

void MyCanvas::LDown_Bisector(wxPoint &point){}

void MyCanvas::LUp_Bisector(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	double geomx2,geomy2;
	double geomx3,geomy3;
	double bufx,bufy;
	int lncount;
	GLine *ln1,*ln2;
	cursorpt = NewPoint(CComplex(geomx,0.0),CComplex(geomy,0.0));
	cursorpt->next=NULL;
	lncount= Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2);
	if(lncount>0){ 
		if(UInputCount==0){ 
			ULInput1 = ln1;
			geomx1=geomx;
			geomy1=geomy;
			UInputCount=1;
			Sethilighted(ln1);
		}
		else if(UInputCount==1 && ULInput1!=ln1){ 
			ULInput2 = ln1;
			geomx2=geomx;
			geomy2=geomy;
			GPoint ispt = Meet(ULInput1,ULInput2);
			geomx3=ispt.xz().real();
			geomy3=ispt.yz().real();
			bufx = geomx3 + (geomx1-geomx3)/sqrt((geomx1-geomx3)*(geomx1-geomx3)+(geomy1-geomy3)*(geomy1-geomy3));
			bufy = geomy3 + (geomy1-geomy3)/sqrt((geomx1-geomx3)*(geomx1-geomx3)+(geomy1-geomy3)*(geomy1-geomy3));
			geomx1 = bufx; geomy1 = bufy;
			bufx = geomx3 + (geomx2-geomx3)/sqrt((geomx2-geomx3)*(geomx2-geomx3)+(geomy2-geomy3)*(geomy2-geomy3));
			bufy = geomy3 + (geomy2-geomy3)/sqrt((geomx2-geomx3)*(geomx2-geomx3)+(geomy2-geomy3)*(geomy2-geomy3));
			geomx2 = bufx; geomy2 = bufy;
			geomx1 = geomx1+geomx2-2*geomx3;
			geomy1 = geomy1+geomy2-2*geomy3;
			cursorln=NewLine(1.0,0.0,0.0,1.0);
			ClearAllHilights();
			Sethilighted(cursorln);
			cursorln->hilightphase=3;
			cursorln->_name=wxString((wxChar*)last_ln_name.c_str());
			cursorln->clipping=LineClipping;
			next_name(last_ln_name);
			GConst* cnp=NewConst(CONST_BISECTOR);
			cnp->LOutput=cursorln;
			cnp->LInput1=ULInput1;
			cnp->LInput2=ULInput2;
			cnp->para1=CComplex(1.0,0.0);
			cursorcn=cnp;
			WriteConst(cnp);
			EvaluateConst(cns);
			geomx2= cursorln->xx.real();
			geomy2= cursorln->yy.real();
			if(abs(geomx1*geomx2+geomy1*geomy2)>0.1*sqrt(geomx1*geomx1+geomy1*geomy1)*sqrt(geomx2*geomx2+geomy2*geomy2)){
				cnp->para1=CComplex(-1.0,0.0);
			}
			EvaluateConst(cns);
			AssignLine(cursorln);
			if(!CheckCoincidency(cursorln)) {
				 CheckIncidency(cursorln);
			}
			cursorln=NULL;
			UInputCount=0;
		}
	}
	DeletePoint(cursorpt);
	m_point_dragging = false; 
	redraw=true;
}

void MyCanvas::LUp_Select(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	if(!ShiftLButton){
		ClearAllHilights();
	}
	if(snapped2pt=Snapping(pts,&geomx,&geomy,&pt1)){
		SelectHilight(pts,geomx,geomy);
	}
	else if(SelectHilight(ags,geomx,geomy)){
		;
	}
	else if(Snap2Bracket(brs,geomx,geomy)){
		Sethilighted(cursorbr);
	}
	else if(snapped2ln=Snap2Line(lns,&geomx,&geomy)){
		SelectHilight(lns,geomx,geomy);
	}
	else if(snapped2ci=Snap2Circle(cis,&geomx,&geomy)){
		SelectHilight(cis,geomx,geomy);
	}
	else if(snapped2curve=Snap2Curve(curves,&geomx,&geomy)){
		SelectHilight(curves,geomx,geomy);
	}
	else if(Snap2Text(texts,point.x,point.y)){
		cursortext->hilighted=true;
	}
	else if(Snap2Image(ims,point.x,point.y)){
		cursorim->hilighted=true;
	}
	else {
		ClearAllHilights();
	}
	redraw=true;
}

void MyCanvas::LUp_Tangent(wxPoint &point)
{
	GPoint* ptp;
	GCircle* cip;
	GParaCurve *cup;
	if(NOhilightedPoints>0){ptp=hilightedPoints[0];} else {ptp=NULL;}
	if(NOhilightedCircles>0){cip=hilightedCircles[0];} else {cip=NULL;}
	if(NOhilightedCurves>0){cup=hilightedCurves[0];} else {cup=NULL;}
	LUp_Select(point);
	if(NOhilightedPoints>0){ptp=hilightedPoints[0];}
	if(NOhilightedCircles>0){cip=hilightedCircles[0];}
	if(NOhilightedCurves>0){cup=hilightedCurves[0];} 
	if(ptp!=NULL &&  NOhilightedPoints==0){  NOhilightedPoints=1;hilightedPoints[0]=ptp; }
	if(cip!=NULL &&  NOhilightedCircles==0){  NOhilightedCircles=1;hilightedCircles[0]=cip; }
	if(cup!=NULL &&  NOhilightedCurves==0){  NOhilightedCurves=1;hilightedCurves[0]=cup; }
	if(NOhilightedCircles>0 && NOhilightedPoints>0){
		ConstDefTangent();
	}
	else if(NOhilightedCurves>0 && NOhilightedPoints>0){
		ConstDefCurveTangent();
	}
}

void MyCanvas::LUp_Compass(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	if(lns!=NULL) lns->ClearHilight();	
	if(cis!=NULL) cis->ClearHilight();	
	if(curves!=NULL) curves->ClearHilight();	
	NOhilightedLines=NOhilightedCircles=NOhilightedCurves=0;
	if(snapped2pt=Snapping(pts,&geomx,&geomy,&pt1)){
		if(NOhilightedPoints==1 && pt1==hilightedPoints[0]){
			;
		}
		else {
			Sethilighted(pt1);
		}
	}
	if(NOhilightedPoints==1){
		compasscenterx=compasscursorx;
		compasscentery=compasscursory;
	}
	else if(NOhilightedPoints==2){
		compassradius=(int)floor(sqrt(
			1.0*(compasscenterx-compasscursorx)*(compasscenterx-compasscursorx)+
			1.0*(compasscentery-compasscursory)*(compasscentery-compasscursory)));
	}
	if(NOhilightedPoints>=3){
		ConstDefCompass();
	}
}

void MyCanvas::LUp_Orbit(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	GConst* cnp;
	if(NOhilightedPoints==0){
		if(cis!=NULL) cis->ClearHilight();	
		NOhilightedCircles=0;
	}
	if(snapped2pt=Snapping(pts,&geomx,&geomy,&pt1)){
		if(NOhilightedPoints!=1 || pt1!=hilightedPoints[0]){
			Sethilighted(pt1);
		}
	}
	if(NOhilightedPoints==1){
		FindCnFromPt(cns,hilightedPoints[0],&cnp);
		if(cnp->Const_Type==CONST_PT_ON_CIRCLE){
			Sethilighted(cnp->CInput1);
		}
		else if(cnp->Const_Type==CONST_ON_LINE || cnp->Const_Type==CONST_PT_ON_PARA || 
			cnp->Const_Type==CONST_PT_ON_PERP || cnp->Const_Type==CONST_PT_ON_3P_BISECTOR || 
			cnp->Const_Type==CONST_PT_ON_BISECTOR || cnp->Const_Type==CONST_PT_ON_TANGENT  || 
			cnp->Const_Type==CONST_PT_ON_CURVE_TANGENT || cnp->Const_Type==CONST_PT_ON_LINE_WITH_ANGLE ||
			cnp->Const_Type==CONST_PT_ON_LINE_WITH_ANGLE_DEGREE){
//			Sethilighted(cnp->CInput1);
		}
		else {
			pts->ClearHilight();
			NOhilightedPoints=0;
		}
	}
	else if(NOhilightedPoints==2){
		ConstDefOrbit();
	}
}

#include "wx/textctrl.h"

class MyEditTextDialog : public wxDialog
{
public:
	MyEditTextDialog(wxWindow *parent,wxString s,int fs,bool centered_on,int R,int G,int B);
	//void OnButton(wxCommandEvent& event);
	void OnLeft(wxCommandEvent& event);
	void OnCenter(wxCommandEvent& event);
	void OnRGB(wxCommandEvent& event);

	wxButton *m_btnOk,*m_btnRGB;
	wxTextCtrl *m_tcText,*m_tcSize,*m_tcR,*m_tcG,*m_tcB;
	wxStaticText *m_stText1,*m_stText2;
	wxRadioButton *m_RButton1,*m_RButton2;
	int r,g,b;

	wxColourData m_ColData;

private:
	DECLARE_EVENT_TABLE()
};

enum{
	wxID_EditTexTLeft=0,
	wxID_EditTexTCenter,
	wxID_EditTexTRGB
};

BEGIN_EVENT_TABLE(MyEditTextDialog, wxDialog)
	EVT_RADIOBUTTON(wxID_EditTexTLeft, MyEditTextDialog::OnLeft)
	EVT_RADIOBUTTON(wxID_EditTexTCenter, MyEditTextDialog::OnCenter)
	EVT_BUTTON(wxID_EditTexTRGB, MyEditTextDialog::OnRGB)
END_EVENT_TABLE()



#ifdef __WXMSW__
MyEditTextDialog::MyEditTextDialog(wxWindow *parent,wxString s,int fs,bool centered_on,int R,int G,int B)
			 : wxDialog(parent, wxID_ANY,EditTextDlogTitle,wxPoint(15,15), wxSize(320,290))
{
	m_stText1 = new wxStaticText(this, wxID_ANY,EditTextDlogText1,wxPoint(15,10));
	m_tcText = new wxTextCtrl(this, wxID_ANY,s,wxPoint(15,30), wxSize(280,120),wxTE_MULTILINE);
	m_stText2 = new wxStaticText(this, wxID_ANY,EditTextDlogText2 ,wxPoint(15,156), wxSize(50,20));
	m_tcSize = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),fs),wxPoint(70,155), wxSize(40,20));
	if(centered_on){
		m_RButton1 = new wxRadioButton(this,wxID_EditTexTLeft,EditTextDlogLeft,wxPoint(140,156),wxSize(60,20));
		m_RButton2 = new wxRadioButton(this,wxID_EditTexTCenter,EditTextDlogCenter,wxPoint(202,156),wxSize(80,20));
	}
	new wxStaticText(this, wxID_ANY,wxT("RGB"),wxPoint(20,185), wxSize(40,20));
	m_tcR = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),R),wxPoint(70,185), wxSize(40,20));
	m_tcG = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),G),wxPoint(120,185), wxSize(40,20));
	m_tcB = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),B),wxPoint(170,185), wxSize(40,20));
	m_btnRGB = new wxButton(this,wxID_EditTexTRGB,wxT("RGB"),wxPoint(220,185),wxSize(80,20));
	m_btnOk = new wxButton(this, wxID_OK, wxT("Ok"),wxPoint(220,225), wxSize(80,20));
}
#else
MyEditTextDialog::MyEditTextDialog(wxWindow *parent,wxString s,int fs,bool centered_on,int R,int G,int B)
	: wxDialog(parent, wxID_ANY,EditTextDlogTitle,wxPoint(15,15), wxSize(320,290))
{
	m_stText1 = new wxStaticText(this, wxID_ANY,EditTextDlogText1,wxPoint(15,10));
	m_tcText = new wxTextCtrl(this, wxID_ANY,s,wxPoint(15,30), wxSize(280,120),wxTE_MULTILINE);
	m_stText2 = new wxStaticText(this, wxID_ANY,EditTextDlogText2 ,wxPoint(15,158), wxSize(85,20));
	m_tcSize = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),fs),wxPoint(95,155), wxSize(40,24));
	if(centered_on){
		m_RButton1 = new wxRadioButton(this,wxID_EditTexTLeft,EditTextDlogLeft,wxPoint(150,156),wxSize(80,20));
		m_RButton2 = new wxRadioButton(this,wxID_EditTexTCenter,EditTextDlogCenter,wxPoint(240,156),wxSize(50,20));
	}
	new wxStaticText(this, wxID_ANY,wxT("RGB"),wxPoint(20,185), wxSize(40,20));
	m_tcR = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),R),wxPoint(70,185), wxSize(40,20));
	m_tcG = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),G),wxPoint(120,185), wxSize(40,20));
	m_tcB = new wxTextCtrl(this, wxID_ANY,wxString::Format(wxT("%d"),B),wxPoint(170,185), wxSize(40,20));
	m_btnRGB = new wxButton(this,wxID_EditTexTRGB,wxT("RGB"),wxPoint(220,185),wxSize(80,30));
	m_btnOk = new wxButton(this, wxID_OK, wxT("Ok"),wxPoint(200,215), wxSize(90,20));
}
#endif

void MyEditTextDialog::OnLeft(wxCommandEvent& event)
{
	m_RButton1->SetValue(true);m_RButton2->SetValue(false);
}

void MyEditTextDialog::OnCenter(wxCommandEvent& event)
{
	m_RButton1->SetValue(false);m_RButton2->SetValue(true);
}

#include "wx/colordlg.h"
#include "wx/cmndata.h"

void MyEditTextDialog::OnRGB(wxCommandEvent& event)
{
	wxColourDialog dialog(this, &m_ColData);
	if (dialog.ShowModal() == wxID_OK){
		wxColourData retData = dialog.GetColourData();
		wxColour col = retData.GetColour();
		m_tcR->SetValue(wxString::Format(wxT("%d"),(int)(col.Red())));
		m_tcG->SetValue(wxString::Format(wxT("%d"),(int)(col.Green())));
		m_tcB->SetValue(wxString::Format(wxT("%d"),(int)(col.Blue())));

	}
}


void MyCanvas::LUp_Text(wxPoint &point)
{
	double gx=geomcx+(point.x-centerx)*geomperdot;
	double gy=geomcy-(point.y-centery)*geomperdot;
	GPoint* ptp;
	MyEditTextDialog *dialog;
	int pointx=point.x;
	int pointy=point.y;
	char buff[1024];
	wxString str0,str1;
	int r,g,b;
	if(Snapping(pts,&gx,&gy,&ptp)){
		str1= wxString((char*)ptp->_name.c_str(),*wxConvCurrent);
		dialog=new MyEditTextDialog(this,str1,ptp->_fontsize,false,PTextColR,PTextColG,PTextColB);
		m_ColData.SetColour(wxColour(PTextColR,PTextColG,PTextColB));
		dialog->m_ColData=m_ColData;
		if(dialog->ShowModal() == wxID_OK){
			str0=dialog->m_tcText->GetValue();
			sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
			ptp->_name =wxString((wxChar*)buff);
			m_ColData=dialog->m_ColData;
			dialog->m_tcR->GetValue().ToLong((long *)&r);
			dialog->m_tcG->GetValue().ToLong((long *)&g);
			dialog->m_tcB->GetValue().ToLong((long *)&b);
			PTextColR=r;
			PTextColG=g;
			PTextColB=b;
			wxString st;
			long fs;
			st=dialog->m_tcSize->GetValue();
			st.ToLong(&fs);
			if(fs>100 || fs<5){
				ptp->_fontsize=14;
			}
			else {
				ptp->_fontsize=fs;
				DefaultFontSize=fs;
			}
		}
	}
	else if(Snap2Text(texts,point.x,point.y)){
		str1= wxString((char*)cursortext->str.c_str(),*wxConvCurrent);
		dialog=new MyEditTextDialog(this,str1,(int)floor(cursortext->fontsize),true,cursortext->ColR,cursortext->ColG,cursortext->ColB);
		if(cursortext->centered){ dialog->m_RButton2->SetValue(true);dialog->m_RButton1->SetValue(false); }
		else { dialog->m_RButton2->SetValue(false);dialog->m_RButton1->SetValue(true); }
		m_ColData.SetColour(wxColour(cursortext->ColR,cursortext->ColG,cursortext->ColB));
		dialog->m_ColData=m_ColData;
		if(dialog->ShowModal() == wxID_OK){
			str0 = dialog->m_tcText->GetValue();
			sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
			cursortext->str=wxString((wxChar*)buff);
			AddYenCommaOnText(cursortext->str);
			cursortext->centered=dialog->m_RButton2->GetValue();
			m_ColData=dialog->m_ColData;
			dialog->m_tcR->GetValue().ToLong((long *)&r);
			dialog->m_tcG->GetValue().ToLong((long *)&g);
			dialog->m_tcB->GetValue().ToLong((long *)&b);
			cursortext->ColR=r;
			cursortext->ColG=g;
			cursortext->ColB=b;
			wxString st;
			long fs;
			st=dialog->m_tcSize->GetValue();
			st.ToLong(&fs);
			if(fs>100 || fs<5){
				cursortext->fontsize=18;
			}
			else {
				cursortext->fontsize=fs;
			}
		}
	}
	else {
		dialog=new MyEditTextDialog(this,wxT("X"),18,true,TextColR,TextColG,TextColB);
		dialog->m_RButton2->SetValue(false);dialog->m_RButton1->SetValue(true);
		m_ColData.SetColour(wxColour(TextColR,TextColG,TextColB));
		dialog->m_ColData=m_ColData;
		if(dialog->ShowModal() == wxID_OK){
			str0 = dialog->m_tcText->GetValue();
			sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
			str1 =wxString((wxChar*)buff);
			cursortext=NewText(str1);
			cursortext->str=wxString((wxChar*)buff);
			AddYenCommaOnText(cursortext->str);
			cursortext->centered=dialog->m_RButton2->GetValue();
			m_ColData=dialog->m_ColData;
			dialog->m_tcR->GetValue().ToLong((long *)&r);
			dialog->m_tcG->GetValue().ToLong((long *)&g);
			dialog->m_tcB->GetValue().ToLong((long *)&b);
			cursortext->ColR=r;
			cursortext->ColG=g;
			cursortext->ColB=b;
			wxString st;
			long fs;
			st=dialog->m_tcSize->GetValue();
			st.ToLong(&fs);
			if(fs>100 || fs<5){
				cursortext->fontsize=18;
			}
			else {
				cursortext->fontsize=fs;
			}
			cursortext->tx=1.0*pointx;
			cursortext->ty=1.0*pointy;
			cursortext->_name=wxString((wxChar*)last_text_name.c_str());
			next_name(last_text_name);
			AssignText(cursortext);
			cursorcn=NewConst(CONST_TEXT);
			cursorcn->TextOutput=cursortext;
			WriteConst(cursorcn);
			WriteLogFile(wxString((char*)cursortext->str.c_str(),*wxConvCurrent)+wxT("\n"));
		}
	}
}

void MyCanvas::LUp_Image(wxPoint &point)
{
	wxFileDialog myFileD(this ,wxT("Choose a image file"),wxT(""),wxT("untitled"),wxT("image files|*.bmp;*.jpg;*.png;*.gif"),wxOPEN);
	if(myFileD.ShowModal()==wxID_OK){
		wxString g_ImagePath=myFileD.GetPath();
		WriteLogFile(wxString::Format(wxT("LUp_Image : g_ImagePath=%s\n"),g_ImagePath.c_str()));
		wxImage img;
		if(img.LoadFile(g_ImagePath,wxBITMAP_TYPE_ANY,-1)){
			GImage* im1=NewImage();
			im1->_name=last_im_name; next_name(last_im_name);
			im1->m_filename=myFileD.GetFilename();
			im1->m_image=wxImage(img);
			im1->m_bmp=wxBitmap(img);
			im1->m_x=point.x;
			im1->m_y=point.y;
			im1->m_w=img.GetWidth(); // 
			im1->m_h=img.GetHeight(); //
			im1->imageon=true;
			AssignImage(im1);
			GConst* cnp=NewConst(CONST_IMAGE);
			cnp->ImageOutput=im1;
			WriteLogFile(wxT("LUp_Image : NewImage=")+wxString((char*)im1->_name.c_str(),*wxConvCurrent)+wxT("\n"));
		}
		else {
			WriteLogFile(wxT("LUp_Image : failed to load image file.\n"));
		}
	}
}

void MyCanvas::LUp_CircleBy3(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	if(snapped2pt=Snapping(pts,&geomx,&geomy,&pt1)){
		if(NOhilightedPoints==0){
			Sethilighted(pt1);
		}
		else if(NOhilightedPoints==1 && pt1!=hilightedPoints[0]){
			Sethilighted(pt1);
		}
		else if(NOhilightedPoints==2 && pt1!=hilightedPoints[0] && pt1!=hilightedPoints[1]){
			Sethilighted(pt1);
		}
	}
	if(NOhilightedPoints==3){
		ConstDefCircleBy3();
	}
}

void MyCanvas::LUp_Angle(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint* pt1;
	if(snapped2pt=Snapping(pts,&geomx,&geomy,&pt1)){
		if(NOhilightedPoints==0){
			Sethilighted(pt1);
		}
		else if(NOhilightedPoints==1 && pt1!=hilightedPoints[0]){
			Sethilighted(pt1);
		}
		else if(NOhilightedPoints==2 && pt1!=hilightedPoints[0] && pt1!=hilightedPoints[1]){
			Sethilighted(pt1);
		}
	}
	if(NOhilightedPoints==3){
		ConstDefAngle();
	}
}

void MyCanvas::LDown_LineWithAngle(wxPoint &point)
{
	ClearAllHilights();
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GLine *ln1,*ln2;
	if(Snap2LineEx(lns,&geomx,&geomy,&ln1,&ln2)){
		snapped2ln=true;
		ConstFree(geomx+0.01,geomy+0.01,true);

		cursorln=NewLine(geomx,geomy,geomx+0.01,geomy+0.01/*,80,80,255,10*/);
		Sethilighted(cursorln);
		cursorln->hilightphase=3;
		cursorln->_name=wxString((wxChar*)last_ln_name.c_str());
		next_name(last_ln_name);
		cursorln->clipping=LineClipping;
		if(cursorag==NULL){
			GConst* cnp = NewConst(CONST_LINE_WITH_ANGLE_DEGREE);
			cnp->LOutput=cursorln;
			cnp->PInput1=cursorpt;
			cnp->LInput1=ln1;
			cnp->para1=CComplex(angle_value,0.0);
			cursorcn=cnp;
		}
		else {
			GConst* cnp = NewConst(CONST_LINE_WITH_ANGLE);
			cnp->LOutput=cursorln;
			cnp->PInput1=cursorpt;
			cnp->LInput1=ln1;
			cnp->AngleInput1=cursorag;
			cursorcn=cnp;
		}
		startpt=NULL;
		EvaluateConst(cns);
		AssignIncident(cursorln,cursorpt);
		m_point_dragging = true;
		snapped2ln=false;
	}
	else {
		m_point_dragging = false;
		snapped2ln=false;
	}
}
void MyCanvas::LUp_LineWithAngle(wxPoint &point)
{
	LUp_Para(point);
}

void MyCanvas::LDown_Bracket(wxPoint &point)
{
	ClearAllHilights();
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	if(Snapping(pts,&geomx,&geomy,&startpt)){
		snapped2pt=true;
	}
	else {
		ConstFree(geomx,geomy,false);
		AssignPoint(cursorpt);
		SetPointName(cursorpt);
		startpt=cursorpt;
		snapped2pt=false;
	}
	ConstFree(geomx+0.1,geomy+0.1,true);
	cursorbr=NewBracket(startpt,cursorpt);
	Sethilighted(cursorbr);
	GConst* cnp=NewConst(CONST_BRACKET);
	cnp->BracketOutput=cursorbr;
	cnp->PInput1=startpt;
	cnp->PInput2=cursorpt;
	cursorcn=cnp;
	EvaluateConst(cns);
	m_point_dragging = true;
}


void MyCanvas::LUp_Bracket(wxPoint &point)
{
	double geomx=geomcx+(point.x-centerx)*geomperdot;
	double geomy=geomcy-(point.y-centery)*geomperdot;
	GPoint *pt1;
	GConst* cnp;
	switch(LUp_Point(&geomx,&geomy)){
	case LUP_ON_POINT:
		Snapping(pts,&geomx,&geomy,&pt1);
		FindBrFromCn(cns,cursorbr,&cnp);
		cnp->PInput2 = pt1;  
		AssignBracket(cursorbr);
		SetBracketName(cursorbr);
		break;
	case LUP_ON_STARTPOINT:
		DeleteLnFromCn(&(cns),cursorln);
		DeleteLine(cursorln);
		*(lastln)=NULL;
		break;
	case LUP_MEET_LC:
	case LUP_MEET_LL:
	case LUP_ON_LINE:
	case LUP_MEET_CC:
	case LUP_ON_CIRCLE:
	case LUP_ON_CURVE:
	case LUP_NO_SNAPPING:
		AssignBracket(cursorbr);
		SetBracketName(cursorbr);
		break;
	}
	WriteConst(cursorcn);
	m_point_dragging = false;
}


void MyCanvas::Sethilighted(GPoint *p)
{
	int i;
	p->hilighted=true;
	p->hilightphase=3;
	for(i=0;i<NOhilightedPoints;i++){
		if(hilightedPoints[i]==p){
			return;
		}
	}
	if(NOhilightedPoints<9){
		hilightedPoints[NOhilightedPoints++]=p;
	}
}
void MyCanvas::Deletehilighted(GPoint *p)
{
	int i;
	p->hilighted=false;
	for(i=0;i<NOhilightedPoints;i++){
		if(hilightedPoints[i]==p){
			for(i++;i<NOhilightedPoints;i++){
				hilightedPoints[i-1]=hilightedPoints[i];
			}
			NOhilightedPoints--;
			return;
		}
	}
}

void MyCanvas::Sethilighted(GLine *p)
{
	int i;
	p->hilighted=true;
	for(i=0;i<NOhilightedLines;i++){
		if(hilightedLines[i]==p){
			return;
		}
	}
	if(NOhilightedLines<9){
		hilightedLines[NOhilightedLines++]=p;
	}
}
void MyCanvas::Deletehilighted(GLine *p)
{
	int i;
	p->hilighted=false;
	for(i=0;i<NOhilightedLines;i++){
		if(hilightedLines[i]==p){
			for(i++;i<NOhilightedLines;i++){
				hilightedLines[i-1]=hilightedLines[i];
			}
			NOhilightedLines--;
			return;
		}
	}
}

void MyCanvas::Sethilighted(GCircle *p)
{
	int i;
	p->hilighted=true;
	for(i=0;i<NOhilightedCircles;i++){
		if(hilightedCircles[i]==p){
			return;
		}
	}
	if(NOhilightedCircles<9){
		hilightedCircles[NOhilightedCircles++]=p;
	}
}

void MyCanvas::Deletehilighted(GCircle *p)
{
	int i;
	p->hilighted=false;
	for(i=0;i<NOhilightedCircles;i++){
		if(hilightedCircles[i]==p){
			for(i++;i<NOhilightedCircles;i++){
				hilightedCircles[i-1]=hilightedCircles[i];
			}
			NOhilightedCircles--;
			return;
		}
	}
}


void MyCanvas::Sethilighted(GParaCurve *p)
{
	int i;
	p->hilighted=true;
	for(i=0;i<NOhilightedCurves;i++){
		if(hilightedCurves[i]==p){
			return;
		}
	}
	if(NOhilightedCurves<9){
		hilightedCurves[NOhilightedCurves++]=p;
	}
}

void MyCanvas::Deletehilighted(GParaCurve *p)
{
	int i;
	p->hilighted=false;
	for(i=0;i<NOhilightedCurves;i++){
		if(hilightedCurves[i]==p){
			for(i++;i<NOhilightedCurves;i++){
				hilightedCurves[i-1]=hilightedCurves[i];
			}
			NOhilightedCurves--;
			return;
		}
	}
}
void MyCanvas::Sethilighted(GAngle *agp)
{
	int i;
	agp->hilighted=true;
	for(i=0;i<NOhilightedAngles;i++){
		if(hilightedAngles[i]==agp){
			return;
		}
	}
	if(NOhilightedAngles<9){
		hilightedAngles[NOhilightedAngles++]=agp;
	}
}
void MyCanvas::Deletehilighted(GAngle *agp)
{
	int i;
	agp->hilighted=false;
	for(i=0;i<NOhilightedAngles;i++){
		if(hilightedAngles[i]==agp){
			for(i++;i<NOhilightedAngles;i++){
				hilightedAngles[i-1]=hilightedAngles[i];
			}
			NOhilightedAngles--;
			return;
		}
	}
}
void MyCanvas::Sethilighted(GImage *imp)
{
	int i;
	imp->hilighted=true;
	for(i=0;i<NOhilightedImages;i++){
		if(hilightedImages[i]==imp){
			return;
		}
	}
	if(NOhilightedImages<9){
		hilightedImages[NOhilightedImages++]=imp;
	}
}
void MyCanvas::Deletehilighted(GImage *imp)
{
	int i;
	imp->hilighted=false;
	for(i=0;i<NOhilightedImages;i++){
		if(hilightedImages[i]==imp){
			for(i++;i<NOhilightedImages;i++){
				hilightedImages[i-1]=hilightedImages[i];
			}
			NOhilightedImages--;
			return;
		}
	}
}
void MyCanvas::Sethilighted(GBracket *brp)
{
	int i;
	brp->hilighted=true;
	for(i=0;i<NOhilightedBrackets;i++){
		if(hilightedBrackets[i]==brp){
			return;
		}
	}
	if(NOhilightedBrackets<9){
		hilightedBrackets[NOhilightedBrackets++]=brp;
	}
}
void MyCanvas::Deletehilighted(GBracket *brp)
{
	int i;
	brp->hilighted=false;
	for(i=0;i<NOhilightedBrackets;i++){
		if(hilightedBrackets[i]==brp){
			for(i++;i<NOhilightedBrackets;i++){
				hilightedBrackets[i-1]=hilightedBrackets[i];
			}
			NOhilightedBrackets--;
			return;
		}
	}
}

void MyCanvas::DeleteIcs(GIncident* ic)
{
	if(ic==NULL){
		return ;
	}
	if(ic->_icnext==NULL){
		return ;
	}
	DeleteIcs(ic->_icnext);
	ic->_icnext->_used=false;
}

void MyCanvas::DeleteIcs(GLine* ln)
{
	DeleteIcs(ln->ics);
	if(ln->ics!=NULL){
		ln->ics->_used=false;
	}
	ln->last_ic=&(ln->ics);
	ln->NOics=0;
}

void MyCanvas::DeletePtFromIcs(GPoint* pt)
{
	GLine* lnp;
	GIncident *icp,**ich;
	for(lnp=lns;lnp!=NULL;lnp=lnp->next){
		ich=&(lnp->ics);
		for(icp=lnp->ics;icp!=NULL;icp=icp->_icnext){
			if(icp->_icpt==pt){
				*ich = icp->_icnext;
				if(icp->_icnext==NULL){
					lnp->last_ic=ich;
				}
				icp->_used=false;
				icp=NULL;
				break;
			}
			else {
				ich=&(icp->_icnext);
			}
		}
	}
	for(GCircle* cip=cis;cip!=NULL;cip=cip->next){
		ich=&(cip->ics);
		for(icp=cip->ics;icp!=NULL;icp=icp->_icnext){
			if(icp->_icpt==pt){
				*ich = icp->_icnext;
				if(icp->_icnext==NULL){
					cip->last_ic=ich;
				}
				icp->_used=false;
				icp=NULL;
				break;
			}
			else {
				ich=&(icp->_icnext);
			}
		}
	}
	
}
void MyCanvas::ResetIcs(GConst* cn,GLine* ln)
{
	GLine *lnP;
	GConst *cnP=NULL,*cnQ=NULL;
	for(lnP=ln;lnP!=NULL;lnP=lnP->next){
		DeleteIcs(lnP);
	}
	for(cnP=cn;cnP!=NULL;cnP=cnP->next){
		switch(cnP->Const_Type){
		case CONST_ON_LINE :
			AssignIncident(cnP->LInput1,cnP->POutput,(cnP->para1 / (cnP->para1+cnP->para2)).real());
			ResetLineIcPara(cnP->LInput1);
			break;
		case CONST_JOIN :
			AssignIncident(cnP->LOutput,cnP->PInput1,0.0);
			AssignIncident(cnP->LOutput,cnP->PInput2,1.0);
			break;
		case CONST_MEET : 
			AssignIncident(cnP->LInput1,cnP->POutput,0.0);
			ResetLineIcPara(cnP->LInput1);
			AssignIncident(cnP->LInput2,cnP->POutput,0.0);
			ResetLineIcPara(cnP->LInput2);
			break;
		case CONST_PARALLEL: 
			AssignIncident(cnP->LOutput,cnP->PInput1,0.0);
			break;
		case CONST_PERP:
			AssignIncident(cnP->LOutput,cnP->PInput1,0.0);
			break;
		case CONST_PT_ON_PARA:
			FindParaFromCns(cn,cnP->LInput1,cnP->PInput1,&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		case CONST_PT_ON_PERP:
			FindPerpFromCns(cn,cnP->LInput1,cnP->PInput1,&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		case CONST_MEET_CL:
			AssignIncident(cnP->LInput1,cnP->POutput,0.0);
			ResetLineIcPara(cnP->LInput1);
			break;
		case CONST_PT_ON_3P_BISECTOR:
			Find3PBisectorFromCns(cn,cnP->PInput1,cnP->PInput2,cnP->PInput3,&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		case CONST_PT_ON_BISECTOR:
			FindBisectorFromCns(cn,cnP->LInput1,cnP->LInput2,cnP->para1.real(),&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para2.real());
			break;
		case CONST_PT_ON_TANGENT:
			FindTangentFromCns(cn,cnP->CInput1,cnP->PInput1,&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		case CONST_PT_ON_CURVE_TANGENT:
			FindCurveTangentFromCns(cn,cnP->CurveInput1,cnP->PInput1,&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		case CONST_PT_ON_LINE_WITH_ANGLE:
			FindLineWithAngleFromCns(cn,cnP->LInput1,cnP->PInput1,cnP->AngleInput1,&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		case CONST_PT_ON_LINE_WITH_ANGLE_DEGREE:
			FindLineWithAngleDegreeFromCns(cn,cnP->LInput1,cnP->PInput1,cnP->para1.real(),&cnQ);
			AssignIncident(cnQ->LOutput,cnP->POutput,cnP->para1.real());
			break;
		}
	}
}

void MyCanvas::DeleteIcs(GCircle* ci)
{
	DeleteIcs(ci->ics);
	if(ci->ics!=NULL){
		ci->ics->_used=false;
	}
	ci->last_ic=&(ci->ics);
	ci->NOics=0;
}


void MyCanvas::ResetIcs(GConst* cn,GCircle* ci)
{
	GCircle *ciP;
	GConst *cnP=NULL;
	for(ciP=ci;ciP!=NULL;ciP=ciP->next){
		DeleteIcs(ciP);
	}
	for(cnP=cn;cnP!=NULL;cn=cn->next){
		switch(cnP->Const_Type){
		case CONST_MULTI_CIRCLE :
			AssignIncident(cnP->COutput,cnP->PInput2,atan2(- cnP->PInput2->yz().real() + cnP->COutput->yy.real(),
				cnP->PInput2->xz().real() - cnP->COutput->xx.real()));
			//ResetCircleIcPara(cnP->COutput);
			break;
		case CONST_PT_ON_CIRCLE :
			AssignIncident(cnP->CInput1,cnP->POutput,cnP->para1.real());
			//ResetCircleIcPara(cnP->CInput1);
			break;
		case CONST_MEET_CL : 
			AssignIncident(cnP->CInput1,cnP->POutput,atan2(- cnP->POutput->yz().real() + cnP->CInput1->yy.real(),
				cnP->POutput->xz().real() - cnP->CInput1->xx.real()));
			//ResetCircleIcPara(cnP->CInput1);
			break;
		case CONST_MEET_CC: 
			AssignIncident(cnP->CInput1,cnP->POutput,atan2(- cnP->POutput->yz().real() + cnP->CInput1->yy.real(),
				cnP->POutput->xz().real() - cnP->CInput1->xx.real()));
			//ResetCircleIcPara(cnP->CInput1);
			AssignIncident(cnP->CInput2,cnP->POutput,atan2(- cnP->POutput->yz().real() + cnP->CInput2->yy.real(),
				cnP->POutput->xz().real() - cnP->CInput2->xx.real()));
			//ResetCircleIcPara(cnP->CInput2);
			break;
		}
	}
}
