//
//   Menu.cpp
//
//
#include "wx/wx.h"
#include "wx/toolbar.h"
#include "wx/button.h"
#include "wx/textctrl.h"
#include "resource.h"
#include "KidsCindyFrame.h"
#include "KidsCindyCanvas.h"
#include "incident.h"
#include "GGraph.h"
#include "PtBmp.h"
#include "AngleDialog.h"

#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif

void MyCanvas::SetTheme(int thm,bool reset)
{
	int j;
	if(reset){
		for(j=0;j<5;j++){ m_appear._MyP[j].ClearBitmap(); }
		m_appear._MyBG.ClearData();
	}
	switch(thm){
	case THM_STANDARD:
		ThemeMode=THM_STANDARD;
		//
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyPtMode[j]=PtMode[j]=PTBMP_BALL0+j; }
		for(j=0;j<5;j++){ m_appear._MyP[j].LoadData(PTBMP_BALL0+j); }
		//
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyLnMode[j]=LnMode[j]=LNDSN_STANDARD0+j; }
		for(int i=0;i<5;i++){ m_appear._MyL[i].SetLnRgn(LNDSN_STANDARD0+i); }
		//
		sheetbuffer[currentSheet].MyBgMode=BgMode=BG_STANDARD0;
		m_appear._MyBG.LoadData(BgMode); 
		BGbmp=false;
		//
		PTextColR=TextColR=0;PTextColG=TextColG=0;PTextColB=TextColB=0;
		TextHilColR=155;TextHilColG=100;TextHilColB=100;
		//
		for(j=0;j<5;j++){AngleColR[j]=TextColR; AngleColG[j]=TextColG; AngleColB[j]=TextColB; }
		BracketColR=TextColR;BracketColG=TextColG;BracketColB=TextColB;
		SetAllAngleColor();SetAllBracketColor();
		//
		AxisPen.SetColour(128,128,128);
		AxisMeshPen.SetColour(128,128,128);
		m_owner->menuTheme->Check(THM_STANDARD,true);
		break;
	case THM_CAT:
		ThemeMode=THM_CAT;
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyPtMode[j]=PtMode[j]=PTBMP_CAT0+j; }
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyLnMode[j]=LnMode[j]=LNDSN_CAT0+j; }
		sheetbuffer[currentSheet].MyBgMode=BgMode=BG_CAT;
		for(j=0;j<5;j++){ m_appear._MyP[j].LoadData(PTBMP_CAT0+j); }
		PTextColR=TextColR=0;PTextColG=TextColG=0;PTextColB=TextColB=0;
		TextHilColR=150;TextHilColG=50;TextHilColB=50;
		for(j=0;j<5;j++){AngleColR[j]=TextColR; AngleColG[j]=TextColG; AngleColB[j]=TextColB; }
		BracketColR=TextColR;BracketColG=TextColG;BracketColB=TextColB;
		SetAllAngleColor();SetAllBracketColor();
		m_appear._MyBG.LoadData(BgMode); 
		for(int i=0;i<5;i++){ m_appear._MyL[i].SetLnRgn(LNDSN_CAT0+i); }
		AxisPen.SetColour(200,128,128);
		AxisMeshPen.SetColour(200,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_CAT,true);
		break;
	case THM_STAR:
		ThemeMode=THM_STAR;
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyPtMode[j]=PtMode[j]=PTBMP_STAR0+j; }
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyLnMode[j]=LnMode[j]=LNDSN_STAR0+j; }
		sheetbuffer[currentSheet].MyBgMode=BgMode=BG_STAR;
		for(j=0;j<5;j++){ m_appear._MyP[j].LoadData(PTBMP_STAR0+j); }
		PTextColR=TextColR=255;PTextColG=TextColG=200;PTextColB=TextColB=255;
		TextHilColR=255;TextHilColG=200;TextHilColB=200;
		for(j=0;j<5;j++){AngleColR[j]=TextColR; AngleColG[j]=TextColG; AngleColB[j]=TextColB; }
		BracketColR=TextColR;BracketColG=TextColG;BracketColB=TextColB;
		SetAllAngleColor();SetAllBracketColor();
		m_appear._MyBG.LoadData(BgMode); 
		for(int i=0;i<5;i++){ m_appear._MyL[i].SetLnRgn(LNDSN_STAR0+i); }
		AxisPen.SetColour(128,128,128);
		AxisMeshPen.SetColour(128,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_STAR,true);
		break;
	case THM_KSEG:
		ThemeMode=THM_KSEG;
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyPtMode[j]=PtMode[j]=PTBMP_KSEG0+j; }
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyLnMode[j]=LnMode[j]=LNDSN_KSEG0+j; }
		sheetbuffer[currentSheet].MyBgMode=BgMode=BG_KSEG;
		for(j=0;j<5;j++){ m_appear._MyP[j].LoadData(PTBMP_KSEG0+j); }
		PTextColR=TextColR=0;PTextColG=TextColG=0;PTextColB=TextColB=0;
		TextHilColR=255;TextHilColG=0;TextHilColB=0;
		for(j=0;j<5;j++){AngleColR[j]=TextColR; AngleColG[j]=TextColG; AngleColB[j]=TextColB; }
		BracketColR=TextColR;BracketColG=TextColG;BracketColB=TextColB;
		SetAllAngleColor();SetAllBracketColor();
		m_appear._MyBG.LoadData(BgMode); 
		for(int i=0;i<5;i++){ m_appear._MyL[i].SetLnRgn(LNDSN_KSEG0+i); }
		AxisPen.SetColour(128,128,128);
		AxisMeshPen.SetColour(128,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_KSEG,true);
		break;
	case THM_CINDY:
		ThemeMode=THM_CINDY;
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyPtMode[j]=PtMode[j]=PTBMP_CINDY0+j; }
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyLnMode[j]=LnMode[j]=LNDSN_CINDY0+j; }
		sheetbuffer[currentSheet].MyBgMode=BgMode=BG_CINDY;
		for(j=0;j<5;j++){ m_appear._MyP[j].LoadData(PTBMP_CINDY0+j); }
		PTextColR=TextColR=0;PTextColG=TextColG=0;PTextColB=TextColB=0;
		TextHilColR=255;TextHilColG=255;TextHilColB=255;
		for(j=0;j<5;j++){AngleColR[j]=TextColR; AngleColG[j]=TextColG; AngleColB[j]=TextColB; }
		BracketColR=TextColR;BracketColG=TextColG;BracketColB=TextColB;
		SetAllAngleColor();SetAllBracketColor();
		m_appear._MyBG.LoadData(BgMode); 
		for(int i=0;i<5;i++){ m_appear._MyL[i].SetLnRgn(LNDSN_CINDY0+i); }
		AxisPen.SetColour(128,128,128);
		AxisMeshPen.SetColour(128,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_CINDY,true);
		break;
	case THM_PASTEL:
		ThemeMode=THM_PASTEL;
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyPtMode[j]=PtMode[j]=PTBMP_PASTEL0+j; }
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyLnMode[j]=LnMode[j]=LNDSN_PASTEL0+j; }
		sheetbuffer[currentSheet].MyBgMode=BgMode=BG_PASTEL;
		for(j=0;j<5;j++){ m_appear._MyP[j].LoadData(PTBMP_PASTEL0+j); }
		PTextColR=TextColR=0;PTextColG=TextColG=150;PTextColB=TextColB=150;
		TextHilColR=50;TextHilColG=200;TextHilColB=200;
		for(j=0;j<5;j++){AngleColR[j]=TextColR; AngleColG[j]=TextColG; AngleColB[j]=TextColB; }
		BracketColR=TextColR;BracketColG=TextColG;BracketColB=TextColB;
		SetAllAngleColor();SetAllBracketColor();
		m_appear._MyBG.LoadData(BgMode); 
		for(int i=0;i<5;i++){ m_appear._MyL[i].SetLnRgn(LNDSN_PASTEL0+i); }
		AxisPen.SetColour(128,128,128);
		AxisMeshPen.SetColour(128,128,128);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_PASTEL,true);
		break;
	case THM_SKELETON:
		ThemeMode=THM_SKELETON;
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyPtMode[j]=PtMode[j]=PTBMP_SKELETON0; }
		for(j=0;j<5;j++){ sheetbuffer[currentSheet].MyLnMode[j]=LnMode[j]=LNDSN_SKELETON0; }
		sheetbuffer[currentSheet].MyBgMode=BgMode=BG_SKELETON;
		for(j=0;j<5;j++){ m_appear._MyP[j].LoadData(PTBMP_SKELETON0); }
		PTextColR=TextColR=255;PTextColG=TextColG=255;PTextColB=TextColB=255;
		TextHilColR=255;TextHilColG=200;TextHilColB=200;
		for(j=0;j<5;j++){AngleColR[j]=TextColR; AngleColG[j]=TextColG; AngleColB[j]=TextColB; }
		BracketColR=TextColR;BracketColG=TextColG;BracketColB=TextColB;
		SetAllAngleColor();SetAllBracketColor();
		m_appear._MyBG.LoadData(BgMode); 
		for(int i=0;i<5;i++){ m_appear._MyL[i].SetLnRgn(LNDSN_SKELETON0); }
		AxisPen.SetColour(200,200,200);
		AxisMeshPen.SetColour(200,200,200);
		BGbmp=false;
		m_owner->menuTheme->Check(THM_SKELETON,true);
		break;
	}
}

void MyCanvas::OnAg(int id)
{
	GAngle* agp;
	AngleMode=AG_1+id;
	for(agp=ags;agp!=NULL;agp=agp->next){
		if(agp->hilighted){
			agp->m_angle_design=id;
		}
	}
}
void MyFrame::OnAg0(wxCommandEvent& event)
{
	m_canvas->OnAg(0);
	Refresh(false);
}
void MyFrame::OnAg1(wxCommandEvent& event)
{
	m_canvas->OnAg(1);
	Refresh(false);
}
void MyFrame::OnAg2(wxCommandEvent& event)
{
	m_canvas->OnAg(2);
	Refresh(false);
}
void MyFrame::OnAg3(wxCommandEvent& event)
{
	m_canvas->OnAg(3);
	Refresh(false);
}
void MyFrame::OnAg4(wxCommandEvent& event)
{
	m_canvas->OnAg(4);
	Refresh(false);
}



void MyFrame::OnBg(wxCommandEvent& event)
{
	OnAppearSelect(event);
}


void MyCanvas::OnLn(int id)
{
	GLine* lnp;
	GCircle* cip;
	GParaCurve* cup;
	LineMode=LN_1+id;
	for(lnp=lns;lnp!=NULL;lnp=lnp->next){
		if(lnp->hilighted){
			lnp->lndsn=id;
		}
	}
	for(cip=cis;cip!=NULL;cip=cip->next){
		if(cip->hilighted){
			cip->lndsn=id;
		}
	}
	for(cup=curves;cup!=NULL;cup=cup->next){
		if(cup->hilighted){
			cup->lndsn=id;
		}
	}
}
void MyFrame::OnLn0(wxCommandEvent& event)
{
	m_canvas->OnLn(0);
	Refresh(false);
}
void MyFrame::OnLn1(wxCommandEvent& event)
{
	m_canvas->OnLn(1);
	Refresh(false);
}
void MyFrame::OnLn2(wxCommandEvent& event)
{
	m_canvas->OnLn(2);
	Refresh(false);
}

void MyFrame::OnLn3(wxCommandEvent& event)
{
	m_canvas->OnLn(3);
	Refresh(false);
}
void MyFrame::OnLn4(wxCommandEvent& event)
{
	m_canvas->OnLn(4);
	Refresh(false);
}

void MyFrame::OnModeRedo(wxCommandEvent& event)
{
	m_canvas->OnRedo();
	if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		enableToolbar();
	}
	Refresh(false);
}

void MyFrame::OnModeUndo(wxCommandEvent& event)
{
	m_canvas->OnUndo();
	if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		enableToolbar();
	}
	Refresh(false);
}

void MyCanvas::OnPt(int id)
{
	GPoint* ptp;
	PointMode=PT_1+id;
	for(ptp=pts;ptp!=NULL;ptp=ptp->next){
		if(ptp->hilighted){
			ptp->ptbmp=id;
			ptp->hilightphase=0;
		}
	}
}
void MyFrame::OnPt0(wxCommandEvent& event)
{
	m_canvas->OnPt(0);
	Refresh(false);
}
void MyFrame::OnPt1(wxCommandEvent& event)
{
	m_canvas->OnPt(1);
	Refresh(false);
}
void MyFrame::OnPt2(wxCommandEvent& event)
{
	m_canvas->OnPt(2);
	Refresh(false);
}
void MyFrame::OnPt3(wxCommandEvent& event)
{
	m_canvas->OnPt(3);
	Refresh(false);
}
void MyFrame::OnPt4(wxCommandEvent& event)
{
	m_canvas->OnPt(4);
	Refresh(false);
}
void MyCanvas::OnRedo()
{
	GConst *cnp=PopConst();
	if(cnp!=NULL){
		*lastcn=cnp;
		lastcn=&(cnp->next);
		switch(cnp->Output_Type()){
		case OUTPUT_POINT:
			cnp->POutput->invisible=false;
			CheckIncidency(cnp->POutput,false);
			break;
		case OUTPUT_LINE:
			cnp->LOutput->invisible=false;break;
		case OUTPUT_CIRCLE:
			cnp->COutput->invisible=false;break;
		case OUTPUT_TEXT:
			cnp->TextOutput->invisible=false;break;
		case OUTPUT_CURVE:
			cnp->CurveOutput->invisible=false;break;
		case OUTPUT_ANGLE:
			cnp->AngleOutput->invisible=false;break;
		case OUTPUT_BRACKET:
			cnp->BracketOutput->invisible=false;break;
		case CONST_INVISIBLE:
			if(cnp->LInput1!=NULL){
				cnp->LInput1->invisible=true;
			}
			if(cnp->PInput1!=NULL){
				cnp->PInput1->invisible=true;
			}
			if(cnp->CInput1!=NULL){
				cnp->CInput1->invisible=true;
			}
			if(cnp->TextInput1!=NULL){
				cnp->TextInput1->invisible=true;
			}
			if(cnp->AngleInput1!=NULL){
				cnp->AngleInput1->invisible=true;
			}
			break;
		case CONST_ZOOMIN:
			OnModeZoomIn(1.2);
			break;
		case CONST_ZOOMOUT:
			OnModeZoomOut(1.2);
			break;
		}
		EvaluateConst(cns);
		Refresh(false);
		ResetAllName();
	}
}

void MyFrame::OnThemeCat(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_CAT);
	Refresh(false);
}
void MyFrame::OnThemeCindy(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_CINDY);
	Refresh(false);
}
void MyFrame::OnThemeKseg(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_KSEG);
	Refresh(false);
}
void MyFrame::OnThemePastel(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_PASTEL);
	Refresh(false);
}
void MyFrame::OnThemeSkeleton(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_SKELETON);
	Refresh(false);
}

void MyFrame::OnThemeStandard(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_STANDARD);
	Refresh(false);
}
void MyFrame::OnThemeStar(wxCommandEvent& event)
{
	m_canvas->SetTheme(THM_STAR);
	Refresh(false);
}

void MyCanvas::OnUndo()
{
	GConst *cnp, **cnh;
	cnh=&cns;
	for(cnp=cns;cnp!=NULL;cnp=cnp->next){
		if(cnp->next==NULL){
			switch(cnp->Output_Type()){
			case OUTPUT_POINT:
				DeletePtFromIcs(cnp->POutput);
				cnp->POutput->invisible=true;
				if(cnp->POutput->hilighted){
					NOhilightedPoints--;
					cnp->POutput->hilighted=false;
				}
				break;
			case OUTPUT_LINE:
				cnp->LOutput->invisible=true;
				if(cnp->LOutput->hilighted){
					NOhilightedLines--;
					cnp->LOutput->hilighted=false;
				}
				break;
			case OUTPUT_CIRCLE:
				cnp->COutput->invisible=true;
				if(cnp->COutput->hilighted){
					NOhilightedCircles--;
					cnp->COutput->hilighted=false;
				}
				break;
			case OUTPUT_TEXT:
				cnp->TextOutput->invisible=true;
				if(cnp->TextOutput->hilighted){
					NOhilightedTexts--;
					cnp->TextOutput->hilighted=false;
				}
				break;
			case OUTPUT_CURVE:
				cnp->CurveOutput->invisible=true;
				if(cnp->CurveOutput->hilighted){
					NOhilightedCurves--;
					cnp->CurveOutput->hilighted=false;
				}
				break;
			case OUTPUT_ANGLE:
				cnp->AngleOutput->invisible=true;
				if(cnp->AngleOutput->hilighted){
					NOhilightedAngles--;
					cnp->AngleOutput->hilighted=false;
				}
				break;
			case OUTPUT_BRACKET:
				cnp->BracketOutput->invisible=true;
				if(cnp->BracketOutput->hilighted){
					NOhilightedBrackets--;
					cnp->BracketOutput->hilighted=false;
				}
				break;
			case CONST_INVISIBLE:
				if(cnp->LInput1!=NULL){
					cnp->LInput1->invisible=false;
				}
				if(cnp->PInput1!=NULL){
					cnp->PInput1->invisible=false;
				}
				if(cnp->CInput1!=NULL){
					cnp->CInput1->invisible=false;
				}
				if(cnp->TextInput1!=NULL){
					cnp->TextInput1->invisible=false;
				}
				if(cnp->AngleInput1!=NULL){
					cnp->AngleInput1->invisible=false;
				}
				break;
			case CONST_ZOOMIN:
				OnModeZoomOut(1.2);
				break;
			case CONST_ZOOMOUT:
				OnModeZoomIn(1.2);
				break;
			}
			PushConst(cnp);
			lastcn=cnh;
			*lastcn=NULL;
			EvaluateConst(cns);
			Refresh(false);
			ResetAllName();
			return;
		}
		cnh=&(cnp->next);
	}
}

void MyCanvas::DeleteConst(GConst* cn)
{
	if(cns==NULL){
		return ; 
	}
	GConst *cnp;
	GConst **cnh;
	cnh=&cns;
	for(cnp=cns;cnp!=NULL;cnp=cnp->next){
		if(cnp==cn){
			switch(cnp->Output_Type()){
			case OUTPUT_POINT:
				DeletePoint(cnp->POutput); break;
			case OUTPUT_LINE:
				DeleteLine(cnp->LOutput); break;
			case OUTPUT_CIRCLE:
				DeleteCircle(cnp->COutput); break;
			case OUTPUT_TEXT:
				DeleteText(cnp->TextOutput); break;
			case OUTPUT_CURVE:
				DeleteCurve(cnp->CurveOutput); break;
			case OUTPUT_ANGLE:
				DeleteAngle(cnp->AngleOutput); break;
			case OUTPUT_IMAGE:
				DeleteImage(cnp->ImageOutput); break;
			}
			cnp->used=false;
			*cnh=cnp->next;
			if(cnp->next==NULL){
				lastcn=cnh;
			}
			return ;
		}
		cnh=&(cnp->next);
	}
}

void MyCanvas::PushConst(GConst* cn)
{
	if(cns==NULL){
		return ; 
	}
	if(NOConstStock<255){
		PushConstStock[NOConstStock]=cn;
		NOConstStock++;
	}
	cn->used=false;
}

GConst*  MyCanvas::PopConst()
{
	if(NOConstStock==0){
		return NULL;
	}
	else {
		NOConstStock--;
		PushConstStock[NOConstStock]->used=true;
		return PushConstStock[NOConstStock];
	}
}


void MyCanvas::DeletePoint(GPoint* pt)
{
	if(pts==NULL){
		return;
	}
	GPoint *ptp;
	GPoint **pth;
	GConst *cnp;
	int i;
	//printf("Debug: DeletePoint: comes\n");
	DeletePtFromIcs(pt);
	pth=&pts;
	for(ptp=pts;ptp!=NULL;ptp=ptp->next){
		if(ptp==pt){
			//printf("Debug: DeletePoint: really deleted\n");
			ptp->used=false;
			*pth=ptp->next;
			if(ptp->next==NULL){
				lastpt=pth;
				*lastpt=NULL; // it must be no use;
			}
			if(ptp->hilighted){
				for(i=0; hilightedPoints[i]!=ptp&&i<NOhilightedPoints; i++){
				}
				NOhilightedPoints--;
				for(; i<NOhilightedPoints; i++){
					hilightedPoints[i]=hilightedPoints[i+1];
				}
			}
			last_pt_name=wxString((wxChar*)"A");
			if(FindNameFromCns(cns,last_pt_name,&cnp)){
				next_name(last_pt_name);
			}
#if __BUFFER_ON
#else
			delete []ptp;
#endif
			return;
		}
		pth=&(ptp->next);
	}
}


void MyCanvas::DeleteLine(GLine* ln)
{
	if(lns==NULL){
		return;
	}
	GLine *lnp;
	GLine **lnh;
	GConst *cnp;
	int i;
	lnh=&lns;
	for(lnp=lns;lnp!=NULL;lnp=lnp->next){
		if(lnp==ln){
			lnp->used=false;
			*lnh=lnp->next;
			if(lnp->next==NULL){
				lastln=lnh;
			}
			if(lnp->hilighted){
				for(i=0; hilightedLines[i]!=lnp&&i<NOhilightedLines; i++){
				}
				NOhilightedLines--;
				for(; i<NOhilightedLines; i++){
					hilightedLines[i]=hilightedLines[i+1];
				}
			}
			last_ln_name=wxString((wxChar*)"a");
			if(FindNameFromCns(cns,last_ln_name,&cnp)){
				next_name(last_ln_name);
			}
#if __BUFFER_ON
#else
			delete []lnp;
#endif
			return ;
		}
		lnh=&(lnp->next);
	}
}

void MyCanvas::DeleteCircle(GCircle* ci)
{
	if(cis==NULL){
		return;
	}
	GCircle *cip;
	GCircle **cih;
	GConst *cnp;
	int i;
	cih=&cis;
	for(cip=cis;cip!=NULL;cip=cip->next){
		if(cip==ci){
			cip->used=false;
			*cih=cip->next;
			if(cip->next==NULL){
				lastci=cih;
			}
			if(cip->hilighted){
				for(i=0; hilightedCircles[i]!=cip&&i<NOhilightedCircles; i++){
				}
				NOhilightedCircles--;
				for(; i<NOhilightedCircles; i++){
					hilightedCircles[i]=hilightedCircles[i+1];
				}
			}
			last_ci_name=wxString((wxChar*)"C1");
			if(FindNameFromCns(cns,last_ci_name,&cnp)){
				next_name(last_ci_name);
			}
			return ;
		}
		cih=&(cip->next);
	}
}

void MyCanvas::DeleteText(GText* text)
{
	if(texts==NULL){
		return;
	}
	GText *textp;
	GText **texth;
	texth=&texts;
	for(textp=texts;textp!=NULL;textp=textp->next){
		if(textp==text){
			textp->used=false;
			*texth=textp->next;
			if(textp->next==NULL){
				lasttext=texth;
			}
			return ;
		}
		texth=&(textp->next);
	}
}

void MyCanvas::DeleteCurve(GParaCurve* curve)
{
	if(curves==NULL){
		return;
	}
	GParaCurve *cvp;
	GParaCurve **cvh;
	GConst *cnp;
	int i;
	cvh=&curves;
	for(cvp=curves;cvp!=NULL;cvp=cvp->next){
		if(cvp==curve){
			cvp->used=false;
			*cvh=cvp->next;
			if(cvp->next==NULL){
				lastcurve=cvh;
			}
			if(cvp->hilighted){
				for(i=0; hilightedCurves[i]!=cvp&&i<NOhilightedCurves; i++){
				}
				NOhilightedCurves--;
				for(; i<NOhilightedCurves; i++){
					hilightedCurves[i]=hilightedCurves[i+1];
				}
			}
			last_curve_name=wxString((wxChar*)"x1");
			if(FindNameFromCns(cns,last_curve_name,&cnp)){
				next_name(last_curve_name);
			}
			return;
		}
		cvh=&(cvp->next);
	}
}

void MyCanvas::DeleteAngle(GAngle* angle)
{
	if(ags==NULL){
		return;
	}
	GAngle *agp;
	GAngle **agh;
	GConst*cnp;
	int i;
	agh=&ags;
	for(agp=ags;agp!=NULL;agp=agp->next){
		if(agp==angle){
			agp->used=false;
			*agh=agp->next;
			if(agp->next==NULL){
				lastag=agh;
			}
			if(agp->hilighted){
				for(i=0; hilightedAngles[i]!=agp&&i<NOhilightedAngles; i++){
				}
				NOhilightedAngles--;
				for(; i<NOhilightedAngles; i++){
					hilightedAngles[i]=hilightedAngles[i+1];
				}
			}
			last_ag_name=wxString((wxChar*)"ag1");
			if(FindNameFromCns(cns,last_ag_name,&cnp)){
				next_name(last_ag_name);
			}
			return;
		}
		agh=&(agp->next);
	}
}

void MyCanvas::DeleteImage(GImage* image)
{
	if(ims==NULL){
		return;
	}
	GImage *imp;
	GImage **imh;
	GConst*cnp;
	int i;
	imh=&ims;
	for(imp=ims;imp!=NULL;imp=imp->next){
		if(imp==image){
			imp->used=false;
			*imh=imp->next;
			if(imp->next==NULL){
				lastim=imh;
			}
			if(imp->hilighted){
				for(i=0; hilightedImages[i]!=imp&&i<NOhilightedImages; i++){
				}
				NOhilightedImages--;
				for(; i<NOhilightedImages; i++){
					hilightedImages[i]=hilightedImages[i+1];
				}
			}
			last_im_name=wxString((wxChar*)"im1");
			if(FindNameFromCns(cns,last_im_name,&cnp)){
				next_name(last_im_name);
			}
			delete []image;
			return;
		}
		imh=&(imp->next);
	}
}

void MyCanvas::DeleteBracket(GBracket* br)
{
	if(brs==NULL){
		return;
	}
	GBracket *brp;
	GBracket **brh;
	GConst*cnp;
	int i;
	brh=&brs;
	for(brp=brs;brp!=NULL;brp=brp->next){
		if(brp==br){
			brp->used=false;
			*brh=brp->next;
			if(brp->next==NULL){
				lastbr=brh;
			}
			if(brp->hilighted){
				for(i=0; hilightedBrackets[i]!=brp&&i<NOhilightedBrackets; i++){
				}
				NOhilightedBrackets--;
				for(; i<NOhilightedBrackets; i++){
					hilightedBrackets[i]=hilightedBrackets[i+1];
				}
			}
			last_br_name=wxString((wxChar*)"br1");
			if(FindNameFromCns(cns,last_br_name,&cnp)){
				next_name(last_br_name);
			}
			return;
		}
		brh=&(brp->next);
	}
}


void MyFrame::OnModeMove(wxCommandEvent& event)
{
	m_canvas->DocMode=MODE_MOVE;
	enableToolbar();
	m_tbar1->ToggleTool(MODE_MOVE,true);
}
void MyFrame::OnModeSPoint(wxCommandEvent& event)
{
	m_canvas->DocMode=MODE_SINGLE_ADD;
	enableToolbar();
	m_tbar1->ToggleTool(MODE_SINGLE_ADD,true);
}
void MyFrame::OnModeMLine(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_MULTI_LINE;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_MULTI_LINE,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefLine();
	}
}
void MyFrame::OnModePara(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_PARALLEL;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_PARALLEL,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefPara();
	}
}
void MyFrame::OnModePerp(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_PERP;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_PERP,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefPerp();
	}
}
void MyFrame::OnModeMid(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_MID;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_MID,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefMid();
	}
}

void MyFrame::OnModeMCircle(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_MULTI_CIRCLE;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_MULTI_CIRCLE,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefCircle();
	}
}

void MyFrame::OnModeBisector(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->UInputCount=0;
		m_canvas->ClearAllHilights();
		m_canvas->DocMode=MODE_BISECTOR;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_BISECTOR,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefBisector();
	}
}

void MyFrame::OnIdModeTangent(wxCommandEvent& event)
{
	//ext_toolbar=MODE_TANGENT;
	//RecreateToolbar();
}
void MyFrame::OnModeTangent(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_TANGENT;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_TANGENT,true);
		if(m_canvas->NOhilightedCircles>0 && m_canvas->NOhilightedPoints>0){
			m_canvas->ConstDefTangent();
		}
		if(m_canvas->NOhilightedCurves>0 && m_canvas->NOhilightedPoints>0){
			m_canvas->ConstDefCurveTangent();
		}
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		if(m_canvas->NOhilightedCircles>0 && m_canvas->NOhilightedPoints>0){
			m_canvas->ConstDefTangent();
		}
		if(m_canvas->NOhilightedCurves>0 && m_canvas->NOhilightedPoints>0){
			m_canvas->ConstDefCurveTangent();
		}
	}
}

void MyFrame::OnIdModeCircleBy3(wxCommandEvent& event)
{
	//ext_toolbar=MODE_CIRCLE_BY_3;
	//RecreateToolbar();
}
void MyFrame::OnModeCircleBy3(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_CIRCLE_BY_3;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_CIRCLE_BY_3,true);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefCircleBy3();
	}
}

void MyFrame::OnModeText(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_TEXT;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_TEXT,true);
		m_tbar1->ToggleTool(MODE_IMAGE,false);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->KSEGtexton=!m_canvas->KSEGtexton;
		enableToolbar();
		if(m_canvas->KSEGtexton){
			m_tbar1->ToggleTool(MODE_TEXT,true);
		}
		m_canvas->KSEGimageon=false;
		m_tbar1->ToggleTool(MODE_IMAGE,false);
	}
}

void MyFrame::OnModeImage(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_IMAGE;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_IMAGE,true);
		m_tbar1->ToggleTool(MODE_TEXT,false);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->KSEGimageon=!m_canvas->KSEGimageon;
		enableToolbar();
		if(m_canvas->KSEGimageon){
			m_tbar1->ToggleTool(MODE_IMAGE,true);
		}
		m_canvas->KSEGtexton=false;
		m_tbar1->ToggleTool(MODE_TEXT,false);
	}
}

void MyFrame::OnModeSelect(wxCommandEvent& event)
{
	m_canvas->DocMode=MODE_SELECT;
	enableToolbar();
	m_tbar1->ToggleTool(MODE_SELECT,true);
}
void MyFrame::OnModeMeet(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefMeet();
	}
}
int GetRBInGraphText(wxString& str);
void MyFrame::OnModeGraph(wxCommandEvent& event)
{
	GConst* thiscn;
	GParaCurve *thiscurve;
	GraphDialog* myd=new GraphDialog(this);
	wxString str0,str1,str2;
	wxString tgt;
	int i;
	int err;
	int RB;
	const char*p;
	char buff[256];
	int len;
	if(myd->ShowModal() == wxID_OK){
//printf("OK0:");
		str0 = myd->txt1->GetValue();
		sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
		str1 =wxString((wxChar*)buff);
		p=(char*)str1.c_str();
		len=strlen(p);
		if(len==0){
			delete myd;
			return;
		}
//printf("OK1:");
		RB=GetRBInGraphText(str1);
		switch(RB){
		case 0:
//printf("OK2:");
			thiscurve = m_canvas->NewGraphCurve(str1);
			thiscurve->RB=0;
			myd->txtmin->GetValue().ToDouble(&(thiscurve->para_min));
			myd->txtmax->GetValue().ToDouble(&(thiscurve->para_max));
//printf("OK3:");
			DeleteGCalc(thiscurve->gcal_y);
//printf("OK4:");
			EvaluateText(m_canvas->cns,thiscurve->str_y,tgt,true);
//printf("OK5:");
			err=MakeCalcPolynomial(tgt,&(thiscurve->gcal_y));
//printf("OK6:");
			//thiscurve->gcal_y->Print(0);
			//printf("OK err=%d,txt=%s\n",err,str1.c_str());
			//thiscurve->gcal_y->Print(0);
			if(err>0){
				//thiscurve->gcal_y->Print(0);
				wxString message;
				message.Printf(wxT("error %d"),err);
				wxMessageBox(message,InvalidGraphInput,wxOK | wxICON_INFORMATION, this);
			}
			else {
				thiscn = m_canvas->NewConst(CONST_GRAPH);
//printf("OK7:");
				thiscn->CurveOutput=thiscurve;
				thiscn->CurveOutput->_name=wxString((wxChar*)m_canvas->last_curve_name.c_str());
				m_canvas->next_name(m_canvas->last_curve_name);
				m_canvas->AssignCurve(thiscn->CurveOutput);
				m_canvas->WriteConst(thiscn);
				m_canvas->WriteLogFile(wxString((char*)thiscurve->str_y.c_str(),*wxConvCurrent)+wxT("\n"));
				m_canvas->EvaluateConst(m_canvas->cns);
				Refresh(false);
//printf("OK8:");
			}
			break;
		case 1:
			p=(char*)str1.c_str();
			len=strlen(p);
			for(i=0;i<len;i++){
				if(p[i]==','){
					str2=mMid(str1,i+1);
					str1=mLeft(str1,i);
					thiscurve = m_canvas->NewParaCurve(str1,str2);
					thiscurve->RB=1;
					myd->txtmin->GetValue().ToDouble(&(thiscurve->para_min));
					myd->txtmax->GetValue().ToDouble(&(thiscurve->para_max));
					DeleteGCalc(thiscurve->gcal_x);
					DeleteGCalc(thiscurve->gcal_y);
					EvaluateText(m_canvas->cns,thiscurve->str_x,tgt,true);
					err=MakeCalcPolynomial(tgt,&(thiscurve->gcal_x));
					EvaluateText(m_canvas->cns,thiscurve->str_y,tgt,true);
					err |= MakeCalcPolynomial(tgt,&(thiscurve->gcal_y));
					//thiscurve->gcal_y->Print(0);
					if(err>0){
						thiscurve->gcal_x->Print(0);
						thiscurve->gcal_y->Print(0);
						wxString message;
						message.Printf(wxT("error %d"),err);
						wxMessageBox(message,InvalidGraphInput,wxOK | wxICON_INFORMATION, this);

					}
					else {
						thiscn = m_canvas->NewConst(CONST_PARA_CURVE);
						thiscn->CurveOutput=thiscurve;
						thiscn->CurveOutput->_name=wxString((wxChar*)m_canvas->last_curve_name.c_str());
						m_canvas->next_name(m_canvas->last_curve_name);
						m_canvas->AssignCurve(thiscn->CurveOutput);
						m_canvas->WriteConst(thiscn);
						m_canvas->WriteLogFile(wxString((char*)str1.c_str(),*wxConvCurrent)+wxT(",")+wxString((char*)str2.c_str(),*wxConvCurrent)+wxT("\n"));
						m_canvas->EvaluateConst(m_canvas->cns);
						Refresh(false);
					}
				}
			}
			break;
		}
	}
	delete myd;
 }


void MyFrame::OnModeCompass(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_COMPASS;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_COMPASS,true);
	}
	if(m_canvas->pts!=NULL){
		m_canvas->pts->ClearHilight();
	}
	m_canvas->NOhilightedPoints=0;
	m_canvas->compasscursorx=m_canvas->compasscursory=0;
	m_canvas->compasscenterx=m_canvas->compasscentery=0;
}

void MyFrame::OnModeOrbit(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_ORBIT;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_ORBIT,true);
		if(m_canvas->pts!=NULL){
			m_canvas->pts->ClearHilight();
			m_canvas->NOhilightedPoints=0;
		}
		Refresh(false);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefOrbit();
	}
}

void MyFrame::OnModeAngle(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_ANGLE;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_ANGLE,true);
		if(m_canvas->pts!=NULL){
			m_canvas->pts->ClearHilight();
			m_canvas->NOhilightedPoints=0;
		}
		Refresh(false);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefAngle();
	}
}

void MyFrame::OnModeBracket(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_BRACKET;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_BRACKET,true);
		Refresh(false);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefBracket();
	}
}


void MyFrame::OnModeLineWithAngle(wxCommandEvent & event)
{
	bool exists;
	GConst* cnp,*cnp1,*cnp2,*cnp3;
	wxString str0,str1;
	char buff[256];

	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->DocMode=MODE_LINE_WITH_ANGLE;
		enableToolbar();
		m_tbar1->ToggleTool(MODE_LINE_WITH_ANGLE,true);
		if(m_canvas->pts!=NULL){
			m_canvas->pts->ClearHilight();
			m_canvas->NOhilightedPoints=0;
		}
		if(m_canvas->ags!=NULL && m_canvas->NOhilightedAngles>0){
			m_canvas->cursorag=m_canvas->hilightedAngles[0];
		}
		else {
			AngleDialog myd(this);
			if(myd.ShowModal()==wxID_OK){
				if(myd.RB1->GetValue()){
					str0 = myd.txt1->GetValue();
					sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
					str1 =wxString((wxChar*)buff);
					FindNameFromCns(m_canvas->cns,str1,&cnp1);
					str0 = myd.txt2->GetValue();
					sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
					str1 =wxString((wxChar*)buff);
					FindNameFromCns(m_canvas->cns,str1,&cnp2);
					str0 = myd.txt3->GetValue();
					sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
					str1 =wxString((wxChar*)buff);
					FindNameFromCns(m_canvas->cns,str1,&cnp3);
					if(cnp1->POutput==NULL || cnp2->POutput==NULL || cnp3->POutput==NULL){
						return;
					}
					exists=false;
					for(cnp=m_canvas->cns;!exists && cnp!=NULL;cnp=cnp->next){
						// if there is an angle with these points then cursorag = the angle
						//we need much more precise casework
						if(cnp->Const_Type==CONST_3P_ANGLE && cnp->PInput1==cnp1->POutput && cnp->PInput2==cnp2->POutput && cnp->PInput3==cnp3->POutput){
							m_canvas->cursorag=cnp->AngleOutput;
							exists=true;
						}
						else if(cnp->Const_Type==CONST_3P_ANGLE && cnp->PInput1==cnp3->POutput && cnp->PInput2==cnp2->POutput && cnp->PInput3==cnp1->POutput){
							m_canvas->cursorag=cnp->AngleOutput;
							exists=true;
						}
					}
					if(!exists){
					// else cursorag= new angle with the three points.
						//printf("Debug:OnModeLineWithAngle\n");
						//printf("angle %s%s%s\n",cnp1->POutput->_name.c_str(),cnp2->POutput->_name.c_str(),cnp3->POutput->_name.c_str());
						cnp=m_canvas->NewConst(CONST_3P_ANGLE);
						cnp->PInput1=cnp1->POutput;
						cnp->PInput2=cnp2->POutput;
						cnp->PInput3=cnp3->POutput;
						m_canvas->cursorag=m_canvas->NewAngle(0.0);
						m_canvas->AssignAngle(m_canvas->cursorag);
						cnp->AngleOutput=m_canvas->cursorag;
						m_canvas->cursorag->_name=wxString((wxChar*)m_canvas->last_ag_name.c_str());
						m_canvas->next_name(m_canvas->last_ag_name);
						m_canvas->WriteConst(cnp);
						m_canvas->EvaluateConst(m_canvas->cns);
						m_canvas->ClearAllHilights();
						m_canvas->Sethilighted(m_canvas->cursorag);
						enableToolbar();
					}
				}
				else {
					m_canvas->cursorag=NULL;
					str0 = myd.txt4->GetValue();
					sprintf(buff,"%s",(const char*)str0.mb_str(wxConvUTF8));
					str1 =wxString((wxChar*)buff);
					if(!str1.ToDouble(&m_canvas->angle_value)){ m_canvas->angle_value=60.0; }
				}
			}
		}
		Refresh(false);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_canvas->ConstDefLineWithAngle();
	}
}


void MyFrame::OnModeEraser(wxCommandEvent& event)
{
	m_canvas->OnModeEraser();
	Refresh(false);
}

 
void MyFrame::OnModeAxis(wxCommandEvent& event)
{
	m_canvas->AxisOn = !m_canvas->AxisOn;
	Refresh(false);
}
void MyFrame::OnModeClipping(wxCommandEvent& event)
{
	if(m_canvas->GMode==MODE_CINDY){
		m_canvas->LineClipping = !m_canvas->LineClipping;
		if(m_canvas->LineClipping){
			m_tbar1->ToggleTool(MODE_CLIPPING,true);
		}
		else {
			m_tbar1->ToggleTool(MODE_CLIPPING,false);
		}
		GLine* gln;
		GCircle* gci;
		for(gln=m_canvas->lns;gln!=NULL;gln=gln->next){
			if(gln->hilighted){
				gln->clipping=m_canvas->LineClipping;
			}
		}
		for(gci=m_canvas->cis;gci!=NULL;gci=gci->next){
			if(gci->hilighted){
				gci->clipping=m_canvas->LineClipping;
			}
		}
		Refresh(false);
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		if(m_canvas->NOhilightedPoints==2){
			m_canvas->ConstDefClippingLine();
		}
		else if(m_canvas->NOhilightedLines>=1){
			m_canvas->LineClippingon();
		}
	}
}
void MyCanvas::OnModeEraser()
{
	GConst *cnp,*cnq;
	bool deleted=false;

	do{ 
		deleted=false;
		for(cnp=cns;cnp!=NULL&&deleted==false;cnp=cnp->next){ 
			switch(cnp->Output_Type()){
			case OUTPUT_POINT:
				if(cnp->POutput->hilighted){
					DeleteConst(cnp);
					deleted=true;
				}
				break;
	    	case OUTPUT_LINE:
				if(cnp->LOutput->hilighted){
					DeleteConst(cnp);
					deleted=true;
				}
				break;	
			case OUTPUT_CIRCLE:
				if(cnp->COutput->hilighted){
					DeleteConst(cnp);
					deleted=true;
				}
				break;
			case OUTPUT_TEXT:
				if(cnp->TextOutput->hilighted){
					DeleteConst(cnp);
					deleted=true;
				}
				break;
			case OUTPUT_CURVE:
				if(cnp->CurveOutput->hilighted){
					DeleteConst(cnp);
					deleted=true;
				}
				break;
			case OUTPUT_ANGLE:
				if(cnp->AngleOutput->hilighted){
					DeleteConst(cnp);
					deleted=true;
				}
				break;
			case OUTPUT_IMAGE:
				if(cnp->ImageOutput->hilighted){
					DeleteConst(cnp);
					deleted=true;
				}
				break;
			}
			if(deleted==false){
				switch(cnp->Const_Type){
					case CONST_FREE:
					case CONST_TEXT:
					case CONST_GRAPH:
					case CONST_PARA_CURVE:
						break;
					case CONST_ON_LINE: 
					case CONST_JOIN:
					case CONST_MID:
					case CONST_MULTI_CIRCLE:
					case CONST_ORBIT1:
					case CONST_ORBIT2:
						if(!FindPtFromCn(cns,cnp->PInput1,&cnq)||!FindPtFromCn(cns,cnp->PInput2,&cnq)){
							DeleteConst(cnp);
							deleted=true;
						}
						break;	
					case CONST_3P_BISECTOR:
					case CONST_COMPASS:
					case CONST_PT_ON_3P_BISECTOR:
					case CONST_3P_ANGLE:
					case CONST_ORTHOCENTER:
						if(!FindPtFromCn(cns,cnp->PInput1,&cnq)||!FindPtFromCn(cns,cnp->PInput2,&cnq)||!FindPtFromCn(cns,cnp->PInput3,&cnq)){
							DeleteConst(cnp);
							deleted=true;
						}
						break;	
					case CONST_PARALLEL:
					case CONST_PERP:
					case CONST_PT_ON_PARA:
					case CONST_PT_ON_PERP:
					case CONST_LINE_WITH_ANGLE_DEGREE:
					case CONST_PT_ON_LINE_WITH_ANGLE_DEGREE:
						if(!FindPtFromCn(cns,cnp->PInput1,&cnq)||!FindLnFromCn(cns,cnp->LInput1,&cnq)){
							DeleteConst(cnp);
							deleted=true;
						}
						break;
					case CONST_MEET:
					case CONST_BISECTOR:
					case CONST_PT_ON_BISECTOR:
						if(!FindLnFromCn(cns,cnp->LInput1,&cnq)||!FindLnFromCn(cns,cnp->LInput2,&cnq)){
							DeleteConst(cnp);
							deleted=true;
						}
						break;
					case CONST_PT_ON_CIRCLE:
						if(!FindCiFromCn(cns,cnp->CInput1,&cnq)){
							DeleteConst(cnp);
							deleted=true;
						}
						break;
					case CONST_MEET_CL:
						if(!FindCiFromCn(cns,cnp->CInput1,&cnq)||!FindLnFromCn(cns,cnp->LInput1,&cnq)){
							DeleteConst(cnp);
							deleted=true;
						}
						break;
					case CONST_TANGENT:
					case CONST_PT_ON_TANGENT:
						if(!FindCiFromCn(cns,cnp->CInput1,&cnq)||!FindPtFromCn(cns,cnp->PInput1,&cnq)){
							DeleteConst(cnp);
							deleted=true;
						}
						break;
					
					case CONST_PT_ON_CURVE:
						if(!FindCurveFromCn(cns,cnp->CurveInput1,&cnq)){
							DeleteConst(cnp);
							deleted=true;
						}
						break;
					case CONST_MEET_CC:
						if(!FindCiFromCn(cns,cnp->CInput1,&cnq)||!FindCiFromCn(cns,cnp->CInput2,&cnq)){
							DeleteConst(cnp);
							deleted=true;
						}
						break;
					case CONST_CURVE_TANGENT:
					case CONST_PT_ON_CURVE_TANGENT:
						if(!FindCurveFromCn(cns,cnp->CurveInput1,&cnq)||!FindPtFromCn(cns,cnp->PInput1,&cnq)){
							DeleteConst(cnp);
							deleted=true;
						}
						break;
					case CONST_LINE_WITH_ANGLE:
					case CONST_PT_ON_LINE_WITH_ANGLE:
						if(!FindCiFromCn(cns,cnp->CInput1,&cnq)||!FindLnFromCn(cns,cnp->LInput1,&cnq)||!FindAngleFromCn(cns,cnp->AngleInput1,&cnq)){
							DeleteConst(cnp);
							deleted=true;
						}
						break;
				}
			}
		}
	} while(deleted);
	ResetAllName();
}
void MyFrame::OnModeInvisible(wxCommandEvent& event)
{
	m_canvas->OnModeInvisible();
}

void MyCanvas::OnModeInvisible()
{
	if(GMode==MODE_CINDY || GMode==MODE_KSEG || GMode==MODE_PANEL){
		GPoint* ptp;
		GLine* lnp;
		GCircle* cip;
		GConst* cnp; 
		GText *txp;
		GAngle *agp;
		GImage *imp;
		GBracket *brp;
		for(lnp=lns;lnp!=NULL;lnp=lnp->next){
			if(lnp->hilighted){
				lnp->invisible=true;
				cnp=NewConst(CONST_INVISIBLE);
				cnp->LInput1=lnp;
				NOhilightedLines--;
				lnp->hilighted=false;
				WriteConst(cnp);
			}
		}
		for(ptp=pts;ptp!=NULL;ptp=ptp->next){
			if(ptp->hilighted){
				ptp->invisible=true;
				cnp=NewConst(CONST_INVISIBLE);
				cnp->PInput1=ptp;
				NOhilightedPoints--;
				ptp->hilighted=false;
				WriteConst(cnp);
			}
		}
		for(cip=cis;cip!=NULL;cip=cip->next){
			if(cip->hilighted){
				cip->invisible=true;
				cnp=NewConst(CONST_INVISIBLE);
				cnp->CInput1=cip;
				NOhilightedCircles--;
				cip->hilighted=false;
				WriteConst(cnp);
			}
		}
		for(txp=texts;txp!=NULL;txp=txp->next){
			if(txp->hilighted){
				txp->invisible=true;
				cnp=NewConst(CONST_INVISIBLE);
				cnp->TextInput1=txp;
				NOhilightedTexts--;
				txp->hilighted=false;
				WriteConst(cnp);
			}
		}
		for(agp=ags;agp!=NULL;agp=agp->next){
			if(agp->hilighted){
				agp->invisible=true;
				cnp=NewConst(CONST_INVISIBLE);
				cnp->AngleInput1=agp;
				NOhilightedAngles--;
				agp->hilighted=false;
				WriteConst(cnp);
			}
		}
		for(imp=ims;imp!=NULL;imp=imp->next){
			if(imp->hilighted){
				imp->invisible=true;
				cnp=NewConst(CONST_INVISIBLE);
				cnp->ImageInput1=imp;
				NOhilightedImages--;
				imp->hilighted=false;
				WriteConst(cnp);
			}
		}
		for(brp=brs;brp!=NULL;brp=brp->next){
			if(brp->hilighted){
				brp->invisible=true;
				cnp=NewConst(CONST_INVISIBLE);
				cnp->BracketInput1=brp;
				NOhilightedBrackets--;
				brp->hilighted=false;
				WriteConst(cnp);
			}
		}
		Refresh(false);
	}
}
void MyFrame::OnCloneOn(wxCommandEvent& event)
{
	m_canvas->CloneOnOff = !m_canvas->CloneOnOff;
}

void MyCanvas::OnCloneOn(void)
{
	pts1=makePClone(pts);
	pts2=makePClone(pts1);
	pts3=makePClone(pts2);
	lns1=makeLClone(lns);
	lns2=makeLClone(lns1);
	lns3=makeLClone(lns2);
	cis1=makeCClone(cis);
	cis2=makeCClone(cis1);
	cis3=makeCClone(cis2);
}

void MyCanvas::OnCloneOff(void)
{
	deletePClone(pts1);
	deletePClone(pts2);
	deletePClone(pts3);
	deleteLClone(lns1);
	deleteLClone(lns2);
	deleteLClone(lns3);
	deleteCClone(cis1);
	deleteCClone(cis2);
	deleteCClone(cis3);
}

void MyFrame::OnGModeCindy(wxCommandEvent& event)
{
	m_canvas->LineClipping=false;
	m_canvas->GMode=MODE_CINDY;
	m_canvas->DocMode=MODE_MOVE;
	RecreateToolbar();
}
void MyFrame::OnGModeKseg(wxCommandEvent& event)
{
	m_canvas->LineClipping=false;
	m_canvas->GMode=MODE_KSEG;
	m_canvas->KSEGtexton=false;
	m_canvas->KSEGimageon=false;
	m_canvas->DocMode=MODE_MOVE;
	RecreateToolbar();
}
void MyFrame::OnGModePanel(wxCommandEvent& event)
{
	m_canvas->LineClipping=false;
	m_canvas->GMode=MODE_PANEL;
	m_canvas->KSEGtexton=false;
	m_canvas->KSEGimageon=false;
	m_canvas->DocMode=MODE_MOVE;
	m_canvas->PanelShift=m_canvas->PanelAdd=m_canvas->PanelMove=false;
	m_canvas->PanelDragPoint=m_canvas->PanelDragText=m_canvas->PanelDragPointName=false;
	RecreateToolbar();
}

void MyFrame::OnSlideShowStart(wxCommandEvent& event)
{
	GConst *cnp;
	if(m_canvas->SMode==false){
		m_canvas->SMode=true;
		m_canvas->anim_cn=NULL;
		m_canvas->anim_wait=false;
		m_canvas->SlideShowStart(m_canvas->cns);
		if(m_canvas->anim_cn==NULL){
			//wxMessageBox(wxT("OnSlideShowStart:anim_cn==NULL"),wxT("Debugging"),wxOK | wxICON_INFORMATION, this);
			m_canvas->anim_wait=true;
		}
	}
	else {
		m_canvas->SMode=false;
		m_canvas->anim_cn=NULL;
		m_canvas->anim_wait=false;
		for(cnp=m_canvas->cns;cnp!=NULL;cnp=cnp->next){
			switch(cnp->Const_Type){
			case CONST_EFFECT_POINT:
				cnp->anim_entry->POutput->offsetx=0;
				cnp->anim_entry->POutput->offsety=0;
				cnp->anim_entry->POutput->vanishing=0;
				break;
			case CONST_EFFECT_LINE:
				cnp->anim_entry->LOutput->offsetx=0;
				cnp->anim_entry->LOutput->offsety=0;
				cnp->anim_entry->LOutput->vanishing=0;
				break;
			case CONST_EFFECT_TEXT:
				cnp->anim_entry->TextOutput->offsetx=0;
				cnp->anim_entry->TextOutput->offsety=0;
				cnp->anim_entry->TextOutput->vanishing=0;
				break;
			case CONST_EFFECT_CIRCLE:
				cnp->anim_entry->COutput->offsetx=0;
				cnp->anim_entry->COutput->offsety=0;
				cnp->anim_entry->COutput->vanishing=0;
				break;
			case CONST_EFFECT_CURVE:
				break;
			case CONST_EFFECT_ANGLE:
				cnp->anim_entry->AngleOutput->offsetx=0;
				cnp->anim_entry->AngleOutput->offsety=0;
				cnp->anim_entry->AngleOutput->vanishing=0;
				break;
			case CONST_EFFECT_IMAGE:
				cnp->anim_entry->ImageOutput->offsetx=0;
				cnp->anim_entry->ImageOutput->offsety=0;
				cnp->anim_entry->ImageOutput->vanishing=0;
				break;
			case CONST_EFFECT_BRACKET:
				cnp->anim_entry->BracketOutput->offsetx=0;
				cnp->anim_entry->BracketOutput->offsety=0;
				cnp->anim_entry->BracketOutput->vanishing=0;
				break;
			}
		}
	}
	Refresh(false);
}


class ScriptDialog : public wxDialog
{
public:
	// ctor
	ScriptDialog(MyFrame* parent);

	MyCanvas* granpa;
	wxTextCtrl *m_textrich;
	wxTextCtrl *sheetnumber;
	wxButton *myB1,*myB2,*myB3,*myB4,*myB5;

	void OnScriptPrevSheet(wxCommandEvent& event);
	void OnScriptNextSheet(wxCommandEvent& event);
	void OnScriptNewSheet(wxCommandEvent& event);

private:
	DECLARE_EVENT_TABLE()
};

BEGIN_EVENT_TABLE(ScriptDialog, wxDialog)
	EVT_BUTTON (ID_FILE_EDIT_PREV, ScriptDialog::OnScriptPrevSheet)
	EVT_BUTTON (ID_FILE_EDIT_NEXT, ScriptDialog::OnScriptNextSheet)
	EVT_BUTTON (ID_FILE_EDIT_NEW,  ScriptDialog::OnScriptNewSheet)
END_EVENT_TABLE()

ScriptDialog::ScriptDialog(MyFrame *parent)
:wxDialog(parent,wxID_ANY,MenuEditSourceTitle,wxPoint(50,50),wxSize(500,600),wxDEFAULT_DIALOG_STYLE,wxT(""))
{
	granpa = parent->m_canvas;
	myB1 = new wxButton(this,wxID_OK,ScriptButtonApply,wxPoint(10,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
	myB2 = new wxButton(this,ID_FILE_EDIT_PREV,ScriptButtonPrev,wxPoint(110,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
	myB3 = new wxButton(this,ID_FILE_EDIT_NEXT,ScriptButtonNext,wxPoint(210,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
	myB4 = new wxButton(this,ID_FILE_EDIT_NEW,ScriptButtonNew,wxPoint(310,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
#ifdef __WXMSW__
	myB5 = new wxButton(this,wxID_CANCEL,ScriptButtonCancel,wxPoint(410,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
#else
	myB5 = new wxButton(this,wxID_CANCEL,/*ScriptButtonCancel*/ wxT(""),wxPoint(410,10),wxSize(75,25),0, wxDefaultValidator, wxT("button"));
#endif
	m_textrich = new wxTextCtrl(this, wxID_ANY, wxT(""),
				wxPoint(10, 75), wxSize(470, 500),
				wxHSCROLL | wxTE_MULTILINE);
	sheetnumber = new wxTextCtrl(this, wxID_ANY, wxString::Format(wxT("Sheet: %d/%d"), granpa->currentSheet+1,granpa->NOMySheet ),wxPoint(10,45),wxSize(470,25),wxTE_READONLY );
}

void ScriptDialog::OnScriptPrevSheet(wxCommandEvent& event)
{
	if(granpa->currentSheet==0){
		return ;
	}
	granpa->DeleteAllConstFromSheet(granpa->sheetbuffer[granpa->currentSheet].MyConst);
	granpa->MoveSheet(true);
	granpa->const_src=m_textrich->GetValue();
	granpa->const_src2cns(false,true);
	if(granpa->currentSheet>0){
		granpa->currentSheet --;
	}
	granpa->MoveSheet(false);
	sheetnumber->Clear();
	sheetnumber->WriteText(wxString::Format(wxT("Sheet: %d/%d"), granpa->currentSheet+1,granpa->NOMySheet ));
	m_textrich->Clear();
	granpa->const_src=(wxString)wxT("");
	granpa->SetConstSrc(granpa->cns);
	m_textrich->WriteText(granpa->const_src);
	granpa->ResetAllName();
}

void ScriptDialog::OnScriptNextSheet(wxCommandEvent& event)
{
	if(granpa->currentSheet==granpa->NOMySheet-1){
		return;
	}
	granpa->DeleteAllConstFromSheet(granpa->sheetbuffer[granpa->currentSheet].MyConst);
	granpa->MoveSheet(true);
	granpa->const_src=m_textrich->GetValue();
	granpa->const_src2cns(false,true);

	if(granpa->currentSheet<granpa->NOMySheet-1){
		granpa->currentSheet ++;
	}
	granpa->MoveSheet(false);
	sheetnumber->Clear();
	sheetnumber->WriteText(wxString::Format(wxT("Sheet: %d/%d"), granpa->currentSheet+1,granpa->NOMySheet ));
	m_textrich->Clear();
	granpa->const_src=(wxString)wxT("");
	granpa->SetConstSrc(granpa->cns);
	m_textrich->WriteText(granpa->const_src);
	granpa->ResetAllName();
}
void ScriptDialog::OnScriptNewSheet(wxCommandEvent& event)
{
	granpa->InsertNewSheet();
	sheetnumber->Clear();
	sheetnumber->WriteText(wxString::Format(wxT("Sheet: %d/%d"), granpa->currentSheet+1,granpa->NOMySheet ));
	m_textrich->Clear();
}
			 
void MyFrame::OnEditText(wxCommandEvent& event)
{
	ScriptDialog myD(this);
	m_canvas->const_src=(wxString)wxT("");
	m_canvas->SetConstSrc(m_canvas->cns);
	char*p=(char*)m_canvas->const_src.c_str();
	int l=strlen(p);
	char * str1= new char[l+1];
	sprintf(str1,"%s",p);
	wxString str2(str1, *wxConvCurrent);
	myD.m_textrich->WriteText(str2);
	bool loop=false;
	do{
		if(myD.ShowModal()==wxID_OK){
			m_canvas->DeleteAllConstFromSheet(m_canvas->sheetbuffer[m_canvas->currentSheet].MyConst);
			m_canvas->MoveSheet(true);
			wxString str=wxT("                \n")+myD.m_textrich->GetValue();
			const char*p=(const char*) str.mb_str(wxConvUTF8);
			char* q;
			for(q=(char*)p;*q!='\n';q++) ;
			q++;
			m_canvas->const_src=wxString((wxChar*)q);
			m_canvas->const_src2cns(false,true);
		}
		else {
			loop=false;
		}
	} while(loop);
}

void MyFrame::OnSlideShowProperty(wxCommandEvent& event)
{
	m_canvas->AnimationProperty();
}

void MyFrame::OnNextSheet(wxCommandEvent& event)
{
	m_canvas->NextSheet();
	SetStatusText(wxString::Format(wxT("Sheet %d"),m_canvas->currentSheet+1));
	Refresh(false);
}
void MyFrame::OnPrevSheet(wxCommandEvent& event)
{
	m_canvas->PrevSheet();
	SetStatusText(wxString::Format(wxT("Sheet %d"),m_canvas->currentSheet+1));
	Refresh(false);
}
void MyFrame::OnInsertNew(wxCommandEvent& event)
{
	m_canvas->InsertNewSheet();
	SetStatusText(wxString::Format(wxT("Sheet %d"),m_canvas->currentSheet+1));
}
void MyFrame::OnInsertCopyFigure(wxCommandEvent& event)
{
	m_canvas->InsertCopyFigure(false);
	SetStatusText(wxString::Format(wxT("Sheet %d"),m_canvas->currentSheet+1));
}
void MyFrame::OnInsertCopyAll(wxCommandEvent& event)
{
	m_canvas->InsertCopyFigure(true);
	SetStatusText(wxString::Format(wxT("Sheet %d"),m_canvas->currentSheet+1));
}
void MyFrame::OnDeleteSheet(wxCommandEvent& event)
{
	m_canvas->DeleteSheet();
}

void MyFrame::OnBenchMark(wxCommandEvent& event)
{
	m_canvas->OnBenchMark();
}

void MyFrame::OnModeZoomIn(wxCommandEvent& event)
{
	m_canvas->OnModeZoomIn(1.2);
	m_canvas->NewConst(CONST_ZOOMIN);
}
void MyCanvas::OnModeZoomIn(double rate)
{
	if(geomperdot>0.001){
		geomperdot/=rate;
		snapradius/=rate;
		snapradius2=snapradius*snapradius;
		boxleft=geomcx+(relRect.GetLeft()-centerx)*geomperdot;
		boxright=geomcx+(relRect.GetRight()-centerx)*geomperdot;
		boxtop=geomcy-(relRect.GetTop()-centery)*geomperdot;
		boxbottom=geomcy-(relRect.GetBottom()-centery)*geomperdot;
		for(GConst* cnp=cns;cnp!=NULL;cnp=cnp->next){
			cnp->geomperdot = geomperdot;
			cnp->boxleft = boxleft;
			cnp->boxright = boxright;
			cnp->boxtop = boxtop;
			cnp->boxbottom = boxbottom;
		}
		EvaluateConst(cns);
	}
	m_owner->enableToolbar();
	Refresh(false);
}

void MyFrame::OnModeZoomOut(wxCommandEvent& event)
{
	m_canvas->OnModeZoomOut(1.2);
	m_canvas->NewConst(CONST_ZOOMOUT);
}

void MyCanvas::OnModeZoomOut(double rate)
{
	if(geomperdot<0.1){
		geomperdot*=rate;
		snapradius*=rate;
		snapradius2=snapradius*snapradius;
		boxleft=geomcx+(relRect.GetLeft()-centerx)*geomperdot;
		boxright=geomcx+(relRect.GetRight()-centerx)*geomperdot;
		boxtop=geomcy-(relRect.GetTop()-centery)*geomperdot;
		boxbottom=geomcy-(relRect.GetBottom()-centery)*geomperdot;
		for(GConst* cnp=cns;cnp!=NULL;cnp=cnp->next){
			cnp->geomperdot = geomperdot;
			cnp->boxleft = boxleft;
			cnp->boxright = boxright;
			cnp->boxtop = boxtop;
			cnp->boxbottom = boxbottom;
		}
		EvaluateConst(cns);
	}
	m_owner->enableToolbar();
	Refresh(false);
}

void MyFrame::OnProperty(wxCommandEvent& event)
{
	m_canvas->OnProperty();
}

#include "PropertyDialog.h"


void MyCanvas::OnProperty()
{
	if(NOhilightedBrackets>0){
		GBracket *brp = hilightedBrackets[0];
		BracketPropertyDialog myD(this,brp);
		if(myD.ShowModal()==wxID_OK){
			wxString P1;
			int i;
			double d;
			P1=myD.m_ColorR->GetValue();
			P1.ToLong((long*)&i);
			if(i>=0 && i<256){ brp->ColR=i; }
			P1=myD.m_ColorG->GetValue();
			P1.ToLong((long*)&i);
			if(i>=0 && i<256){ brp->ColG=i; }
			P1=myD.m_ColorB->GetValue();
			P1.ToLong((long*)&i);
			if(i>=0 && i<256){ brp->ColB=i; }
			if(myD.m_rb_caption->GetValue()){
				wxString str=wxT("                \n")+myD.m_caption->GetValue();
				const char *p=(const char*) str.mb_str(wxConvUTF8);
				char *q;
				for(q=(char*)p;*q!='\n';q++) ;
				q++;
				brp->caption=wxString((wxChar*)q);
				brp->m_bracket_design=-1;
			}
			if(myD.m_rb_style->GetValue()){
				P1=myD.m_cmb_style->GetValue();
				for(i=0;i<BRDSN_MAX;i++){
					if(P1.Cmp(myD.m_style_list[i])==0){
						brp->m_bracket_design=i;
					}
				}
			}
			P1=myD.m_height->GetValue();
			P1.ToDouble(&d);
			if(d>=-0.5 && d<=0.5){ brp->m_bracket_height=d; }
		}
	}
	if(NOhilightedAngles>0){
		GAngle *agp = hilightedAngles[0];
		AnglePropertyDialog myD(this,agp);
		if(myD.ShowModal()==wxID_OK){
			wxString P1;
			int i;
			P1=myD.m_ColorR->GetValue();
			P1.ToLong((long*)&i);
			if(i>=0 && i<256){ agp->ColR=i; }
			P1=myD.m_ColorG->GetValue();
			P1.ToLong((long*)&i);
			if(i>=0 && i<256){ agp->ColG=i; }
			P1=myD.m_ColorB->GetValue();
			P1.ToLong((long*)&i);
			if(i>=0 && i<256){ agp->ColB=i; }
			P1=myD.m_cmb_style->GetValue();
			for(i=0;i<AGDSN_MAX;i++){
				if(P1.Cmp(myD.m_style_list[i])==0){
					agp->m_angle_design=i;
				}
			}
			P1=myD.m_size->GetValue();
			P1.ToLong((long*)&i);
			if(i>=20 && i<=100){ agp->m_angle_size=i; }
		}
	}
}



void MyFrame::OnAppearSelect(wxCommandEvent& event)
{
	AppearanceDialog MyD(m_canvas,m_canvas->PtMode,m_canvas->LnMode,m_canvas->BgMode,m_canvas->AngleColR,m_canvas->AngleColG,m_canvas->AngleColB);
	if(MyD.ShowModal()==wxID_OK){
		wxString P1;
		int i,j;
		for(i=0;i<5;i++){
			P1=MyD.m_ComboBox_P[i]->GetValue();
			for(j=0;j<PTBMP_MAX;j++){
				if(P1.Cmp(MyD.Pchoices[j])==0){
					m_canvas->sheetbuffer[m_canvas->currentSheet].MyPtMode[j]=m_canvas->PtMode[i]=j;
					m_canvas->m_appear._MyP[i].LoadData(j);
				}
			}
			P1=MyD.m_ComboBox_L[i]->GetValue();
			for(j=0;j<LNDSN_MAX;j++){
				if(P1.Cmp(MyD.Lchoices[j])==0){
					m_canvas->sheetbuffer[m_canvas->currentSheet].MyLnMode[j]=m_canvas->LnMode[i]=j;
					m_canvas->m_appear._MyL[i].SetLnRgn(j);
					
				}
			}
			//P1=MyD.m_ComboBox_A[i]->GetValue();
			//for(j=0;j<AGDSN_MAX;j++){
			//	if(P1.Cmp(MyD.Achoices[j])==0){
			//		m_canvas->sheetbuffer[m_canvas->currentSheet].MyAgMode[j]=m_canvas->AgMode[i]=j;
			//	}
			//}
			//P1=MyD.m_AngleColorR[i]->GetValue();
			//P1.ToLong((long*)&j);
			//m_canvas->AngleColR[i]=j;
	
			//P1=MyD.m_AngleColorG[i]->GetValue();
			//P1.ToLong((long*)&j);
			//m_canvas->AngleColG[i]=j;

			//P1=MyD.m_AngleColorB[i]->GetValue();
			//P1.ToLong((long*)&j);
			//m_canvas->AngleColB[i]=j;
		}
		P1=MyD.m_ComboBox_BG->GetValue();
		for(j=0;j<BG_MAX;j++){
			if(P1.Cmp(MyD.BGchoices[j])==0){
				m_canvas->sheetbuffer[m_canvas->currentSheet].MyBgMode=m_canvas->BgMode=j;
				m_canvas->m_appear._MyBG.LoadData(j);
				m_canvas->BGbmp=false;
				
			}
		}
	}
}

//void MyFrame::OnUpdateModeSelect(wxUpdateUIEvent& event)
//{
//	event.Enable(true);
//}
//
//void MyFrame::OnToolLeftClick(wxCommandEvent& event)
//{
//    printf( "Clicked on tool %d\n", event.GetId());
//}
