/////////////////////////////////////////////////////////////////////////////
// Name:		samples/wxKidsCindy/wxKidsCIndy.cpp
// Licence:	 wxWindows licence
/////////////////////////////////////////////////////////////////////////////

// ============================================================================
// declarations
// ============================================================================

// ----------------------------------------------------------------------------
// headers
// ----------------------------------------------------------------------------

#if defined(__GNUG__) && !defined(__APPLE__)
	#pragma implementation
	#pragma interface
#endif

#include "wx/wxprec.h"

#ifdef __BORLANDC__
	#pragma hdrstop
#endif

#ifndef WX_PRECOMP
	#include "wx/wx.h"
#endif

#include "wx/image.h"
#include "wx/artprov.h"
#include "wx/toolbar.h"
#include "wx/tbarbase.h"
#include "wx/file.h"
#include "wx/dcmemory.h"
#include "wx/filename.h"
#include <wx/event.h>

#if defined(__WXGTK__) || defined(__WXMOTIF__) || defined(__WXMAC__) || defined(__WXMGL__) || defined(__WXX11__)
	#include "kc.xpm"			// kc_xpm
#endif

#include "resource.h"

#ifdef __WXMSW__
	#include "word.h"
#else
	#include "word_e.h"
#endif

// global variables

// Application class
class MyApp : public wxApp
{
public:
	virtual bool OnInit();
	virtual int OnExit() { return 0; }

protected:
};

	bool InitScreenBmp();

#include "KidsCindyFrame.h"
#include "KidsCindyCanvas.h"

IMPLEMENT_APP(MyApp)

bool MyApp::OnInit()
{
	// Making frame class
	MyFrame *frame = new MyFrame((wxString)wxT("KidsCindy - untitled.kcf"),wxPoint(50, 50), wxSize(950, 700));
	frame->Show(true);
	SetTopWindow(frame);
	InitScreenBmp();
	return true;
}

//	 canvas class event table 
BEGIN_EVENT_TABLE(MyCanvas, wxWindow)
	EVT_PAINT				(MyCanvas::OnPaint)
	EVT_ERASE_BACKGROUND	(MyCanvas::OnEraseBG)
	EVT_LEAVE_WINDOW		(MyCanvas::LeaveWindow)
	EVT_MOUSE_EVENTS		(MyCanvas::OnMouseEvent)
	EVT_TIMER				(TIMER_ID, MyCanvas::OnTimer)
END_EVENT_TABLE()

MyCanvas::MyCanvas(MyFrame *parent)
		: wxWindow(parent, wxID_ANY, wxDefaultPosition, wxDefaultSize,wxNO_FULL_REPAINT_ON_RESIZE),
//		: wxWindow(parent, wxID_ANY, wxPoint(0,45), wxDefaultSize,wxNO_FULL_REPAINT_ON_RESIZE),
		m_timer(this, TIMER_ID)
{
	m_owner = parent;
	m_std_icon = wxArtProvider::GetIcon(wxART_INFORMATION);
	m_lbuttondown=false;
	m_rbuttondown=false;
	m_point_dragging=false;
	snapped2pt=false;
	snapped2ln=false;
	snapped2ci=false;
	snapped2ccl=false;
	snapped2curve=false;
	BitMapInit=false;
	KSEGtexton=KSEGimageon=false;
	moved_point=NULL;
#ifdef __WXMSW__
	m_tbar_offsety=43;
#else
	m_tbar_offsety=32;
#endif
	wxSize mysize=m_owner->GetClientSize();
	constwidth=windowwidth=mysize.GetWidth();
	constheight=windowheight=mysize.GetHeight()-m_tbar_offsety;
	SetSize(0,m_tbar_offsety,windowwidth,windowheight);
	geomcx=0.0;
	geomcy=0.0;
	geomperdot=0.01;
	snapradius=0.1;
	snapradius2=snapradius*snapradius;
	m_timer.Start(100);	// 0.1 second interval

	GMode=MODE_CINDY;
	SMode=false;
	anim_cn=NULL;
	SetTheme(THM_STANDARD,false);
	PointMode=PT_1;
	LineMode=LN_1;
	AngleMode=AG_1;

	///
	relRect=wxRect(0,0,windowwidth,windowheight);
//	relRect=wxRect(0,m_tbar_offsety,windowwidth,windowheight);
	boxleft=geomcx+(relRect.GetLeft()-centerx)*geomperdot;
	boxright=geomcx+(relRect.GetRight()-centerx)*geomperdot;
	boxtop=geomcy-(relRect.GetTop()-centery)*geomperdot;
	boxbottom=geomcy-(relRect.GetBottom()-centery)*geomperdot;
	CloneOnOff = false;
	ShiftLButton=false;
	DefaultFontSize=18;

	ReadPrefFile();

	wxClientDC cdc(this);
	PrepareDC(cdc);
	m_owner->PrepareDC(cdc);

	wxInitAllImageHandlers();

	ClearConst();
	const_src = wxT("");
	LineClipping=false;
	AxisOn=false;

	NOhilightedPoints=0;
	NOhilightedLines=0;
	NOhilightedCircles=0;
	NOhilightedTexts=0;
	NOhilightedCurves=0;
	BGbmp=false;
	bgdsn=0;
	NOConstStock=0;
	m_write_logfile=true;
	m_owner->menuFile->Check(ID_FILE_LOGFILE,m_write_logfile);
	wxDateTime dt = wxDateTime::Now();
	WriteLogFile(wxString::Format(wxT("**** Start ****%02d%02d%02d,%02d:%02d\n"),dt.GetYear(),dt.GetMonth(),dt.GetDay(),dt.GetHour(),dt.GetMinute()));

}


void MyFrame::OnSize(wxSizeEvent& event)
{
//	printf("OnSize : \n");
	if(m_canvas!=NULL && m_tbar_on){
		wxSize mysize=GetClientSize();
		if(m_canvas->windowwidth!=mysize.GetWidth() || m_canvas->windowheight!=mysize.GetHeight()){
			m_canvas->windowwidth=mysize.GetWidth();
			m_canvas->windowheight=mysize.GetHeight();
			m_canvas->OnSize();
			RecreateToolbar();
		}
	}
	Refresh(false);
}

void MyCanvas::OnSize()
{
	SetSize(0,m_tbar_offsety,windowwidth,windowheight-m_tbar_offsety);
	convert_textsize();
	centerx=windowwidth/2;
	centery=windowheight/2;
	relRect=wxRect(relRect.x,relRect.y,windowwidth,windowheight);
	boxleft=geomcx-centerx*geomperdot;
	boxright=geomcx+centerx*geomperdot;
	boxtop=geomcy+centery*geomperdot;
	boxbottom=geomcy-centery*geomperdot;
	for(GConst* cnp=cns;cnp!=NULL;cnp=cnp->next){
		cnp->boxleft = boxleft;
		cnp->boxright = boxright;
		cnp->boxtop = boxtop;
		cnp->boxbottom = boxbottom;
	}
	BGbmp=false;
	EvaluateConst(cns);
}

void MyCanvas::convert_textsize()
{
	if(windowwidth==constwidth && windowheight==constheight){
		return ;
	}
	GText *txp;
	double hr,wr;
	int i;
	wr=1.0*windowwidth/constwidth;
	hr=1.0*(windowheight-50)/(constheight-50);
	for(i=0;i<NOMySheet;i++){
		if(sheetbuffer[i].MyText!=NULL){
			for(txp=sheetbuffer[i].MyText;txp!=NULL;txp=txp->next){
				txp->tx=wr * txp->tx;
				txp->ty=hr * txp->ty;
				txp->fontsize=hr * txp->fontsize;
			}
		}
	}
	OnModeZoomIn(hr);
	constwidth=windowwidth;
	constheight=windowheight;
}

extern wxBitmap		*gs_bmpBackGround;

void MyCanvas::OnEraseBG(wxEraseEvent& WXUNUSED(event))
{

}

void MyCanvas::OnMouseEvent(wxMouseEvent &event)
{
	ShiftLButton = event.ShiftDown(); 
	currentpoint = event.GetPosition();
	//currentpoint -= wxPoint(0,m_tbar_offsety);
	if (event.LeftDown()){
		LButtonDown(currentpoint);
	}
	else if (event.Dragging()){
		if(m_lbuttondown){
			LButtonDrag(currentpoint);
		}
		else if(m_rbuttondown){
			RButtonDrag(currentpoint);
		}
	}
	else if (event.LeftUp()){
		LButtonUp(currentpoint);
	}
	else if (event.RightDown()){
		RButtonDown(currentpoint);
	}
	else if (event.RightUp()){
		RButtonUp(currentpoint);
	}
	if(m_move_dragging || m_text_dragging || m_ptname_dragging) {
		if(redraw){
			Refresh(false);
		}
	}
	if(DocMode==MODE_COMPASS){
		compasscursorx=currentpoint.x;
		compasscursory=currentpoint.y;
	}
}

void MyCanvas::OnTimer(wxTimerEvent& event)
{
	Refresh(false);
}

#include "wx/datetime.h"

void MyCanvas::WriteLogFile(wxString str)
{
	if(m_write_logfile){
		wxDateTime dt = wxDateTime::Now();
		int yr=dt.GetYear();
		int mo=dt.GetMonth()+1;
		int da=dt.GetDay();
		wxString g_Path=wxT("KClog")+wxString::Format(wxT("%02d%02d%02d"),yr,mo,da)+wxT(".txt");
		wxFile myF(g_Path,wxFile::write_append);
		myF.Write(str);
		myF.Close();
	}
}

void MyCanvas::WritePrefFile()
{
	wxString g_Path=wxT("wxKC.pref");
	wxFile myF(g_Path,wxFile::write);
	if(GMode==MODE_CINDY){
		myF.Write(wxT("GMode=CINDY;"));
	}
	else if(GMode==MODE_KSEG){
		myF.Write(wxT("GMode=KSEG;"));
	}
	else if(GMode==MODE_PANEL){
		myF.Write(wxT("GMode=PANEL;"));
	}
	switch(ThemeMode){
		case THM_STANDARD:
		myF.Write(wxT("ThemeMode=THM_STANDARD;"));break;
		case THM_CAT:
		myF.Write(wxT("ThemeMode=THM_CAT;"));break;
		case THM_STAR:
		myF.Write(wxT("ThemeMode=THM_STAR;"));break;
		case THM_RAILROAD:
		myF.Write(wxT("ThemeMode=THM_RAILROAD;"));break;
		case THM_KSEG:
		myF.Write(wxT("ThemeMode=THM_KSEG;"));break;
		case THM_CINDY:
		myF.Write(wxT("ThemeMode=THM_CINDY;"));break;
		case THM_PASTEL:
		myF.Write(wxT("ThemeMode=THM_PASTEL;"));break;
		case THM_SKELETON:
		myF.Write(wxT("ThemeMode=THM_SKELETON;"));break;
	}
	switch(PointMode){
	case PT_1:
		myF.Write(wxT("PointMode=PT_1;"));break;
	case PT_2:
		myF.Write(wxT("PointMode=PT_2;"));break;
	case PT_3:
		myF.Write(wxT("PointMode=PT_3;"));break;
	case PT_4:
		myF.Write(wxT("PointMode=PT_4;"));break;
	case PT_5:
		myF.Write(wxT("PointMode=PT_5;"));break;
	}
	switch(LineMode){
	case LN_1:
		myF.Write(wxT("LineMode=LN_1;"));break;
	case LN_2:
		myF.Write(wxT("LineMode=LN_2;"));break;
	case LN_3:
		myF.Write(wxT("LineMode=LN_3;"));break;
	case LN_4:
		myF.Write(wxT("LineMode=LN_4;"));break;
	case LN_5:
		myF.Write(wxT("LineMode=LN_5;"));break;
	}
	switch(AngleMode){
	case AG_1:
		myF.Write(wxT("AngleMode=AG_1;"));break;
	case AG_2:
		myF.Write(wxT("AngleMode=AG_2;"));break;
	case AG_3:
		myF.Write(wxT("AngleMode=AG_3;"));break;
	case AG_4:
		myF.Write(wxT("AngleMode=AG_4;"));break;
	case AG_5:
		myF.Write(wxT("AngleMode=AG_5;"));break;
	}
	if(m_write_logfile){
		myF.Write(wxT("WriteLogfile;"));
	}
	myF.Close();
}

#include <string.h>

void MyCanvas::ReadPrefFile()
{
	wxString g_Path=wxT("wxKC.pref");
	wxFile myF;
	if(myF.Access(g_Path,wxFile::read)){
		myF.Open(g_Path,wxFile::read);
		int length=myF.Length();
		char* buffer=new char[length+1];
		myF.Read(buffer,length);
		myF.Close();
		m_write_logfile=false;
		for(int i=0;i<length;i++){
			if(strncmp(buffer+i,"GMode=CINDY",11)==0){
				GMode=MODE_CINDY;
			}
			else if(strncmp(buffer+i,"GMode=KSEG",10)==0){
				GMode=MODE_KSEG;
			}
			else if(strncmp(buffer+i,"GMode=PANEL",11)==0){
				GMode=MODE_PANEL;
			}
			else if(strncmp(buffer+i,"ThemeMode=THM_STANDARD;",23)==0){
				SetTheme(THM_STANDARD);
			}
			else if(strncmp(buffer+i,"ThemeMode=THM_CAT;",18)==0){
				SetTheme(THM_CAT);
			}
			else if(strncmp(buffer+i,"ThemeMode=THM_STAR;",19)==0){
				SetTheme(THM_STAR);
			}
			else if(strncmp(buffer+i,"ThemeMode=THM_RAILROAD;",23)==0){
				SetTheme(THM_RAILROAD);
			}
			else if(strncmp(buffer+i,"ThemeMode=THM_KSEG;",19)==0){
				SetTheme(THM_KSEG);
			}
			else if(strncmp(buffer+i,"ThemeMode=THM_CINDY;",20)==0){
				SetTheme(THM_CINDY);
			}
			else if(strncmp(buffer+i,"ThemeMode=THM_PASTEL;",21)==0){
				SetTheme(THM_PASTEL);
			}
			else if(strncmp(buffer+i,"ThemeMode=THM_SKELETON;",23)==0){
				SetTheme(THM_SKELETON);
			}
			else if(strncmp(buffer+i,"PointMode=PT_1;",15)==0){
				PointMode=PT_1;
				m_owner->menuPoint->Check(PointMode,true);
			}
			else if(strncmp(buffer+i,"PointMode=PT_2;",15)==0){
				PointMode=PT_2;
				m_owner->menuPoint->Check(PointMode,true);
			}
			else if(strncmp(buffer+i,"PointMode=PT_3;",15)==0){
				PointMode=PT_3;
				m_owner->menuPoint->Check(PointMode,true);
			}
			else if(strncmp(buffer+i,"PointMode=PT_4;",15)==0){
				PointMode=PT_4;
				m_owner->menuPoint->Check(PointMode,true);
			}
			else if(strncmp(buffer+i,"PointMode=PT_5;",15)==0){
				PointMode=PT_5;
				m_owner->menuPoint->Check(PointMode,true);
			}
			else if(strncmp(buffer+i,"LineMode=LN_1;",14)==0){
				LineMode=LN_1;
				m_owner->menuLine->Check(LineMode,true);
			}
			else if(strncmp(buffer+i,"LineMode=LN_2;",14)==0){
				LineMode=LN_2;
				m_owner->menuLine->Check(LineMode,true);
			}
			else if(strncmp(buffer+i,"LineMode=LN_3;",14)==0){
				LineMode=LN_3;
				m_owner->menuLine->Check(LineMode,true);
			}
			else if(strncmp(buffer+i,"LineMode=LN_4;",14)==0){
				LineMode=LN_4;
				m_owner->menuLine->Check(LineMode,true);
			}
			else if(strncmp(buffer+i,"LineMode=LN_5;",14)==0){
				LineMode=LN_5;
				m_owner->menuLine->Check(LineMode,true);
			}
			else if(strncmp(buffer+i,"AngleMode=AG_1;",15)==0){
				AngleMode=AG_1;
				m_owner->menuAngle->Check(AngleMode,true);
			}
			else if(strncmp(buffer+i,"AngleMode=AG_2;",15)==0){
				AngleMode=AG_2;
				m_owner->menuAngle->Check(AngleMode,true);
			}
			else if(strncmp(buffer+i,"AngleMode=AG_3;",15)==0){
				AngleMode=AG_3;
				m_owner->menuAngle->Check(AngleMode,true);
			}
			else if(strncmp(buffer+i,"AngleMode=AG_4;",15)==0){
				AngleMode=AG_4;
				m_owner->menuAngle->Check(AngleMode,true);
			}
			else if(strncmp(buffer+i,"AngleMode=AG_5;",15)==0){
				AngleMode=AG_5;
				m_owner->menuAngle->Check(AngleMode,true);
			}
			else if(strncmp(buffer+i,"WriteLogfile;",13)==0){
				m_write_logfile=true;
			}
		}
		delete []buffer;
	}		
}


// frame class event table
BEGIN_EVENT_TABLE(MyFrame, wxFrame)
	EVT_SIZE				(MyFrame::OnSize)
	EVT_MENU	(ID_FILE_NEW,	MyFrame::OnNew)
	EVT_MENU	(ID_FILE_OPEN,	MyFrame::OnOpen)
	EVT_MENU	(ID_FILE_SAVE,	MyFrame::OnSave)
	EVT_MENU	(ID_FILE_SAVE_CSV,	MyFrame::OnSaveCsv)
	EVT_MENU	(ID_FILE_SAVE_BMP,	MyFrame::OnSaveBmp)
	EVT_MENU	(ID_APP_ABOUT,  MyFrame::OnAbout)
	EVT_MENU	(ID_FILE_QUIT,  MyFrame::OnQuit)
	EVT_MENU	(ID_EDIT_TEXT,	MyFrame::OnEditText)
	EVT_MENU	(ID_EDIT_UNDO,			MyFrame::OnModeUndo)
	EVT_MENU	(ID_EDIT_REDO,			MyFrame::OnModeRedo)
	EVT_MENU	(ID_NEXT_SHEET, 		MyFrame::OnNextSheet)
	EVT_MENU	(ID_PREV_SHEET,			MyFrame::OnPrevSheet)
	EVT_MENU	(ID_INSERT_NEW,			MyFrame::OnInsertNew)
	EVT_MENU	(ID_INSERT_COPY_FIGURE,	MyFrame::OnInsertCopyFigure)
	EVT_MENU	(ID_INSERT_COPY_ALL,	MyFrame::OnInsertCopyAll)
	EVT_MENU	(ID_DELETE_SHEET,		MyFrame::OnDeleteSheet)
	EVT_MENU	(ID_FILE_BENCHMARK,		MyFrame::OnBenchMark)
	EVT_MENU	(ID_FILE_PRINT, MyFrame::OnPrint)
	EVT_MENU	(ID_FILE_PREVIEW, MyFrame::OnPrintPreview)
	EVT_MENU	(ID_FILE_PAGE_SETUP, MyFrame::OnPageSetup)
	EVT_MENU	(ID_SLIDESHOW_START, MyFrame::OnSlideShowStart)
	EVT_MENU	(ID_SLIDESHOW_PROPERTY,	MyFrame::OnSlideShowProperty)
	EVT_MENU	(ID_FILE_LOGFILE,MyFrame::OnLogfile)

	EVT_MENU	(THM_STANDARD,	MyFrame::OnThemeStandard)
	EVT_MENU	(THM_CAT,		MyFrame::OnThemeCat)
	EVT_MENU	(THM_STAR,		MyFrame::OnThemeStar)
	EVT_MENU	(THM_KSEG,		MyFrame::OnThemeKseg)
	EVT_MENU	(THM_CINDY,		MyFrame::OnThemeCindy)
	EVT_MENU	(THM_PASTEL,	MyFrame::OnThemePastel)
	EVT_MENU	(THM_SKELETON,	MyFrame::OnThemeSkeleton)
	EVT_MENU	(PT_1,		MyFrame::OnPt0)
	EVT_MENU	(PT_2,		MyFrame::OnPt1)
	EVT_MENU	(PT_3,		MyFrame::OnPt2)
	EVT_MENU	(PT_4,		MyFrame::OnPt3)
	EVT_MENU	(PT_5,		MyFrame::OnPt4)
	EVT_MENU	(LN_1,		MyFrame::OnLn0)
	EVT_MENU	(LN_2,		MyFrame::OnLn1)
	EVT_MENU	(LN_3,		MyFrame::OnLn2)
	EVT_MENU	(LN_4,		MyFrame::OnLn3)
	EVT_MENU	(LN_5,		MyFrame::OnLn4)
	EVT_MENU	(ID_APPEAR_BG,MyFrame::OnBg)
	//EVT_MENU	(BG_1,		MyFrame::OnBg0)
	//EVT_MENU	(BG_2,		MyFrame::OnBg1)
	//EVT_MENU	(BG_3,		MyFrame::OnBg2)
	EVT_MENU	(AG_1,		MyFrame::OnAg0)
	EVT_MENU	(AG_2,		MyFrame::OnAg1)
	EVT_MENU	(AG_3,		MyFrame::OnAg2)
	EVT_MENU	(AG_4,		MyFrame::OnAg3)
	EVT_MENU	(AG_5,		MyFrame::OnAg4)
	EVT_MENU	(MODE_MOVE,				MyFrame::OnModeMove)
	EVT_MENU	(MODE_SINGLE_ADD,		MyFrame::OnModeSPoint)
	EVT_MENU	(MODE_MULTI_LINE,		MyFrame::OnModeMLine)
	EVT_MENU	(MODE_PARALLEL,			MyFrame::OnModePara)
	EVT_MENU	(MODE_PERP,				MyFrame::OnModePerp)
	EVT_MENU	(MODE_MID,				MyFrame::OnModeMid)
	EVT_MENU	(MODE_MULTI_CIRCLE,		MyFrame::OnModeMCircle)
	EVT_MENU	(MODE_BISECTOR,			MyFrame::OnModeBisector)
	EVT_MENU	(MODE_SELECT,			MyFrame::OnModeSelect)
	EVT_MENU	(MODE_MEET,				MyFrame::OnModeMeet)
	EVT_MENU	(MODE_GRAPH,			MyFrame::OnModeGraph)
	EVT_MENU	(MODE_ERASER,			MyFrame::OnModeEraser)
	EVT_MENU	(MODE_CLIPPING,			MyFrame::OnModeClipping)
	EVT_MENU	(MODE_INVISIBLE,		MyFrame::OnModeInvisible)
	EVT_MENU	(MODE_AXIS,				MyFrame::OnModeAxis)
	EVT_MENU	(MODE_TANGENT,			MyFrame::OnModeTangent)
	EVT_MENU	(MODE_TEXT,				MyFrame::OnModeText)
	EVT_MENU	(MODE_IMAGE,			MyFrame::OnModeImage)
	EVT_MENU	(MODE_COMPASS,			MyFrame::OnModeCompass)
	EVT_MENU	(MODE_ORBIT,			MyFrame::OnModeOrbit)
	EVT_MENU	(MODE_CIRCLE_BY_3,		MyFrame::OnModeCircleBy3)
	EVT_MENU	(MODE_ANGLE,			MyFrame::OnModeAngle)
	EVT_MENU	(MODE_BRACKET,			MyFrame::OnModeBracket)
	EVT_MENU	(MODE_LINE_WITH_ANGLE,	MyFrame::OnModeLineWithAngle)
	EVT_MENU	(MODE_ZOOMIN,			MyFrame::OnModeZoomIn)
	EVT_MENU	(MODE_ZOOMOUT,			MyFrame::OnModeZoomOut)
	EVT_MENU	(ID_EDIT_PROPERTY,		MyFrame::OnProperty)
	EVT_MENU	(ID_MODE_TANGENT,		MyFrame::OnIdModeTangent)
	EVT_MENU	(ID_MODE_CIRCLE_BY_3,	MyFrame::OnIdModeCircleBy3)
	EVT_MENU	(ID_CLONE_ON,			MyFrame::OnCloneOn)
	EVT_MENU	(ID_APPEAR_SELECT,		MyFrame::OnAppearSelect)

	EVT_MENU	(MODE_CINDY,			MyFrame::OnGModeCindy)
	EVT_MENU	(MODE_KSEG, 			MyFrame::OnGModeKseg)
	EVT_MENU	(MODE_PANEL, 			MyFrame::OnGModePanel)

	//EVT_UPDATE_UI(MODE_SELECT, MyFrame::OnUpdateModeSelect)
 //   EVT_MENU	(wxID_ANY, MyFrame::OnToolLeftClick)

	EVT_CLOSE	(MyFrame::OnClose)	
END_EVENT_TABLE()

MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size)
	   : wxFrame((wxFrame *)NULL, wxID_ANY, title, pos, size,
				 wxDEFAULT_FRAME_STYLE | wxNO_FULL_REPAINT_ON_RESIZE)
{
	SetIcon(wxICON(kc));
	m_tbar1=m_tbar2=NULL;
	m_tbar_on=false;
	menuFile = new wxMenu;
	menuFile->Append(ID_FILE_NEW, MenuFileNew);
	menuFile->Append(ID_FILE_OPEN, MenuFileOpen);
	menuFile->Append(ID_FILE_SAVE, MenuFileSave);
	menuFile->Append(ID_FILE_SAVE_CSV, MenuFileSaveCsv);
	menuFile->Append(ID_FILE_SAVE_BMP, MenuFileSaveBmp);
	menuFile->AppendCheckItem(ID_FILE_LOGFILE, MenuFileLogfile);
	menuFile->AppendSeparator();
	menuFile->Append(ID_FILE_PRINT, MenuFilePrint);
	menuFile->Append(ID_FILE_PAGE_SETUP, MenuFilePrintSetup);
	menuFile->Append(ID_FILE_PREVIEW,MenuFilePrintPreview);
	menuFile->AppendSeparator();
	menuFile->Append(ID_APP_ABOUT, MenuFileAbout);
	menuFile->Append(ID_FILE_QUIT, MenuFileQuit);

	menuEdit = new wxMenu;
	menuEdit->Append(ID_EDIT_UNDO, MenuEditUndo );
	menuEdit->Append(ID_EDIT_REDO, MenuEditRedo );
	menuEdit->AppendSeparator();
	menuEdit->Append(ID_NEXT_SHEET,MenuNextSheet);
	menuEdit->Append(ID_PREV_SHEET,MenuPrevSheet);
	menuEdit->AppendSeparator();
	menuEdit->Append(ID_INSERT_NEW,MenuInsertNew);
	menuEdit->Append(ID_INSERT_COPY_FIGURE,MenuInsertCopyFigure);
	menuEdit->Append(ID_INSERT_COPY_ALL,MenuInsertCopyAll);
	menuEdit->Append(ID_DELETE_SHEET,MenuDeleteSheet);
	menuEdit->AppendSeparator();
	menuEdit->Append(ID_EDIT_TEXT,MenuEditSource);
	menuEdit->Append(ID_FILE_BENCHMARK,MenuBenchMark);
	
	menuMode = new wxMenu;
	menuMode->Append(MODE_CINDY, MenuGModeCindy);
	menuMode->Append(MODE_KSEG,  MenuGModeKseg);
	menuMode->Append(MODE_PANEL, MenuGModePanel);
	menuMode->AppendSeparator();
	menuMode->Append(MODE_SELECT,	ToolText_ModeSelect);
	menuMode->Append(MODE_MOVE,		ToolText_ModeMove);
	menuMode->Append(MODE_SINGLE_ADD,	ToolText_ModeSPoint);
	menuMode->Append(MODE_MULTI_LINE,	ToolText_ModeMLine);
	menuMode->Append(MODE_PARALLEL,		ToolText_ModePara);
	menuMode->Append(MODE_PERP,		ToolText_ModePerp);
	menuMode->Append(MODE_MID,		ToolText_ModeMid);
	menuMode->Append(MODE_MULTI_CIRCLE,	ToolText_ModeMCircle);
	menuMode->Append(MODE_BISECTOR,	ToolText_ModeBisector);

	menuSlideShow = new wxMenu;
	menuSlideShow->Append(ID_SLIDESHOW_START, MenuSlideShowStart);
	menuSlideShow->Append(ID_SLIDESHOW_PROPERTY,MenuSlideShowProperty);

	menuTheme = new wxMenu;
	menuTheme->AppendRadioItem(THM_STANDARD,MenuThemeStandard);
	menuTheme->AppendRadioItem(THM_CAT, MenuThemeCat);
	menuTheme->AppendRadioItem(THM_STAR, MenuThemeStar);
	menuTheme->AppendRadioItem(THM_SKELETON, MenuThemeSkeleton);
	menuTheme->AppendRadioItem(THM_KSEG, MenuThemeKseg);
	menuTheme->AppendRadioItem(THM_CINDY, MenuThemeCindy);
	menuTheme->AppendRadioItem(THM_PASTEL, MenuThemePastel);

	menuPoint = new wxMenu;
	menuPoint->AppendRadioItem(PT_1,MenuPt1);
	menuPoint->AppendRadioItem(PT_2,MenuPt2);
	menuPoint->AppendRadioItem(PT_3,MenuPt3);
	menuPoint->AppendRadioItem(PT_4,MenuPt4);
	menuPoint->AppendRadioItem(PT_5,MenuPt5);

	menuLine = new wxMenu;
	menuLine->AppendRadioItem(LN_1,MenuLine1);
	menuLine->AppendRadioItem(LN_2,MenuLine2);
	menuLine->AppendRadioItem(LN_3,MenuLine3);
	menuLine->AppendRadioItem(LN_4,MenuLine4);
	menuLine->AppendRadioItem(LN_5,MenuLine5);

	menuAngle = new wxMenu;
	menuAngle->AppendRadioItem(AG_1,MenuAngle1);
	menuAngle->AppendRadioItem(AG_2,MenuAngle2);
	menuAngle->AppendRadioItem(AG_3,MenuAngle3);
	menuAngle->AppendRadioItem(AG_4,MenuAngle4);
	menuAngle->AppendRadioItem(AG_5,MenuAngle5);

	menuAppear = new wxMenu;
	menuAppear->Append(ID_APPEAR_THEME,MenuAppearTheme,menuTheme);
	menuAppear->AppendSeparator();
	menuAppear->Append(ID_APPEAR_POINT,MenuAppearPt,menuPoint);
	menuAppear->Append(ID_APPEAR_LINE,MenuAppearLine,menuLine);
	menuAppear->Append(ID_APPEAR_ANGLE,MenuAppearAngle,menuAngle);
	menuAppear->Append(ID_APPEAR_BG,MenuAppearBG);
	menuAppear->AppendSeparator();
	menuAppear->Append(ID_APPEAR_SELECT,MenuAppearSelect);
	menuAppear->Append(ID_EDIT_PROPERTY,MenuEditProperty);
	menuAppear->AppendSeparator();
	menuAppear->AppendCheckItem(ID_CLONE_ON,MenuAfterimage);

	wxMenuBar *menuBar = new wxMenuBar;
	menuBar->Append(menuFile, MenuFile);
	menuBar->Append(menuEdit, MenuEdit);
	menuBar->Append(menuMode, MenuMode);
	menuBar->Append(menuSlideShow, MenuSlideShow);
	menuBar->Append(menuAppear,MenuAppear);

	SetMenuBar(menuBar);

#if wxUSE_STATUSBAR
	CreateStatusBar(2);
	SetStatusText((wxString)wxT("Welcome to wxKidsCindy!"));
#endif // wxUSE_STATUSBAR


	m_canvas = new MyCanvas( this );

	RecreateToolbar();
	m_canvas->DocMode=MODE_MOVE;
	menuMode->Check(MODE_MOVE,true);
}

// event handlers

void MyFrame::OnQuit(wxCommandEvent& WXUNUSED(event))
{
	int answer=wxMessageBox(OnCloseMakeSure
		,wxT("Are you sure?"), wxYES_NO | wxICON_INFORMATION, this);
	if(answer==wxYES){
		m_canvas->OnSave();
	}
	m_canvas->WritePrefFile();
	m_canvas->WriteLogFile(wxT("**** Quit ****\n"));
	Close(true);
}

void MyFrame::OnClose(wxCloseEvent& event)
{
	int answer=wxMessageBox(OnCloseMakeSure
		,wxT("Are you sure?"), wxYES_NO | wxICON_INFORMATION, this);
	if(answer==wxYES){
		m_canvas->OnSave();
	}
	m_canvas->WritePrefFile();
	m_canvas->WriteLogFile(wxT("**** Quit ****\n"));
	Destroy();
}

void MyFrame::OnNew(wxCommandEvent& event)
{
	int answer=wxMessageBox(OnOpenMakeSure
		,wxT("Are you sure?"), wxYES_NO | wxICON_INFORMATION, this);
	if(answer==wxYES){
		m_canvas->ClearConst();
		Refresh(false);
		SetTitle(wxT("KidsCindy - untitled"));
		m_canvas->WriteLogFile(wxT("OnNew:\n"));
	}
}

void MyFrame::OnOpen(wxCommandEvent& event)
{
	wxFileDialog myFileD(this ,wxT("Choose a file"),wxT(""),wxT("untitled.kcf"),wxT("KidsCindy files(*.kcf)|*.kcf"),wxOPEN);
	if(myFileD.ShowModal()==wxID_OK){
		wxString g_Path=myFileD.GetPath();
		wxFile myF;
		m_canvas->WriteLogFile(wxString::Format(wxT("OnOpen : g_Path=%s\n"),g_Path.c_str()));
		if(myF.Open(g_Path,wxFile::read)){
			int answer=wxMessageBox(OnOpenMakeSure
				,wxT("Are you sure?"), wxYES_NO | wxICON_INFORMATION, this);
			if(answer==wxYES){
				m_canvas->WriteLogFile(wxT("OnOpen: start\n"));
				int length=myF.Length();
				char* buffer=new char[length+1];
				myF.Read(buffer,length);
				buffer[length]=0x00;
				myF.Close();
				wxString str=wxString((wxChar*)buffer);
				m_canvas->const_src = str;
				delete []buffer;
				m_canvas->const_src2cns(true,true);
				m_canvas->ResetAllName();
				SetTitle(wxT("KidsCindy - ")+myFileD.GetFilename());
				m_canvas->WriteLogFile(wxT("OnOpen: end\n"));
			}
		}
	}
	Refresh(false);
}
void MyFrame::OnSave(wxCommandEvent& event)
{
	m_canvas->OnSave();
}

void MyCanvas::OnSave()
{
	wxFileDialog myFileD(this ,wxT("Input a file name"),wxT(""),wxT("untitled.kcf"),wxT("KidsCindy files(*.kcf)|*.kcf"),wxSAVE | wxOVERWRITE_PROMPT);
	if(myFileD.ShowModal()==wxID_OK){
		WriteLogFile(wxT("OnSave: start\n"));
		wxString g_Path=myFileD.GetPath();
		if(g_Path.Right(3)!=wxT("kcf")){
			g_Path=g_Path+wxT(".kcf");
		}
		wxFile myF(g_Path,wxFile::write);
		for(int i=0;i<NOMySheet;i++){
			myF.Write(wxString::Format(wxT("//Sheet %d;\r\n"),i));
			const_src=wxT("");
			SetConstSrc(sheetbuffer[i].MyConst);
			wxString str((char*)const_src.c_str(),wxConvUTF8);
			myF.Write(str);
			WriteLogFile(str);
		}
		SetTitle(wxT("KidsCindy - ")+g_Path);
		myF.Close();
		WriteLogFile(wxT("OnSave: end\n"));
	}
	Refresh(false);
}
void MyFrame::OnSaveCsv(wxCommandEvent& event)
{
	m_canvas->OnSaveCsv();
}

void MyCanvas::OnSaveCsv()
{
	int i;
	wxString str,tgt;
	char buffer[1024];
	int answer=wxMessageBox(OnSaveCsvMakeSure,wxT("Are you sure?"), wxYES_NO | wxICON_INFORMATION, this);
	if(answer==wxYES){
		wxFileDialog myFileD(this ,wxT("Input a file name"),wxT(""),wxT("untitled.csv"),wxT("CSV files(*.csv)|*.csv"),wxSAVE | wxOVERWRITE_PROMPT);
		if(myFileD.ShowModal()==wxID_OK){
			wxString g_Path=myFileD.GetPath();
			if(g_Path.Right(3)!=wxT("csv")){
				g_Path=g_Path+wxT(".csv");
			}
			wxFile myF(g_Path,wxFile::write);
			for(GConst *cnp=cns;cnp!=NULL;cnp=cnp->next){
				switch(cnp->Output_Type()){
				case OUTPUT_POINT:
					if(cnp->POutput->hilighted){
						sprintf(buffer," ,point %s \n ,x,y\n",cnp->POutput->_name.c_str()); 
						str = wxString((char*)buffer,wxConvUTF8);
						myF.Write(str);
						sprintf(buffer," ,%f,%f\n",cnp->POutput->xz().real(),cnp->POutput->yz().real());
						str = wxString((char*)buffer,wxConvUTF8);
						myF.Write(str);
					}
					break;
				case OUTPUT_LINE:
					if(cnp->LOutput->hilighted){
						sprintf(buffer," ,point %s,ax+by+c=0 \n ,a,b,c\n",cnp->LOutput->_name.c_str()); 
						str = wxString((char*)buffer,wxConvUTF8);
						myF.Write(str);
						sprintf(buffer," ,%f,%f,%f\n",cnp->LOutput->xx.real(),cnp->LOutput->yy.real(),cnp->LOutput->zz.real());
						str = wxString((char*)buffer,wxConvUTF8);
						myF.Write(str);
					}
					break;
				case OUTPUT_CIRCLE:
					if(cnp->COutput->hilighted){
						sprintf(buffer," ,circle %s,(x-a)^2+(y-b)^2=r^2 \n ,a,b,r^2\n",cnp->COutput->_name.c_str()); 
						str = wxString((char*)buffer,wxConvUTF8);
						myF.Write(str);
						sprintf(buffer," ,%f,%f,%f\n",cnp->COutput->xx.real(),cnp->COutput->yy.real(),cnp->COutput->rr.real());
						str = wxString((char*)buffer,wxConvUTF8);
						myF.Write(str);
					}
					break;
				case OUTPUT_TEXT:
					if(cnp->TextOutput->hilighted){
						sprintf(buffer," ,text %s\n",cnp->TextOutput->_name.c_str()); 
						str = wxString((char*)buffer,wxConvUTF8);
						myF.Write(str);
						EvaluateText(cns,cnp->TextOutput->str, tgt,false);
						sprintf(buffer," ,\"%1000s\"\n",tgt.c_str()); 
						str = wxString((char*)buffer,wxConvUTF8);
						myF.Write(str);
					}
					break;
				case OUTPUT_CURVE:
					if(cnp->CurveOutput->hilighted){
						sprintf(buffer," ,curve %s \n ,x,y\n",cnp->CurveOutput->_name.c_str()); 
						str = wxString((char*)buffer,wxConvUTF8);
						myF.Write(str);
						for(i=0;i<cnp->CurveOutput->orbit_len;i++){
							sprintf(buffer,"%d,%f,%f\n",i,cnp->CurveOutput->orbitx[i],cnp->CurveOutput->orbity[i]);
							str = wxString((char*)buffer,wxConvUTF8);
							myF.Write(str);
						}
					}
					break;
				}
			}
			myF.Close();
		}
		Refresh(false);
	}
}
void MyFrame::OnSaveBmp(wxCommandEvent& event)
{
	m_canvas->OnSaveBmp();
}

void MyCanvas::OnSaveBmp()
{
	wxFileDialog myFileD(this ,wxT("Save an image file"),wxT(""),wxT("untitled"),wxT("BMP files (*.bmp)|*.bmp"),wxSAVE | wxOVERWRITE_PROMPT);
	if(myFileD.ShowModal()==wxID_OK){
		wxBitmap *gs_bmpFile = new wxBitmap(windowwidth,windowheight);
		wxMemoryDC g_memfiledc;
		g_memfiledc.SelectObject(*gs_bmpFile);
		g_memfiledc.Blit(0,0,windowwidth,windowheight,&g_memBGdc,0,0);
		OnDraw(&g_memfiledc);
		wxString g_Path=myFileD.GetPath();
		g_Path=g_Path+wxT(".bmp");
		gs_bmpFile->SaveFile(g_Path,wxBITMAP_TYPE_BMP);
	}
	Refresh(false);
}

void MyFrame::OnLogfile(wxCommandEvent& event)
{
	m_canvas->m_write_logfile=!(m_canvas->m_write_logfile);
	menuFile->Check(ID_FILE_LOGFILE,m_canvas->m_write_logfile);
}
void MyFrame::OnAbout(wxCommandEvent& WXUNUSED(event))
{
	wxString msg;
	msg.Printf( wxT("wxKidsCindy \nKidsCindy on wxWidgets\n\nAhara Lab., Meiji University, \nhttp://www11.atwiki.jp/kidscindy/") );

	wxMessageBox(msg, wxT("About ...."), wxOK | wxICON_INFORMATION, this);
}

	#include "FileNew.xpm"		// filenew_xpm
	#include "FileSave.xpm"		// filesave_xpm
	#include "FileOpen.xpm"		// fileopen_xpm
	#include "FilePrint.xpm"	// fileprint_xpm
//	#include "Help.xpm"			// help_xpm
	#include "ModeMCircle.xpm"	// modemcircle_xpm
	#include "ModeMid.xpm"		// modemid_xpm
	#include "ModeMLine.xpm"	// modemline_xpm
	#include "ModeMove.xpm"		// modemove_xpm
	#include "ModePara.xpm"		// modepara_xpm
	#include "ModePerp.xpm"		// modeperp_xpm
	#include "ModeSPoint.xpm"	// modespoint_xpm
	#include "ModeBisector.xpm"	// modespoint_xpm
	#include "ModeSelect.xpm"	// modespoint_xpm
	#include "ModeMeet.xpm"	// modespoint_xpm
	#include "ModeGraph.xpm"	// modespoint_xpm
	#include "ModeClipping.xpm"	// modespoint_xpm
	#include "ModeAxis.xpm"	// modespoint_xpm
	#include "ModeTangent.xpm"	// modespoint_xpm
	#include "ModeText.xpm"	// modespoint_xpm
	#include "ModeCompass.xpm"	// modespoint_xpm
	#include "ModeUndo.xpm"	// modeundo_xpm
	#include "ModeRedo.xpm"	// moderedo_xpm
	#include "ModeOrbit.xpm"	// modesorbit_xpm
	#include "ModeCircleBy3.xpm" //modecircleby3_xpm
	#include "ModeInvisible.xpm"	// modeinvisible_xpm
	#include "ModeAngle.xpm"	// modeangle_xpm
	#include "ModeLineWithAngle.xpm"	// modelinewithangle_xpm
	#include "ModeEraser.xpm"	// modeeraser_xpm
	#include "ModeImage.xpm"	// modeimage_xpm
	#include "ModeBracket.xpm"	// modebracket_xpm
	#include "ZoomIn.xpm"	// zoomin_xpm
	#include "ZoomOut.xpm"	// zoomout_xpm
	#include "panel_button.xpm" // panel_button_xpm
	#include "Property.xpm"	// property_xpm


enum{
	Tool_FileNew=0,
	Tool_FileOpen,
	Tool_FileSave,
	Tool_FilePrint,
	Tool_ModeMove,
	Tool_ModeSPoint,
	Tool_ModeMLine,
	Tool_ModePara,
	Tool_ModePerp,
	Tool_ModeMid,
	Tool_ModeMCircle,
	Tool_ModeBisector,
	Tool_ModeSelect,
	Tool_ModeMeet,
	Tool_ModeGraph,
	Tool_ModeClipping,
	Tool_ModeInvisible,
	Tool_ModeAxis,
	Tool_ModeTangent,
	Tool_ModeText,
	Tool_ModeCompass,
	Tool_ModeUndo,
	Tool_ModeRedo,
	Tool_ModeOrbit,
	Tool_ModeCircleBy,
	Tool_ModeAngle,
	Tool_ModeLineWithAngle,
	Tool_ModeEraser,
	Tool_ModeImage,
	Tool_ModeBracket,
	Tool_ZoomIn,
	Tool_ZoomOut,
	Tool_Property,
	Tool_Max
};


wxBitmap *toolBarBitmap;
bool m_InitToolbar=false;

bool MyFrame::InitToolbarBMP()
{
	toolBarBitmap=new wxBitmap[Tool_Max];

	toolBarBitmap[Tool_FileNew] = wxBitmap(filenew_xpm);
	toolBarBitmap[Tool_FileOpen] = wxBitmap(fileopen_xpm);
	toolBarBitmap[Tool_FileSave] = wxBitmap(filesave_xpm);
	toolBarBitmap[Tool_FilePrint] = wxBitmap(fileprint_xpm);

	toolBarBitmap[Tool_ModeMove] = wxBitmap(modemove_xpm);
	toolBarBitmap[Tool_ModeSPoint] = wxBitmap(modespoint_xpm);
	toolBarBitmap[Tool_ModeMLine] = wxBitmap(modemline_xpm);
	toolBarBitmap[Tool_ModePara] = wxBitmap(modepara_xpm);
	toolBarBitmap[Tool_ModePerp] = wxBitmap(modeperp_xpm);
	toolBarBitmap[Tool_ModeMid] = wxBitmap(modemid_xpm);
	toolBarBitmap[Tool_ModeMCircle] = wxBitmap(modemcircle_xpm);
	toolBarBitmap[Tool_ModeBisector] = wxBitmap(modebisector_xpm);
	toolBarBitmap[Tool_ModeSelect] = wxBitmap(modeselect_xpm);
	toolBarBitmap[Tool_ModeMeet] = wxBitmap(modemeet_xpm);
	toolBarBitmap[Tool_ModeGraph] = wxBitmap(modegraph_xpm);
	toolBarBitmap[Tool_ModeClipping] = wxBitmap(modeclipping_xpm);
	toolBarBitmap[Tool_ModeInvisible] = wxBitmap(modeinvisible_xpm);
	toolBarBitmap[Tool_ModeAxis] = wxBitmap(modeaxis_xpm);
	toolBarBitmap[Tool_ModeTangent] = wxBitmap(modetangent_xpm);
	toolBarBitmap[Tool_ModeText] = wxBitmap(modetext_xpm);
	toolBarBitmap[Tool_ModeCompass] = wxBitmap(modecompass_xpm);
	toolBarBitmap[Tool_ModeUndo] = wxBitmap(modeundo_xpm);
	toolBarBitmap[Tool_ModeRedo] = wxBitmap(moderedo_xpm);
	toolBarBitmap[Tool_ModeOrbit] = wxBitmap(modeorbit_xpm);
	toolBarBitmap[Tool_ModeCircleBy] = wxBitmap(modecircleby3_xpm);
	toolBarBitmap[Tool_ModeAngle] = wxBitmap(modeangle_xpm);
	toolBarBitmap[Tool_ModeLineWithAngle] = wxBitmap(modelinewithangle_xpm);
	toolBarBitmap[Tool_ModeEraser] = wxBitmap(modeeraser_xpm);
	toolBarBitmap[Tool_ModeImage] = wxBitmap(modeimage_xpm);
	toolBarBitmap[Tool_ModeBracket] = wxBitmap(modebracket_xpm);
	toolBarBitmap[Tool_ZoomIn] = wxBitmap(zoomin_xpm);
	toolBarBitmap[Tool_ZoomOut] = wxBitmap(zoomout_xpm);
	toolBarBitmap[Tool_Property] = wxBitmap(property_xpm);
	m_canvas->PanelButton = wxBitmap(panel_button_xpm);
	m_canvas->PanelShiftOff = m_canvas->PanelButton.GetSubBitmap(wxRect(0,0,64,32));
	m_canvas->PanelAddOff = m_canvas->PanelButton.GetSubBitmap(wxRect(64,0,64,32));
	m_canvas->PanelMoveOff = m_canvas->PanelButton.GetSubBitmap(wxRect(128,0,64,32));
	m_canvas->PanelShiftOn = m_canvas->PanelButton.GetSubBitmap(wxRect(192,0,64,32));
	m_canvas->PanelAddOn = m_canvas->PanelButton.GetSubBitmap(wxRect(256,0,64,32));
	m_canvas->PanelMoveOn = m_canvas->PanelButton.GetSubBitmap(wxRect(320,0,64,32));
	return true;
}

bool MyFrame::RecreateToolbar()
{

// delete old toolbar and re-create new one
	//printf("RecreateToolbar : \n");
	wxToolBarBase *toolBar = GetToolBar();
	long style = toolBar? toolBar->GetWindowStyle() : 0;
	delete toolBar;

#ifdef __WXMSW__
	style &= ~(wxTB_HORIZONTAL | wxTB_VERTICAL | wxTB_HORZ_LAYOUT);
#else
	style &= ~(wxTB_HORIZONTAL | wxTB_VERTICAL);
#endif
 	style |= wxTB_HORIZONTAL;  // wxTB_VERTICAL;
#ifdef __WXMSW__
	style |= wxTB_TEXT;
#endif
	toolBar = CreateToolBar(style, ID_TOOLBAR);

	if(!m_InitToolbar){
		m_InitToolbar=InitToolbarBMP();
	}

	toolBar->SetToolBitmapSize(wxSize(24,24));
	// add items
	toolBar->AddTool(ID_FILE_NEW,ToolText_FileNew,toolBarBitmap[Tool_FileNew]);
	toolBar->AddTool(ID_FILE_OPEN,ToolText_FileOpen,toolBarBitmap[Tool_FileOpen]);
	toolBar->AddTool(ID_FILE_SAVE,ToolText_FileSave,toolBarBitmap[Tool_FileSave]);
	toolBar->AddTool(ID_FILE_PRINT,ToolText_FilePrint,toolBarBitmap[Tool_FilePrint]);
	toolBar->AddTool(ID_EDIT_UNDO,ToolText_ModeUndo,toolBarBitmap[Tool_ModeUndo], (const wxString&)wxT("Undo"));
	toolBar->AddTool(ID_EDIT_REDO,ToolText_ModeRedo,toolBarBitmap[Tool_ModeRedo], (const wxString&)wxT("Redo"));
	toolBar->AddTool(MODE_AXIS,ToolText_ModeAxis,toolBarBitmap[Tool_ModeAxis], (const wxString&)wxT("Add axes"),wxITEM_CHECK);
	toolBar->AddTool(MODE_ERASER,ToolText_ModeEraser,toolBarBitmap[Tool_ModeEraser], (const wxString&)wxT("Erase"));
	toolBar->AddTool(MODE_ZOOMIN,ToolText_ZoomIn,toolBarBitmap[Tool_ZoomIn], (const wxString&)wxT("ZoomIn"));
	toolBar->AddTool(MODE_ZOOMOUT,ToolText_ZoomOut,toolBarBitmap[Tool_ZoomOut], (const wxString&)wxT("ZoomOut"));
	toolBar->AddTool(ID_EDIT_PROPERTY,ToolText_Property,toolBarBitmap[Tool_Property], (const wxString&)wxT("Property"));
	toolBar->AddTool(MODE_INVISIBLE,ToolText_ModeInvisible,toolBarBitmap[Tool_ModeInvisible], (const wxString&)wxT("Invisible"));
	toolBar->Realize();
	toolBar->SetRows(1/*ToolbarRow*/);

	//printf("RecreateToolbar : make m_tbar1\n");

	if ( m_tbar1 ){
		delete m_tbar1;
		m_tbar1 = NULL;
	}
    style = GetToolBar() ? GetToolBar()->GetWindowStyle() : 0;
    style &= ~wxTB_VERTICAL;
    style |= wxTB_HORIZONTAL;

    m_tbar1 = new wxToolBar(this, wxID_ANY,
                               wxDefaultPosition, wxDefaultSize,
                               style);

    m_tbar1->SetMargins(2,2);
	m_tbar1->SetToolBitmapSize(wxSize(24,24));

	if(m_canvas->GMode==MODE_CINDY){
		m_tbar1->AddTool(MODE_SELECT,ToolText_ModeSelect,toolBarBitmap[Tool_ModeSelect], (const wxString&)wxT("Select"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_MOVE,ToolText_ModeMove,toolBarBitmap[Tool_ModeMove], (const wxString&)wxT("Move mode"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_SINGLE_ADD,ToolText_ModeSPoint,toolBarBitmap[Tool_ModeSPoint], (const wxString&)wxT("Add a point"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_MULTI_LINE,ToolText_ModeMLine,toolBarBitmap[Tool_ModeMLine], (const wxString&)wxT("Add a line"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_PARALLEL,ToolText_ModePara,toolBarBitmap[Tool_ModePara], (const wxString&)wxT("Add a parallel"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_PERP,ToolText_ModePerp,toolBarBitmap[Tool_ModePerp], (const wxString&)wxT("Add a perpendicular"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_MID,ToolText_ModeMid,toolBarBitmap[Tool_ModeMid], (const wxString&)wxT("Add a midpoint"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_MULTI_CIRCLE,ToolText_ModeMCircle,toolBarBitmap[Tool_ModeMCircle], (const wxString&)wxT("Add a circle"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_ANGLE,ToolText_ModeAngle,toolBarBitmap[Tool_ModeAngle], (const wxString&)ToolText_ModeAngle,wxITEM_RADIO);
		m_tbar1->AddTool(MODE_BRACKET,ToolText_ModeBracket,toolBarBitmap[Tool_ModeBracket], (const wxString&)ToolText_ModeBracket,wxITEM_RADIO);
		m_tbar1->AddTool(MODE_LINE_WITH_ANGLE,ToolText_ModeLineWithAngle,toolBarBitmap[Tool_ModeLineWithAngle], (const wxString&)ToolText_ModeLineWithAngle,wxITEM_RADIO);
		m_tbar1->AddTool(MODE_BISECTOR,ToolText_ModeBisector,toolBarBitmap[Tool_ModeBisector], (const wxString&)wxT("Add a bisector"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_COMPASS,ToolText_ModeCompass,toolBarBitmap[Tool_ModeCompass], (const wxString&)wxT("Compass"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_ORBIT,ToolText_ModeOrbit,toolBarBitmap[Tool_ModeOrbit], (const wxString&)wxT("Orbit"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_TEXT,ToolText_ModeText,toolBarBitmap[Tool_ModeText], (const wxString&)wxT("Text"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_IMAGE,ToolText_ModeImage,toolBarBitmap[Tool_ModeImage], (const wxString&)wxT("Image"),wxITEM_RADIO);
		m_tbar1->AddTool(MODE_TANGENT,ToolText_ModeTangent,toolBarBitmap[Tool_ModeTangent], (const wxString&)ToolText_ModeTangent,wxITEM_RADIO);
		m_tbar1->AddTool(MODE_CIRCLE_BY_3,ToolText_ModeCircleBy,toolBarBitmap[Tool_ModeCircleBy], (const wxString&)ToolText_ModeCircleBy,wxITEM_RADIO);
		m_tbar1->AddTool(MODE_CLIPPING,ToolText_ModeClipping,toolBarBitmap[Tool_ModeClipping], (const wxString&)wxT("Clip a line"),wxITEM_CHECK);
		m_tbar1->AddTool(MODE_GRAPH,ToolText_ModeGraph,toolBarBitmap[Tool_ModeGraph], (const wxString&)wxT("Graph"));
	}
	else if(m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL){
		m_tbar1->AddTool(MODE_MULTI_LINE,ToolText_ModeMLine,toolBarBitmap[Tool_ModeMLine], (const wxString&)wxT("Add a line"));
		m_tbar1->AddTool(MODE_CLIPPING,ToolText_ModeClipping,toolBarBitmap[Tool_ModeClipping], (const wxString&)wxT("Add a line"));
		m_tbar1->AddTool(MODE_MEET,ToolText_ModeMeet,toolBarBitmap[Tool_ModeMeet], (const wxString&)wxT("Add the intersection"));
		m_tbar1->AddTool(MODE_PARALLEL,ToolText_ModePara,toolBarBitmap[Tool_ModePara], (const wxString&)wxT("Add a parallel"));
		m_tbar1->AddTool(MODE_PERP,ToolText_ModePerp,toolBarBitmap[Tool_ModePerp], (const wxString&)wxT("Add a perpendicular"));
		m_tbar1->AddTool(MODE_MID,ToolText_ModeMid,toolBarBitmap[Tool_ModeMid], (const wxString&)wxT("Add a midpoint"));
		m_tbar1->AddTool(MODE_MULTI_CIRCLE,ToolText_ModeMCircle,toolBarBitmap[Tool_ModeMCircle], (const wxString&)wxT("Add a circle"));
		m_tbar1->AddTool(MODE_ANGLE,ToolText_ModeAngle,toolBarBitmap[Tool_ModeAngle], (const wxString&)ToolText_ModeAngle);
		m_tbar1->AddTool(MODE_BRACKET,ToolText_ModeBracket,toolBarBitmap[Tool_ModeBracket], (const wxString&)ToolText_ModeBracket);
		m_tbar1->AddTool(MODE_LINE_WITH_ANGLE,ToolText_ModeLineWithAngle,toolBarBitmap[Tool_ModeLineWithAngle], (const wxString&)ToolText_ModeLineWithAngle);
		m_tbar1->AddTool(MODE_BISECTOR,ToolText_ModeBisector,toolBarBitmap[Tool_ModeBisector], (const wxString&)wxT("Add a bisector"));
		m_tbar1->AddTool(MODE_TANGENT,ToolText_ModeTangent,toolBarBitmap[Tool_ModeTangent], (const wxString&)wxT("Tangent"));
		m_tbar1->AddTool(MODE_CIRCLE_BY_3,ToolText_ModeCircleBy,toolBarBitmap[Tool_ModeCircleBy], (const wxString&)ToolText_ModeCircleBy);
		m_tbar1->AddTool(MODE_ORBIT,ToolText_ModeOrbit,toolBarBitmap[Tool_ModeOrbit], (const wxString&)wxT("Orbit"));
		m_tbar1->AddTool(MODE_GRAPH,ToolText_ModeGraph,toolBarBitmap[Tool_ModeGraph], (const wxString&)wxT("Graph"));
		m_tbar1->AddTool(MODE_TEXT,ToolText_ModeText,toolBarBitmap[Tool_ModeText], (const wxString&)wxT("Text"),wxITEM_CHECK);
		m_tbar1->AddTool(MODE_IMAGE,ToolText_ModeImage,toolBarBitmap[Tool_ModeImage], (const wxString&)wxT("Image"),wxITEM_CHECK);
	}

    m_tbar1->Realize();
    m_tbar1->SetSize(0, 0,  m_canvas->windowwidth,m_canvas->m_tbar_offsety);
	enableToolbar();
	m_tbar_on=true;
	return true;
}

void MyFrame::enableToolbar()
{	
	wxToolBarBase *toolBar = GetToolBar();	
	if(m_canvas->geomperdot>0.001){
		toolBar->EnableTool(MODE_ZOOMIN,true);
	}
	else{
		toolBar->EnableTool(MODE_ZOOMIN,false);
	}
	if(m_canvas->geomperdot<0.1){
		toolBar->EnableTool(MODE_ZOOMOUT,true);
	}
	else{
		toolBar->EnableTool(MODE_ZOOMOUT,false);
	}
	if(m_canvas->GMode==MODE_CINDY && m_tbar1!=NULL){
		m_tbar1->ToggleTool(MODE_MOVE,true);
		m_tbar1->ToggleTool(MODE_SINGLE_ADD,false);
		m_tbar1->ToggleTool(MODE_MULTI_LINE,false);
		m_tbar1->ToggleTool(MODE_CLIPPING,false);
		m_tbar1->ToggleTool(MODE_MEET,false);
		m_tbar1->ToggleTool(MODE_PARALLEL,false);
		m_tbar1->ToggleTool(MODE_PERP,false);
		m_tbar1->ToggleTool(MODE_MID,false);
		m_tbar1->ToggleTool(MODE_MULTI_CIRCLE,false);
		m_tbar1->ToggleTool(MODE_BISECTOR,false);
		m_tbar1->ToggleTool(MODE_TANGENT,false);
		m_tbar1->ToggleTool(MODE_CIRCLE_BY_3,false);
		m_tbar1->ToggleTool(MODE_ORBIT,false);
		m_tbar1->ToggleTool(MODE_TEXT,false);
		m_tbar1->ToggleTool(MODE_IMAGE,false);
		m_tbar1->ToggleTool(MODE_SELECT,false);
		m_tbar1->ToggleTool(MODE_COMPASS,false);
		m_tbar1->ToggleTool(MODE_ORBIT,false);
		m_tbar1->ToggleTool(MODE_BRACKET,false);
	}
	if((m_canvas->GMode==MODE_KSEG || m_canvas->GMode==MODE_PANEL)  && m_tbar1!=NULL){
		m_tbar1->EnableTool(MODE_MULTI_LINE,false);
		m_tbar1->EnableTool(MODE_CLIPPING,false);
		m_tbar1->EnableTool(MODE_MEET,false);
		m_tbar1->EnableTool(MODE_PARALLEL,false);
		m_tbar1->EnableTool(MODE_PERP,false);
		m_tbar1->EnableTool(MODE_MID,false);
		m_tbar1->EnableTool(MODE_MULTI_CIRCLE,false);
		m_tbar1->EnableTool(MODE_BISECTOR,false);
		m_tbar1->EnableTool(MODE_TANGENT,false);
		m_tbar1->EnableTool(MODE_CIRCLE_BY_3,false);
		m_tbar1->EnableTool(MODE_ORBIT,false);
		m_tbar1->EnableTool(MODE_ANGLE,false);
		m_tbar1->EnableTool(MODE_BRACKET,false);
		m_tbar1->EnableTool(MODE_LINE_WITH_ANGLE,false);
		if(m_canvas->NOhilightedPoints==2){
			m_tbar1->EnableTool(MODE_MULTI_LINE,true);
			m_tbar1->EnableTool(MODE_CLIPPING,true);
			m_tbar1->EnableTool(MODE_MID,true);
			m_tbar1->EnableTool(MODE_MULTI_CIRCLE,true);
			m_tbar1->EnableTool(MODE_ORBIT,true);
			m_tbar1->EnableTool(MODE_BRACKET,true);
		}
		if(m_canvas->NOhilightedPoints>=1 && m_canvas->NOhilightedLines==1){
			m_tbar1->EnableTool(MODE_PARALLEL,true);
			m_tbar1->EnableTool(MODE_PERP,true);
			m_tbar1->EnableTool(MODE_MULTI_CIRCLE,true);
			m_tbar1->EnableTool(MODE_LINE_WITH_ANGLE,true);
		}
		if(m_canvas->NOhilightedPoints==3){
			m_tbar1->EnableTool(MODE_BISECTOR,true);
			m_tbar1->EnableTool(MODE_MULTI_CIRCLE,true);
			m_tbar1->EnableTool(MODE_CIRCLE_BY_3,true);
			m_tbar1->EnableTool(MODE_ANGLE,true);
		}
		if(m_canvas->NOhilightedLines>=2){
			m_tbar1->EnableTool(MODE_MEET,true);
		}
		if(m_canvas->NOhilightedPoints==1 && m_canvas->NOhilightedCircles==1){
			m_tbar1->EnableTool(MODE_TANGENT,true);
		}
		if(m_canvas->NOhilightedLines==1 && m_canvas->NOhilightedCircles==1){
			m_tbar1->EnableTool(MODE_MEET,true);
		}
		if(m_canvas->NOhilightedCircles==2){
			m_tbar1->EnableTool(MODE_MEET,true);
		}
		if(m_canvas->NOhilightedLines>=1){
			m_tbar1->EnableTool(MODE_CLIPPING,true);
		}
		if(m_canvas->NOhilightedPoints==1 && m_canvas->NOhilightedCurves==1){
			m_tbar1->EnableTool(MODE_TANGENT,true);
		}
	}
}
